#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 14 "parse.y"

#define YYDEBUG 1
#define YYERROR_VERBOSE 1
#ifndef YYSTACK_USE_ALLOCA
#define YYSTACK_USE_ALLOCA 0
#endif

#include "ruby.h"
#include "env.h"
#include "intern.h"
#include "node.h"
#include "st.h"
#include <stdio.h>
#include <errno.h>
#include <ctype.h>

#define YYMALLOC	rb_parser_malloc
#define YYREALLOC	rb_parser_realloc
#define YYCALLOC	rb_parser_calloc
#define YYFREE 	rb_parser_free
#define malloc	YYMALLOC
#define realloc	YYREALLOC
#define calloc	YYCALLOC
#define free	YYFREE
static void *rb_parser_malloc _((size_t));
static void *rb_parser_realloc _((void *, size_t));
static void *rb_parser_calloc _((size_t, size_t));
static void rb_parser_free _((void *));

#define yyparse ruby_yyparse
#define yylex ruby_yylex
#define yyerror ruby_yyerror
#define yylval ruby_yylval
#define yychar ruby_yychar
#define yydebug ruby_yydebug

#define ID_SCOPE_SHIFT 3
#define ID_SCOPE_MASK 0x07
#define ID_LOCAL    0x01
#define ID_INSTANCE 0x02
#define ID_GLOBAL   0x03
#define ID_ATTRSET  0x04
#define ID_CONST    0x05
#define ID_CLASS    0x06
#define ID_JUNK     0x07
#define ID_INTERNAL ID_JUNK

#define is_notop_id(id) ((id)>tLAST_TOKEN)
#define is_local_id(id) (is_notop_id(id)&&((id)&ID_SCOPE_MASK)==ID_LOCAL)
#define is_global_id(id) (is_notop_id(id)&&((id)&ID_SCOPE_MASK)==ID_GLOBAL)
#define is_instance_id(id) (is_notop_id(id)&&((id)&ID_SCOPE_MASK)==ID_INSTANCE)
#define is_attrset_id(id) (is_notop_id(id)&&((id)&ID_SCOPE_MASK)==ID_ATTRSET)
#define is_const_id(id) (is_notop_id(id)&&((id)&ID_SCOPE_MASK)==ID_CONST)
#define is_class_id(id) (is_notop_id(id)&&((id)&ID_SCOPE_MASK)==ID_CLASS)
#define is_junk_id(id) (is_notop_id(id)&&((id)&ID_SCOPE_MASK)==ID_JUNK)

#define is_asgn_or_id(id) ((is_notop_id(id)) && \
	(((id)&ID_SCOPE_MASK) == ID_GLOBAL || \
	 ((id)&ID_SCOPE_MASK) == ID_INSTANCE || \
	 ((id)&ID_SCOPE_MASK) == ID_CLASS))

NODE *ruby_eval_tree_begin = 0;
NODE *ruby_eval_tree = 0;

char *ruby_sourcefile;		/* current source file */
int   ruby_sourceline;		/* current line no. */

static int yylex();
static int yyerror();

static enum lex_state {
    EXPR_BEG,			/* ignore newline, +/- is a sign. */
    EXPR_END,			/* newline significant, +/- is a operator. */
    EXPR_ARG,			/* newline significant, +/- is a operator. */
    EXPR_CMDARG,		/* newline significant, +/- is a operator. */
    EXPR_ENDARG,		/* newline significant, +/- is a operator. */
    EXPR_MID,			/* newline significant, +/- is a operator. */
    EXPR_FNAME,			/* ignore newline, no reserved words. */
    EXPR_DOT,			/* right after `.' or `::', no reserved words. */
    EXPR_CLASS,			/* immediate after `class', no here document. */
} lex_state;
static NODE *lex_strterm;

#ifdef HAVE_LONG_LONG
typedef unsigned LONG_LONG stack_type;
#else
typedef unsigned long stack_type;
#endif

#define BITSTACK_PUSH(stack, n)	(stack = (stack<<1)|((n)&1))
#define BITSTACK_POP(stack)	(stack >>= 1)
#define BITSTACK_LEXPOP(stack)	(stack = (stack >> 1) | (stack & 1))
#define BITSTACK_SET_P(stack)	(stack&1)

static stack_type cond_stack = 0;
#define COND_PUSH(n)	BITSTACK_PUSH(cond_stack, n)
#define COND_POP()	BITSTACK_POP(cond_stack)
#define COND_LEXPOP()	BITSTACK_LEXPOP(cond_stack)
#define COND_P()	BITSTACK_SET_P(cond_stack)

static stack_type cmdarg_stack = 0;
#define CMDARG_PUSH(n)	BITSTACK_PUSH(cmdarg_stack, n)
#define CMDARG_POP()	BITSTACK_POP(cmdarg_stack)
#define CMDARG_LEXPOP()	BITSTACK_LEXPOP(cmdarg_stack)
#define CMDARG_P()	BITSTACK_SET_P(cmdarg_stack)

static int class_nest = 0;
static int in_single = 0;
static int in_def = 0;
static int compile_for_eval = 0;
static ID cur_mid = 0;
static int command_start = Qtrue;

static NODE *cond();
static NODE *logop();
static int cond_negative();

static NODE *newline_node();
static void fixpos();

static int value_expr0();
static void void_expr0();
static void void_stmts();
static NODE *remove_begin();
#define value_expr(node) value_expr0((node) = remove_begin(node))
#define void_expr(node) void_expr0((node) = remove_begin(node))

static NODE *block_append();
static NODE *list_append();
static NODE *list_concat();
static NODE *arg_concat();
static NODE *arg_prepend();
static NODE *literal_concat();
static NODE *new_evstr();
static NODE *evstr2dstr();
static NODE *call_op();
static int in_defined = 0;

static NODE *negate_lit();
static NODE *ret_args();
static NODE *arg_blk_pass();
static NODE *new_call();
static NODE *new_fcall();
static NODE *new_super();
static NODE *new_yield();

static NODE *gettable();
static NODE *assignable();
static NODE *aryset();
static NODE *attrset();
static void rb_backref_error();
static NODE *node_assign();

static NODE *match_gen();
static void local_push();
static void local_pop();
static int  local_append();
static int  local_cnt();
static int  local_id();
static ID  *local_tbl();
static ID   internal_id();

static struct RVarmap *dyna_push();
static void dyna_pop();
static int dyna_in_block();
static NODE *dyna_init();

static void top_local_init();
static void top_local_setup();

#define RE_OPTION_ONCE 0x80

#define NODE_STRTERM NODE_ZARRAY	/* nothing to gc */
#define NODE_HEREDOC NODE_ARRAY 	/* 1, 3 to gc */
#define SIGN_EXTEND(x,n) (((1<<(n)-1)^((x)&~(~0<<(n))))-(1<<(n)-1))
#define nd_func u1.id
#if SIZEOF_SHORT == 2
#define nd_term(node) ((signed short)(node)->u2.id)
#else
#define nd_term(node) SIGN_EXTEND((node)->u2.id, CHAR_BIT*2)
#endif
#define nd_paren(node) (char)((node)->u2.id >> CHAR_BIT*2)
#define nd_nest u3.id

/* Older versions of Yacc set YYMAXDEPTH to a very low value by default (150,
   for instance).  This is too low for Ruby to parse some files, such as
   date/format.rb, therefore bump the value up to at least Bison's default. */
#ifdef OLD_YACC
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif
#endif

#line 209 "parse.y"
typedef union {
    NODE *node;
    ID id;
    int num;
    struct RVarmap *vars;
} YYSTYPE;
#line 218 "parse.c"
#define YYERRCODE 256
#define kCLASS 257
#define kMODULE 258
#define kDEF 259
#define kUNDEF 260
#define kBEGIN 261
#define kRESCUE 262
#define kENSURE 263
#define kEND 264
#define kIF 265
#define kUNLESS 266
#define kTHEN 267
#define kELSIF 268
#define kELSE 269
#define kCASE 270
#define kWHEN 271
#define kWHILE 272
#define kUNTIL 273
#define kFOR 274
#define kBREAK 275
#define kNEXT 276
#define kREDO 277
#define kRETRY 278
#define kIN 279
#define kDO 280
#define kDO_COND 281
#define kDO_BLOCK 282
#define kRETURN 283
#define kYIELD 284
#define kSUPER 285
#define kSELF 286
#define kNIL 287
#define kTRUE 288
#define kFALSE 289
#define kAND 290
#define kOR 291
#define kNOT 292
#define kIF_MOD 293
#define kUNLESS_MOD 294
#define kWHILE_MOD 295
#define kUNTIL_MOD 296
#define kRESCUE_MOD 297
#define kALIAS 298
#define kDEFINED 299
#define klBEGIN 300
#define klEND 301
#define k__LINE__ 302
#define k__FILE__ 303
#define tIDENTIFIER 304
#define tFID 305
#define tGVAR 306
#define tIVAR 307
#define tCONSTANT 308
#define tCVAR 309
#define tINTEGER 310
#define tFLOAT 311
#define tSTRING_CONTENT 312
#define tNTH_REF 313
#define tBACK_REF 314
#define tREGEXP_END 315
#define tUPLUS 316
#define tUMINUS 317
#define tPOW 318
#define tCMP 319
#define tEQ 320
#define tEQQ 321
#define tNEQ 322
#define tGEQ 323
#define tLEQ 324
#define tANDOP 325
#define tOROP 326
#define tMATCH 327
#define tNMATCH 328
#define tDOT2 329
#define tDOT3 330
#define tAREF 331
#define tASET 332
#define tLSHFT 333
#define tRSHFT 334
#define tCOLON2 335
#define tCOLON3 336
#define tOP_ASGN 337
#define tASSOC 338
#define tLPAREN 339
#define tLPAREN_ARG 340
#define tRPAREN 341
#define tLBRACK 342
#define tLBRACE 343
#define tLBRACE_ARG 344
#define tSTAR 345
#define tAMPER 346
#define tSYMBEG 347
#define tSTRING_BEG 348
#define tXSTRING_BEG 349
#define tREGEXP_BEG 350
#define tWORDS_BEG 351
#define tQWORDS_BEG 352
#define tSTRING_DBEG 353
#define tSTRING_DVAR 354
#define tSTRING_END 355
#define tLOWEST 356
#define tUMINUS_NUM 357
#define tLAST_TOKEN 358
const short yylhs[] = {                                        -1,
   96,    0,   19,   20,   21,   21,   21,   21,   99,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   22,  100,
   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
   22,   22,   22,   22,   23,   23,   23,   23,   23,   23,
   29,   27,   27,   27,   27,   27,   56,   56,   56,  101,
  102,   73,   26,   26,   26,   26,   26,   26,   26,   26,
   78,   78,   81,   81,   80,   80,   80,   80,   80,   80,
   82,   82,   79,   79,   83,   83,   83,   83,   83,   83,
   83,   83,   75,   75,   75,   75,   75,   75,   75,   75,
   91,   91,   18,   18,   18,   92,   92,   92,   92,   92,
   84,   84,   77,   77,   67,  104,   67,   93,   93,   93,
   93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
   93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
   93,   93,   93,  103,  103,  103,  103,  103,  103,  103,
  103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
  103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
  103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
  103,  103,  103,   24,   24,   24,   24,   24,   24,   24,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
   24,   24,   24,   24,  106,   24,   24,   24,   30,   48,
   48,   48,   48,   48,   48,   45,   45,   45,   45,   46,
   46,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,  108,   47,   44,  109,   44,  110,   44,   50,
   49,   49,   40,   40,   53,   53,   53,   25,   25,   25,
   25,   25,   25,   25,   25,   25,  111,   25,  112,   25,
   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
  113,   25,   25,   25,   25,   25,   25,  115,  117,   25,
  118,  119,   25,   25,   25,   25,  120,  121,   25,  122,
   25,  124,  125,   25,  126,   25,  127,   25,  129,  130,
   25,   25,   25,   25,   25,   31,  114,  114,  114,  114,
  116,  116,  116,   32,   32,   33,   33,   70,   70,   71,
   71,   71,   71,  131,  132,   74,   55,   55,   55,   28,
   28,   28,   28,   28,   28,  133,  134,   72,  135,  136,
   72,   34,   41,   41,   41,   35,   35,   36,   36,   37,
   37,   37,   38,   38,   39,   39,   15,   15,   15,    2,
    3,    3,    4,    5,    6,   10,   10,   12,   12,   14,
   14,   11,   11,   13,   13,    7,    7,    8,    8,    9,
  137,    9,  138,    9,   69,   69,   69,   69,   87,   86,
   86,   86,   86,   17,   16,   16,   16,   16,   85,   85,
   85,   85,   85,   85,   85,   85,   85,   85,   85,   51,
   52,   68,   68,   54,  139,   54,   54,   57,   57,   58,
   58,   58,   58,   58,   58,   58,   58,   58,   94,   94,
   94,   94,   94,   95,   95,   60,   59,   59,  140,  140,
   61,   61,  141,  141,   62,   63,   63,    1,  142,    1,
   64,   64,   64,   65,   65,   66,   88,   88,   88,   89,
   89,   89,   89,   90,   90,   90,  128,  128,   97,   97,
  105,  105,  107,  107,  107,  123,  123,   98,   98,   76,
};
const short yylen[] = {                                         2,
    0,    2,    4,    2,    1,    1,    3,    2,    0,    4,
    3,    3,    3,    2,    3,    3,    3,    3,    3,    0,
    5,    4,    3,    3,    3,    6,    5,    5,    5,    3,
    3,    3,    3,    1,    1,    3,    3,    2,    2,    1,
    1,    1,    1,    2,    2,    2,    1,    4,    4,    0,
    0,    6,    2,    3,    4,    5,    4,    5,    2,    2,
    1,    3,    1,    3,    1,    2,    3,    2,    2,    1,
    1,    3,    2,    3,    1,    4,    3,    3,    3,    3,
    2,    1,    1,    4,    3,    3,    3,    3,    2,    1,
    1,    1,    2,    1,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    4,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    3,    5,    3,    6,    5,    5,    5,
    5,    4,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    4,    4,    2,    2,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    2,    2,
    3,    3,    3,    3,    0,    4,    5,    1,    1,    1,
    2,    2,    5,    2,    3,    3,    4,    4,    6,    1,
    1,    1,    2,    5,    2,    5,    4,    7,    3,    1,
    4,    3,    5,    7,    2,    5,    4,    6,    7,    9,
    3,    1,    0,    2,    1,    0,    3,    0,    4,    2,
    2,    1,    1,    3,    3,    4,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    0,    4,    0,    5,
    3,    3,    2,    4,    3,    3,    1,    4,    3,    1,
    0,    6,    2,    1,    2,    6,    6,    0,    0,    7,
    0,    0,    7,    5,    4,    5,    0,    0,    9,    0,
    6,    0,    0,    8,    0,    5,    0,    6,    0,    0,
    9,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    1,    1,    1,    1,    5,    1,    2,    1,    1,    1,
    2,    1,    3,    0,    0,    6,    2,    4,    4,    2,
    4,    4,    3,    2,    1,    0,    0,    6,    0,    0,
    6,    5,    1,    4,    2,    1,    1,    6,    1,    1,
    1,    1,    2,    1,    2,    1,    1,    1,    1,    1,
    1,    2,    3,    3,    3,    3,    3,    0,    3,    1,
    2,    3,    3,    0,    3,    0,    2,    0,    2,    1,
    0,    3,    0,    4,    1,    1,    1,    1,    2,    1,
    1,    1,    1,    3,    1,    1,    2,    2,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    0,    4,    2,    4,    2,    6,
    4,    4,    2,    4,    2,    2,    1,    0,    1,    1,
    1,    1,    1,    1,    3,    3,    1,    3,    1,    1,
    2,    1,    1,    1,    2,    2,    1,    1,    0,    5,
    1,    2,    2,    1,    3,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,
    0,    1,    0,    1,    1,    1,    1,    1,    2,    0,
};
const short yydefred[] = {                                      1,
    0,    0,    0,    0,    0,    0,    0,  277,    0,    0,
    0,  298,  301,    0,    0,    0,  324,  325,    0,    0,
    0,  425,  424,  426,  427,    0,    0,    0,   20,    0,
  429,  428,    0,    0,  421,  420,    0,  423,  415,  416,
  432,  433,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  396,  398,  398,    0,    0,    0,    0,    0,  269,
    0,  381,  270,  271,  272,  273,  268,  377,  379,    2,
    0,    0,    0,    0,    0,    0,   35,    0,    0,  274,
    0,    0,   43,    0,    0,    5,    0,    0,   61,    0,
   71,    0,  378,    0,    0,  322,  323,  287,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  326,    0,
  275,  430,    0,   94,  315,  143,  154,  144,  167,  140,
  160,  150,  149,  170,  171,  165,  148,  147,  142,  168,
  172,  173,  152,  141,  155,  159,  161,  153,  146,  162,
  169,  164,    0,    0,    0,    0,  139,  158,  157,  138,
  145,  136,  137,    0,    0,    0,   98,    0,  129,  130,
  127,  111,  112,  113,  116,  118,  114,  131,  132,  119,
  120,  124,  115,  117,  108,  109,  110,  121,  122,  123,
  125,  126,  128,  133,  469,    0,  468,  317,   99,  100,
  163,  156,  166,  151,  134,  135,   96,   97,  104,    0,
  105,  103,  102,  101,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  497,  496,    0,    0,    0,  498,
    0,    0,    0,    0,    0,    0,  338,  339,    0,    0,
    0,    0,    0,  232,    0,    0,   45,  240,    0,  474,
   46,   44,    0,   60,    0,    0,  354,   59,   38,    0,
    9,  492,    0,    0,    0,  194,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  220,
    0,    0,    0,  471,    0,    0,    0,   69,    0,  412,
  411,  413,    0,  409,  410,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  209,   39,  210,  382,    4,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  344,  347,  359,  356,  295,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   73,  350,    0,  293,    0,    0,   91,    0,   93,  417,
  418,    0,  435,  310,  434,    0,    0,    0,    0,    0,
  488,  487,  319,    0,  106,    0,    0,    0,  329,  328,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  499,    0,    0,    0,    0,    0,    0,
  307,    0,  260,    0,    0,  233,  262,    0,  235,  289,
    0,    0,  255,  254,    0,    0,    0,    0,    0,   11,
   13,   12,    0,  291,    0,    0,    0,    0,    0,    0,
    0,  281,    0,    0,    0,  221,    0,  494,  222,  285,
    0,  224,    0,  473,  286,  472,    0,    0,    0,    0,
  400,  403,  401,  414,  399,  383,  397,  384,  385,  386,
  387,  390,    0,  392,    0,  393,    0,    0,    0,   15,
   16,   17,   18,   19,   36,   37,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  353,
    0,    0,    0,  482,    0,    0,  483,    0,   25,  480,
  481,    0,    0,    0,   30,    0,    0,   23,  263,    0,
   31,   24,    0,   33,    0,   67,   74,   50,   54,    0,
  437,    0,    0,    0,    0,    0,   95,    0,    0,    0,
    0,    0,    0,  451,  450,  449,  452,  460,  464,  463,
  459,    0,    0,    0,    0,  457,    0,  447,  454,    0,
    0,    0,    0,  278,    0,    0,  369,    0,  330,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  305,  333,  332,  299,  331,  302,    0,    0,    0,
    0,    0,    0,    0,  239,  476,    0,    0,  261,    0,
    0,    0,  475,  288,    0,    0,    0,  258,  252,    0,
    0,    0,    0,    0,    0,    0,  226,   10,    0,    0,
    0,   22,    0,    0,    0,  225,    0,  264,    0,    0,
    0,    0,    0,    0,    0,  389,  391,  395,    0,    0,
    0,  342,    0,  345,  340,  360,  357,    0,    0,  352,
    0,    0,    0,    0,  231,  351,    0,  230,  349,   49,
  348,   48,  267,    0,    0,   72,    0,  313,    0,    0,
  284,  316,    0,  320,    0,    0,    0,  439,    0,  445,
  467,    0,  446,    0,  443,  461,  465,  107,    0,    0,
  371,  372,    0,    0,  336,    0,    0,  334,    0,    0,
    0,    0,    0,  304,  306,  365,    0,    0,    0,    0,
    0,    0,    0,    0,  237,    0,    0,    0,    0,    0,
  245,  257,    0,    0,  227,    0,    0,  228,    0,   21,
  280,    0,    0,    0,  405,  406,  407,  408,  402,    0,
  341,    0,    0,    0,    0,    0,   29,    0,   58,    0,
    0,   27,    0,   28,   56,    0,    0,    0,   51,    0,
  436,  311,  470,    0,  456,    0,  318,    0,  458,    0,
  466,    0,    0,  455,    0,    0,  374,  337,    0,    3,
  376,    0,  296,    0,  297,    0,    0,    0,    0,  308,
  234,    0,  236,  251,    0,    0,  242,    0,  259,    0,
    0,  292,  223,  404,  343,    0,    0,    0,    0,   26,
  266,    0,    0,    0,  438,  444,    0,  441,  442,    0,
    0,    0,  373,    0,    0,  375,    0,  364,  366,  367,
  362,  300,  303,    0,    0,    0,    0,  241,    0,  247,
    0,  229,  346,  361,  358,    0,  314,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  238,  243,    0,    0,
    0,  246,   52,  321,  440,    0,    0,    0,    0,    0,
  368,  335,  309,    0,    0,  248,    0,    0,  244,    0,
  249,    0,  250,
};
const short yydgoto[] = {                                       1,
  186,   60,   61,   62,   63,   64,  286,  283,  455,   65,
   66,  290,  292,  463,   67,   68,   69,  108,  376,  377,
   71,   72,   73,   74,   75,   76,   77,   78,  208,  235,
  257,  707,  708,  393,  841,  576,  700,  786,  790,  267,
  591,  237,  618,  414,  665,  666,  244,  268,  406,  609,
   80,  210,  531,  364,   82,   83,  563,  564,  565,  566,
  567,  781,  690,  272,  269,  240,  200,  211,  749,  226,
  654,  354,  539,  335,  212,   86,  201,   87,   88,   89,
  263,   90,   91,  202,  213,  284,   93,  113,  546,  510,
  114,  204,  517,  569,  570,    2,  218,  219,  423,  254,
  677,  822,  190,  573,  253,  425,  439,  245,  621,  729,
  205,  434,  629,  381,  221,  595,  719,  222,  720,  603,
  844,  543,  382,  540,  770,  369,  374,  373,  552,  774,
  503,  753,  505,  755,  504,  754,  645,  644,  542,  571,
  572,  370,
};
const short yysindex[] = {                                      0,
    0, 5269,14030,17150,18791,17262,16963,    0,15521,15521,
 6946,    0,    0,18442,14357,14357,    0,    0,14357,  111,
  124,    0,    0,    0,    0,15521,16872,   28,    0,   46,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,16394,16394, -211,13709,15521,15618,16394,18888,
17352,    0,    0,    0,  161,  197, -102,16491,16394,    0,
  -87,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  115,  786,  225,14031,    0,  -11,    0,  -53,    9,    0,
  -62,   40,    0,  -55,  230,    0,  267,18694,    0,  294,
    0,    0,    0,   98,  786,    0,    0,    0,  111,  124,
   28,    0,    0,15521, -151, 5269,  240,  210,    0,   19,
    0,    0,   98,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  110,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  304,
    0,    0,    0,    0, 5269,   55,  225,  103,   48,   39,
   51,  331,    0,  103,    0,    0,  115, -163,  352,    0,
15521,15521,  142,   61,    0,  181,    0,    0,    0,16394,
16394,16394,14031,    0,  125,  435,    0,    0,  460,    0,
    0,    0,14159,    0,14454,14357,    0,    0,    0,  333,
    0,    0,  467,  389, 5269,    0,   63,  199,  190,13709,
  482,    0,  484,  225,16394,   28,  278,  443,  495,    0,
  500,  415,  495,    0,  249,  112,    0,    0,    0,    0,
    0,    0,  338,    0,    0,  471,  533,  420,  206,  540,
  209, -207,  258,  261,    0,    0,    0,    0,    0,13929,
15521,15521,15521,15521,14030,15521,15521,16394,16394,16394,
16394,16394,16394,16394,16394,16394,16394,16394,16394,16394,
16394,16394,16394,16394,16394,16394,16394,16394,16394,16394,
16394,16394,16394,    0,    0,    0,    0,    0,17682,15618,
17720,16491,17751,17751,16491,15715,15715,13709,18888,  550,
    0,    0,  255,    0,  467,  225,    0,    0,    0,    0,
    0,  115,    0,    0,    0,18050,15618,17751, 5269,15521,
    0,    0,    0,  683,    0,  339,  348,  190,    0,    0,
 5269,  346,18081,15618,18119,16394,16394,16394, 5269,  360,
 5269,15812,  370,    0,  441,  441,    0,18150,15618,18188,
    0,  593,    0,16394,14551,    0,    0,14648,    0,    0,
  604,14260,    0,    0,  -11,  620,   28,  104,  631,    0,
    0,    0,16963,    0,16394, 5269,  556,18081,18119,16394,
  634,    0,    0,   28, 5941,    0,15909,    0,    0,    0,
16394,    0,16394,    0,    0,    0,    0,18219,15618,18518,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   52,    0,  652,    0,16394,16394,  786,    0,
    0,    0,    0,    0,    0,    0,  199, 7786, 7786, 7786,
 7786,  640,  640, 8830, 8345, 7786, 7786, 7860, 7860,  433,
  433, 9044,  640,  640,  138,  138,  699,   43,   43,  199,
  199,  199,  -48,  -48,  -48,  349,    0,  358,  124,    0,
    0,  605,  364,    0,  366,  124,    0,14031,    0,    0,
    0,  124,  124,14031,    0,16394,18616,    0,    0,  664,
    0,    0,    0,    0,  692,    0,    0,    0,    0,  115,
    0,15521, 5269,    0,    0,  124,    0,  645,  124,  476,
   56,17651,  666,    0,    0,    0,    0,    0,    0,    0,
    0,  769, 5269,  115,  703,    0,  711,    0,    0,  724,
  466,  474,16963,    0,16006,  511,    0,  372,    0,  451,
  358,  700,  459,  473,18616,  511,  536,  552,16394,  777,
  103,    0,    0,    0,    0,    0,    0,    0,    0,  730,
    0,    0,15521,  483,    0,    0,16394,  125,    0,  787,
16394,  125,    0,    0,16394,14031,   13,    0,    0,  793,
  805,14745,  810,17751,17751,  818,    0,    0,15521,14031,
  736,    0,14031,    0,  822,    0,16394,    0,    0,    0,
  775,    0,    0, 5269,  570,    0,    0,    0,  199,  199,
16394,    0,16761,    0,    0,    0,    0,16491,16394,    0,
  255,  529,16491,16491,    0,    0,  255,    0,    0,    0,
    0,    0,    0,16394,16103,    0,  -48,    0,  115,  607,
    0,    0,  840,    0,16394,   28,  621,    0,  220,    0,
    0,    7,    0,  769,    0,    0,    0,    0,    0,  531,
    0,    0, 5269,  627,    0,15521,  635,    0,16394,  554,
16394,16394,  647,    0,    0,    0,16200, 5269, 5269, 5269,
    0,  441,  593,14842,    0,  593,  593,14939,  862,15036,
    0,    0,  -11,  104,    0,  124,  124,    0,   91,    0,
    0, 5941,    0,  789,    0,    0,    0,    0,    0,14031,
    0,  791, 5269, 5269, 5269,14031,    0,14031,    0,16491,
14031,    0,14031,    0,    0,14031,16394,    0,    0, 5269,
    0,    0,    0,  683,    0,  875,    0,  666,    0,  711,
    0,  876,  711,    0,18985,  103,    0,    0, 5269,    0,
    0,  103,    0,16394,    0,16394,   18,  660,  661,    0,
    0,16394,    0,    0,16394,  879,    0,  883,    0,16394,
  887,    0,    0,    0,    0,  665,  671,  811,14031,    0,
    0, 5269,  673, 5269,    0,    0,  220,    0,    0,  637,
  120,    0,    0,    0, 5269,    0, 5269,    0,    0,    0,
    0,    0,    0, 5269,13713,  593,15133,    0,15230,    0,
  593,    0,    0,    0,    0,  823,    0,  689,  711,    0,
18549,15618,18587,  348,  372,  690,    0,    0,16394,  903,
16394,    0,    0,    0,    0,    0,    0,  864,    0,    0,
    0,    0,    0,  593,15327,    0,  593,    0,    0,16394,
    0,  593,    0,
};
const short yyrindex[] = {                                      0,
    0,  133,    0,    0,    0,    0,    0,    0,    0,    0,
  188,    0,    0,    0,12919,13004,    0,    0,13100, 4510,
 3751,    0,    0,    0,    0,    0,    0,16297,    0,    0,
    0,    0, 2039, 3226,    0,    0, 2370,    0,    0,    0,
    0,    0,    0,    0,    0,  214,    0,  866,  830,  477,
  589,    0,    0,    0,  686, -188,    0,    0,    0,    0,
 8232,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2002, 1025, 6054, 7167, 8317, 9533,    0, 8413,    0,    0,
    0,12812,    0,13475,    0,    0,    0,  543,    0,    0,
    0,13399,    0,15424, 1389,    0,    0,    0, 8717, 7264,
  923, 5783, 5885,    0,    0,  214,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  892,  996, 1132, 1183,    0,    0,    0,    0,
    0,    0,    0, 1492, 1684, 1862,    0, 2137,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 7368,
    0,    0,    0,    0,  579,    0,13111,    0,    0,    0,
 7747,    0, 7353,    0,    0,    0,  693,    0,  198,    0,
    0,    0,    0,    0,  195,    0,    0,    0,  774,    0,
    0,    0,  921,    0, 1715, 8047,    0,    0, 8047,    0,
    0,    0,    0,    0,    0,  919,    0,    0,    0,    0,
    0,    0,16588,    0,  101,    0,    0, 9202,13549,  214,
    0,   86,    0,  316,    0,  874,  877,    0,  877,    0,
  843,    0,  843,    0,    0,    0,  670,    0, 1319,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 8802, 8898,    0,    0,    0,    0,    0, 2013,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  866,
    0,    0,    0,    0,    0,    0,    0,  214,  638,  639,
    0,    0, 6156,    0,    0,  184,    0, 6534,    0,    0,
    0,    0,    0,    0,    0,    0,  866,    0,  579,    0,
    0,    0,    0,  189,    0,    0,  528, 7832,    0,    0,
  213, 6406,    0,  866,    0,    0,    0,    0,  455,    0,
   78,    0,    0,    0,    0,    0,  809,    0,  866,    0,
    0, 8047,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  928,    0,    0,  527,  539,  931,  931,    0,    0,
    0,    0,    0,    0,    0,  101,    0,    0,    0,    0,
    0,    0,  497,  931,  874,    0,  888,    0,    0,    0,
   89,    0,  857,    0,    0,    0, 1871,    0,  866,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 4749,    0,
    0,    0,    0,    0,    0,    0, 9287,11111,11200,11290,
11384,10744,10838,11473,11746,11563,11657,11836,11872,10260,
10349,    0,10927,11017,10565,10654,10439,10045,10134, 9382,
 9624, 9713, 6726, 6726, 6839, 4607, 3323, 5366,15424,    0,
 3654,    0, 4938,    0, 5035, 4082,    0,11932,    0,    0,
    0, 5463, 5463,12019,    0,    0, 9589,    0,    0,    0,
    0,    0, 1517,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  579, 6198, 6300,    0,    0,    0, 7443,    0,
  931,    0,  561,    0,    0,    0,    0,    0,    0,    0,
    0,  542,  579,    0,  214,    0,  214,    0,    0,  214,
  583,    0,    0,    0,   62,  425,    0,  733,    0, 2467,
 4179,    0, 2798, 2895,12659,  733,    0,    0,    0,  113,
    0,    0,    0,    0,    0,    0,    0, 1513,  773,    0,
 1544, 2171,    0,    0,    0,    0,    0, 6644,    0, 8047,
    0,    0,    0,    0,    0,   30,    0,    0,    0,  919,
    0,    0,    0,    0,    0,    0,    0,    0,    0,12079,
    0,    0,12147,  716,    0,    0,    0,    0, 1924, 1003,
    0, 5743, 5829,  101,    0,    0,    0,    0, 9803, 9955,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 8532,13848,    0,    0,    0,    0, 9017,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 6839,    0,    0,    0,
    0,    0,    0,    0,    0,  931,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   57,  571,
    0,    0,  139,  733,    0,    0,    0,    0,    0, 7928,
    0,    0,    0,    0,    0,    0,    0,  609,   78,   78,
  828,    0, 8047,    0,    0, 8047,  919,    0,    0,    0,
    0,    0,    0,  931,    0,   85,   85,    0,    0,    0,
    0,  874, 1913,    0,    0,    0,    0,    0,    0,12202,
    0,    0,   78,   78,  101,12263,    0,12354,    0,    0,
12445,    0,12506,    0,    0,12561,    0, 1587,    0,  579,
    0,    0,    0,  189,    0,    0,    0,    0,    0,  214,
    0,  214,  214,    0,    0,    0,    0,    0,   78,    0,
    0,    0,    0,    0,    0,    0,  733,    0,    0,    0,
    0,    0,    0,    0,    0,  919,    0,  919,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,12598,    0,
    0,  101,    0,  579,    0,    0,    0,    0,    0,    0,
    0,  160,    0,  194,  579,    0,  213,    0,    0,    0,
    0,    0,    0,   78, 8047,  919,    0,    0,    0,    0,
  919,    0,    0,    0,    0,    0,    0,    0,  214,  615,
    0,  866,    0,  528,  733,    0,    0,    0,    0,  919,
    0,    0,    0,    0,    0,  119,   82,    0,  463,  532,
    0,    0,    0,  919,    0,    0,  919,  659,    0,    0,
    0,  919,    0,
};
const short yygindex[] = {                                      0,
    0,    0,    0,  927,    0,    0,    0,  731, -203,    0,
    0,    0,    0,    0,    0,    0,   35,  995, -356,  920,
    0,   60,  606,  -15,    1,   34,   -6,    0,  134, 1341,
  186,  144, -530, -376,    0,  140,    0,    0,    0,   20,
    0,  590,    0,    0,   -1,  -74,   -3, -303, -180,   -8,
 1001, 1406, -316,    0, -237,    0,  238,  453,  319, -648,
 -559, -349, -286,    0,   11, -387,    0,  981,    0,  367,
 -401,  941, -525,    0, 1350,  757,  -10,   -2,    0,  -14,
 -162,  934,  -26,    0, 1116,    0,   41,  756, -266,    0,
  -83,   10,   -4,  330,    0,    0,    8,  966,    0,    0,
    0,    0,    0,    0,   67,    0,  -24,    0,    0,    0,
    0,    0,    0, -204,    0, -377,    0,    0,    0,    0,
    0,    0,   47,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,
};
#define YYTABLESIZE 19342
const short yytable[] = {                                     233,
  233,  189,  189,  233,  109,  109,  238,  238,  418,  389,
  238,  228,  550,  587,  109,  188,  251,  248,  597,  247,
  613,  359,  189,  278,  568,  239,  239,  256,  258,  239,
  534,  262,  233,  233,  236,  236,  512,  252,  236,   40,
  779,  199,  295,  297,  560,  704,  189,  203,  234,  234,
  109,  296,  234,  613,  341,  713,  728,  220,  409,  273,
  285,  199,   95,  548,  368,  252,  370,  203,  271,  337,
   40,  500,  509,  219,  516,  653,  522,  523,  299,  333,
  582,  266,  457,  646,  331,  344,  462,  500,  109,  332,
  353,   88,  352,  385,  500,  600,  259,  431,  247,  340,
  263,  549,  656,  657,  465,  391,  400,  392,  429,  367,
  500,  352,  215,  252,  370,  370,  509,  220,  516,  500,
  500,  481,  363,  394,  215,  500,   63,  282,   86,  780,
  500,  812,  500,  549,  783,  759,  500,  246,  384,   88,
   88,  765,  500,  214,  217,  641,   61,  466,  500,  625,
  243,  399,  357,  384,  365,  372,  358,  450,  480,  500,
  380,  216,  549,  246,  484,  863,  394,  355,  255,   90,
  363,  363,  282,  216,  333,  328,   86,   86,  779,  331,
  329,  495,  330,  549,  332,  535,  680,   79,   79,  110,
  110,  500,  289,  312,  209,  209,  209,  500,  448,  224,
  209,  209,  449,   83,  209,  275,  687,  293,  294,  484,
  862,  209,  568,  495,  233,  233,  295,   90,   90,  215,
  337,  605,  500,  500,  390,  500,  336,  233,  291,  233,
  233,   79,  209,  209,  238,  276,  238,  238,   82,  430,
  275,  484,  312,  209,  442,  262,  444,  448,  446,  435,
  275,   83,   83,  239,  500,  239,  239,  560,  701,  647,
   52,  561,  236,  220,  236,  416,  839,  859,  216,  363,
  334,  500,  500,  276,  342,  769,  234,  652,  234,  415,
  693,  345,  547,  695,  430,  275,  703,  438,  392,  209,
  346,   79,  477,  478,  479,  480,  481,  482,  483,  484,
  485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
  495,  496,  497,  498,  499,  500,  501,  502,   90,   40,
   40,  437,  536,  370,  233,  279,  518,  347,  500,  524,
  527,  233,  436,  262,  511,  519,  613,  351,  525,  528,
  532,  500,  613,  339,  800,  306,  307,  375,   88,  109,
  404,  233,  559,  366,  395,  396,  279,  736,  737,  469,
  308,  511,  378,  451,  474,  530,  530,  219,  233,  379,
  518,  524,  585,  266,  343,  386,  233,  336,  511,  363,
  306,  307,  383,  233,  734,   86,  718,  387,  233,  233,
   79,  388,  233,  511,  370,  398,  616,  428,  484,  500,
  266,  500,  500,  619,  452,  453,  209,  209,  541,  630,
  394,  590,  628,  823,  633,  610,  282,  266,  189,  500,
  840,  233,  620,  511,  568,  233,   90,  233,  209,  725,
  209,  209,  266,  233,  470,  471,  472,  473,  624,  731,
   79,  596,  596,  511,  371,   79,  448,  669,  671,  397,
  215,  649,  650,  484,  861,  308,  489,  199,  489,  401,
   83,  613,  404,  203,  500,  362,  490,  858,  490,  333,
  321,  322,   85,   90,  331,  329,  500,  330,  405,  332,
  500,  500,  266,  623,  626,   79,  209,  209,  209,  209,
   79,  209,  209,  826,  275,  828,  829,  613,  594,  216,
  635,  636,  480,  408,  438,  661,  424,  660,  480,  438,
  233,  426,  667,  500,  306,  307,  308,   70,  670,  672,
   85,   85,  432,  778,  433,  209,  430,  209,  430,  275,
  209,  209,  209,   79,  276,  440,  232,   70,  441,  445,
   72,   87,  801,  443,  660,  803,  804,  189,  500,  360,
  361,  448,  209,  480,   79,  209,  447,   62,  878,  233,
  460,  684,  698,  464,  558,  559,   79,  232,  189,  209,
  453,  481,  875,  233,   79,  467,   79,  481,  468,  500,
  500,  835,  448,   65,  209,  480,  678,  837,  500,   87,
   87,  233,  462,  537,  530,  233,  549,  209,  538,  233,
   70,  453,  574,   65,  453,  241,  233,  199,  242,  575,
  688,   79,  579,  203,  207,  207,  207,  683,  500,  453,
   62,  742,  481,  462,   89,  848,  462,  850,  500,  500,
  392,  249,  610,  592,  209,  750,  604,  500,  420,  706,
  703,  462,  756,  758,  614,  421,  422,  761,  763,  451,
  228,  757,  264,  109,  481,  733,  762,  764,  766,  233,
  283,  669,  671,  622,  867,  868,   65,  500,   84,  233,
  872,  627,   89,   89,  634,  679,  333,  328,   68,   66,
  632,  331,  329,  648,  330,  658,  332,  500,  500,  886,
  452,  453,  454,  756,  659,  761,  763,  662,   68,   66,
  663,  233,  664,  889,  284,  283,  891,  675,  233,  356,
   82,  893,  233,   82,  233,  275,   84,   84,  500,  807,
  560,  593,  562,  500,  561,  771,  685,  209,   79,   85,
   82,  451,  676,  327,  459,  333,  722,  681,  808,  682,
  331,  329,  480,  330,  819,  332,  689,  806,   79,  284,
  308,  233,  776,  820,  692,   70,   64,   94,   94,   72,
  275,   68,   66,  326,   94,   94,   94,  694,  596,  696,
   94,   94,  452,  453,   94,   62,   62,  697,  819,  703,
  233,   94,  451,  287,  288,  109,  845,  709,  209,  233,
  500,  500,  710,   82,  233,  711,  500,  480,   87,  714,
  811,   94,   94,   94,  270,  274,  560,  209,  813,  712,
  561,  481,  481,   94,  209,  715,   80,   75,  282,  430,
  717,   65,  721,  452,  453,  456,  207,  207,  231,   79,
  724,  233,  411,  233,  413,  417,  730,  500,  224,  792,
  500,  500,  500,  209,  451,  732,  233,  500,  209,  209,
  735,  451,   81,  233,  283,  233,  511,  870,  738,   94,
  740,   94,  741,  282,  430,  760,  481,  743,  785,  233,
  772,   76,  500,  284,  233,  745,  746,  500,  747,  500,
  773,   89,   41,   42,  777,  452,  453,  458,   79,  789,
  794,  209,  452,  453,  461,  266,   88,   83,  793,  283,
  398,  163,  809,   79,   79,   79,  207,  207,  207,  207,
  795,  475,  476,  814,  815,  825,   68,   66,  284,  827,
  219,   70,  847,  842,  843,   84,  849,  852,  853,  163,
  219,  163,   89,  163,  854,  855,  857,  425,   79,   79,
   79,  398,  398,  398,  860,  209,  885,  873,   82,  283,
  163,   84,  874,  883,  500,   79,  888,  308,  500,  500,
   94,  219,  491,  489,  219,  261,  491,  493,  256,  493,
  831,  491,  321,  322,   79,  551,   94,   94,  219,  219,
  495,  495,   84,   84,  111,  111,  553,  298,  554,  555,
  556,  557,  407,  284,  225,  407,  500,  388,   94,  115,
   94,   94,  419,  881,  275,  156,  187,   79,  882,   79,
   94,  824,  782,  219,  686,   94,  308,  264,  338,  752,
   79,  350,   79,  784,    6,  261,   84,  558,  559,   79,
  277,  321,  322,  156,    6,  156,  300,  156,  388,  388,
  388,  424,  481,   80,    0,  219,   80,  209,  282,    0,
    0,   88,   83,    0,  156,   94,   94,   94,   94,   94,
   94,   94,   94,   80,    0,    6,    0,    0,  277,    0,
    0,    0,  553,    0,  554,  555,  556,  557,  301,  302,
  303,  304,  305,    6,    0,    0,   84,   89,    0,    0,
    0,    0,    0,  282,    0,   94,  270,   94,    0,    0,
   94,   94,   94,   94,    0,    0,   84,  282,  430,    0,
    0,    0,    0,  558,  559,    0,    0,   92,   92,  112,
  112,  112,   94,  270,   94,   94,   80,    0,    0,  229,
    0,    0,    0,  577,    0,    0,   94,    0,    0,   94,
  270,  166,    0,  283,   94,    0,   94,  207,    0,    6,
    0,    0,    0,    0,   94,  270,    0,    0,  407,    0,
    0,   92,  284,    0,    0,  279,    0,   94,    0,  166,
    0,  166,  407,  166,  427,    0,    0,  426,    0,  261,
    0,   94,  219,  219,  219,   84,    0,  219,  219,  219,
  166,  219,  151,    0,    0,  163,    0,  163,  163,  163,
  163,  219,  219,  279,   94,  270,    0,    0,  207,    0,
  219,  219,    0,  219,  219,  219,  219,  219,    0,    0,
  151,   92,  151,    0,  151,    0,  425,    0,  427,    0,
    0,    0,    0,    0,  739,   84,  163,  163,    0,    0,
   84,  151,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  219,  655,
  655,  655,    0,    0,  219,    0,    0,  261,    0,    0,
    0,    0,  668,    0,    0,    0,    0,    0,  668,  668,
   84,   80,    0,    0,    0,   84,    6,    6,    6,    0,
    0,    0,    6,    6,    0,    6,    0,   94,   94,  156,
  578,  156,  156,  156,  156,  668,    0,    0,  586,    0,
  588,  207,    0,    0,    0,    0,    0,    0,   94,    0,
   92,  691,    0,  691,    0,    0,  691,    0,   84,  277,
  424,  702,  705,    0,  705,    0,    0,  282,    0,    0,
  156,  156,  705,    0,    0,  631,    0,    0,    0,   84,
    0,   85,   85,    0,    0,    0,    0,    0,   94,   75,
    0,   84,   75,  227,  430,    0,  407,    0,    0,   84,
   92,   84,    0,    0,    0,   92,  407,   94,    0,   75,
    0,    0,    0,    0,   94,    0,    0,    0,    8,    0,
    0,    0,    0,    0,    0,   85,    0,    0,    8,   94,
    0,    0,    0,    0,    0,    0,   84,   81,   81,  430,
    0,    0,    0,   94,    0,   92,    0,    0,   94,   94,
   92,    0,    0,    0,    0,    0,    0,    0,    0,    8,
    0,    0,    0,  655,    0,  166,    0,  166,  166,  166,
  166,    0,   75,    0,    0,    0,    0,    8,    0,    0,
    0,   81,    0,    0,    0,   85,  787,    0,   94,    0,
  791,   94,    0,   92,  279,    0,  426,    0,    0,    0,
    0,    0,    0,   94,   94,   94,  166,  166,    0,  407,
    0,    0,  407,  407,   92,    0,  151,    0,  151,  151,
  151,  151,  668,  668,    0,    0,   92,    0,    0,    0,
    0,  134,    0,    0,   92,    0,   92,    0,   94,   94,
   94,   81,    0,    8,    0,   94,   32,  427,    0,    0,
    0,    0,    0,   84,    0,   94,   32,  151,  151,  134,
    0,  134,    0,  134,    0,    0,  691,  429,  691,  691,
    0,   92,    0,   84,   94,    0,    0,    0,    0,    0,
  134,    0,  480,  705,   85,    0,   78,   32,  484,    0,
  263,    0,  407,  744,  407,    0,    0,    0,    0,    0,
  402,  403,    0,    0,    0,   32,    0,   94,    0,   94,
    0,    0,    0,  480,    0,    0,  265,   77,    0,  480,
   94,    0,   94,    0,    0,    0,  265,   75,    0,   94,
    0,  407,  407,  484,   85,    0,    0,  407,    0,   85,
   81,    0,    0,    0,    0,  691,    0,   94,  270,    0,
  577,  705,  788,    0,   84,  748,  407,  265,    0,    0,
  264,    0,    0,  225,  480,  484,   86,  797,  798,  799,
  407,   32,    0,  407,  265,  265,    0,    0,  407,   85,
    8,    8,    8,  430,   85,    0,    8,    8,   92,    8,
   81,    0,    0,    0,    0,   81,  480,   85,    0,    0,
    0,    0,  816,  817,  818,    0,    0,    0,   92,    0,
    0,    0,    0,   84,    0,    0,  529,  533,    0,    0,
    0,    0,    0,  135,    0,    0,    0,   85,   84,   84,
   84,    0,    0,    0,    0,   81,    0,    0,  836,    0,
   81,  265,    0,    0,  263,    0,    0,    0,   85,    0,
    0,  135,    0,  135,  263,  135,    0,    0,    0,  428,
   85,    0,  529,   84,   84,   84,    0,    0,   85,    0,
   85,  856,  135,    0,  606,  608,    0,    0,  612,    0,
   84,    0,  617,   81,  864,  263,  865,    0,  263,   92,
    0,    0,    0,  866,    0,  832,    0,    0,  229,   84,
    0,    0,  263,  263,   81,   85,    0,  638,   32,   32,
   32,  612,    0,  638,   32,   32,   81,   32,    0,    0,
    0,   86,  484,    0,   81,  134,   81,  134,  134,  134,
  134,    0,   84,    0,   84,    0,    0,  263,    0,   32,
   32,   32,   32,   32,    0,   84,    0,   84,   92,    0,
    0,    0,   85,  480,   84,    0,  429,    0,    0,    0,
    0,   81,    0,   92,   92,   92,  134,  134,    0,  263,
    0,    0,    0,    0,    0,    0,    0,  484,  265,  265,
  265,    0,    0,  265,  265,  265,    0,  265,    0,    0,
    0,    0,    0,    0,    0,    0,  673,    0,   92,   92,
   92,   96,    0,    0,    0,    0,    0,    0,  480,  265,
  265,  265,  265,  265,    0,   92,    0,    0,    0,    0,
    0,    0,   85,    0,    0,    0,    0,    0,    0,   96,
  834,   96,    0,   96,   92,    0,    0,  419,    0,    0,
    0,   81,   85,    0,   81,  699,  283,    0,    0,    0,
   96,    0,    0,    0,  265,    0,    0,    0,    0,  716,
    0,   81,    0,    0,    0,    0,    0,   92,    0,   92,
    0,    0,    0,    0,    0,    0,    0,  723,   81,    0,
   92,  726,   92,   76,    0,  727,   76,    0,  284,   92,
    0,  283,  608,  480,   78,    0,    0,   78,   81,  484,
    0,    0,    0,   76,    0,    0,  263,  263,  263,    0,
    0,  263,  263,  263,   78,  263,    0,  135,    0,  135,
  135,  135,  135,   85,   81,  263,  263,    0,    0,    0,
    0,  489,  227,  284,  263,  263,    0,  263,  263,  263,
  263,  263,  490,    0,  484,  768,    0,    0,  428,    0,
    0,    0,    0,    0,    0,  775,    0,    0,  135,  135,
    0,    0,    0,    0,    0,    0,   76,    0,  419,    0,
    0,    0,  489,    0,    0,    0,  484,   78,  419,   81,
    0,    0,   85,  490,    0,    0,    0,  638,  263,    0,
    0,    0,    0,    0,  612,    0,    0,   85,   85,   85,
  612,  477,    0,    0,    0,  419,  419,    0,  477,  419,
  419,  419,  419,  419,  419,  419,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  419,  419,  419,  419,
  419,  419,   85,   85,   85,    0,    0,  821,   81,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   85,
    0,    0,    0,   81,   81,   81,  489,    0,    0,  419,
    0,  419,  419,    0,  833,    0,  838,  490,   85,    0,
    0,    0,    0,    0,    0,  846,   97,    0,    0,   81,
  851,    0,    0,    0,    0,    0,    0,    0,   81,   81,
   81,  477,  419,  419,  477,   96,    0,   96,   96,   96,
   96,   85,    0,   85,   97,   81,   97,    0,   97,    0,
    0,    0,  422,    0,   85,    0,   85,  608,    0,  612,
    0,   76,    0,   85,   81,   97,  419,    0,    0,    0,
    0,    0,   78,  484,    0,  283,   96,   96,    0,  884,
  481,  887,    0,    0,   79,    0,  481,    0,    0,    0,
    0,    0,    0,    0,    0,  612,    0,   81,    0,   81,
  892,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   81,    0,   81,    0,    0,    0,    0,  284,    0,   81,
    0,    0,    0,    0,    0,    0,    0,    0,  484,    0,
    0,  481,    0,  489,  489,  489,    0,    0,    0,  489,
  489,    0,  489,    0,  490,  490,  490,    0,    0,    0,
  490,  490,    0,  490,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  481,   87,  477,  477,  477,    0,  477,
  419,  419,  419,  477,  477,  419,  419,  419,  477,  419,
  477,  477,  477,  477,  477,  477,  477,  419,  477,  419,
  419,  477,  477,  477,  477,  477,  477,  477,  419,  419,
    0,  419,  419,  419,  419,  419,    0,  477,    0,    0,
  477,  477,  477,  477,  477,  477,  477,  477,  477,  477,
    0,  477,  477,    0,  477,  477,  419,  419,  419,  419,
  419,  419,  419,  419,  419,  419,  419,  419,  419,  422,
    0,  419,  419,  419,  477,  419,  419,  477,  477,  422,
  477,  477,  419,  477,  477,  477,  477,  477,  477,  477,
  477,    0,    0,    0,    0,  477,    0,    0,    0,    0,
    0,    0,  478,    0,    0,    0,  422,  422,    0,  478,
  422,  422,  422,  422,  422,  422,  422,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  422,  422,  422,
  422,  422,  422,    0,    0,    0,    0,    0,    0,    0,
   97,    0,   97,   97,   97,   97,    0,    0,    0,   87,
  481,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  422,    0,  422,  422,    0,    0,  484,    0,    0,    0,
    0,  422,    0,    0,    0,    0,  484,    0,    0,    0,
    0,   97,   97,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  478,  422,  422,  478,    0,    0,    0,  480,
    0,    0,    0,  484,  484,  481,  480,  484,  484,  484,
  484,  484,  484,  484,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  484,  484,  484,   86,  484,  484,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  484,    0,  484,
  484,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  484,
  484,  484,  480,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  478,  478,  478,    0,
  478,  422,  422,  422,  478,  478,  422,  422,  422,  478,
  422,  478,  478,  478,  478,  478,  478,  478,  422,  478,
  422,  422,  478,  478,  478,  478,  478,  478,  478,  422,
  422,    0,  422,  422,  422,  422,  422,    0,  478,    0,
    0,  478,  478,  478,  478,  478,  478,  478,  478,  478,
  478,    0,  478,  478,    0,  478,  478,  422,  422,  422,
  422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
    0,    0,  422,  422,  422,  478,  422,  422,  478,  478,
    0,  478,  478,  422,  478,  478,  478,  478,  478,  478,
  478,  478,    0,  480,  480,  480,  478,  480,  484,  484,
  484,  480,  480,  484,  484,  484,  480,  484,  480,  480,
  480,  480,  480,  480,  480,    0,  484,  484,  484,  480,
  480,  480,  480,  480,  480,  480,  484,  484,    0,  484,
  484,  484,  484,  484,    0,  480,    0,    0,  480,  480,
  480,  480,  480,  480,  480,  480,  480,  480,    0,  480,
  480,    0,  480,  480,  484,  484,  484,  484,  484,  484,
  484,  484,  484,  484,  484,  484,  484,  480,    0,  484,
  484,  484,  480,    0,  484,  480,  480,  480,  480,  480,
  484,  480,  480,  480,  480,  480,  480,  480,  480,    0,
    0,    0,    0,  480,    0,    0,    0,    0,    0,    0,
  480,    0,    0,    0,  480,  480,    0,  480,  480,  480,
  480,  480,  480,  480,  480,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  480,  480,  480,   85,  480,
  480,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  480,    0,
  480,  480,    0,    0,  481,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  481,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  480,  480,  480,  480,    0,    0,    0,  481,    0,    0,
    0,  481,  481,    0,  481,  481,  481,  481,  481,  481,
  481,  481,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  481,  481,  481,   87,  481,  481,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  481,    0,  481,  481,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  481,  481,  481,
  481,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  480,  480,  480,    0,  480,  480,
  480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
  480,  480,  480,  480,  480,  480,    0,  480,  480,  480,
  480,  480,  480,  480,  480,  480,  480,  480,  480,    0,
  480,  480,  480,  480,  480,    0,  480,    0,    0,  480,
  480,  480,  480,  480,  480,  480,  480,  480,  480,    0,
  480,  480,    0,  480,  480,  480,  480,  480,  480,  480,
  480,  480,  480,  480,  480,  480,  480,  480,    0,    0,
  480,  480,  480,  480,    0,  480,  480,  480,    0,  480,
  480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
    0,  481,  481,  481,  480,  481,  481,  481,  481,  481,
  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
  481,  481,  481,    0,  481,  481,  481,  481,  481,  481,
  481,  481,  481,  481,  481,  481,    0,  481,  481,  481,
  481,  481,    0,  481,    0,    0,  481,  481,  481,  481,
  481,  481,  481,  481,  481,  481,    0,  481,  481,    0,
  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
  481,  481,  481,  481,  481,  276,    0,  481,  481,  481,
  481,    0,  481,  481,  481,  276,  481,  481,  481,  481,
  481,  481,  481,  481,  481,  481,  481,    0,    0,    0,
    0,  481,    0,    0,    0,    0,    0,    0,  479,    0,
    0,    0,  276,  276,    0,  479,  276,  276,  276,  276,
  276,  276,  276,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  276,  276,  276,    0,  276,  276,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  276,    0,  276,  276,
    0,    0,  485,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  485,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  479,  276,
  276,  479,    0,    0,    0,  482,    0,    0,    0,  485,
  485,    0,  482,  485,  485,  485,  485,  485,  485,  485,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  485,  485,  485,    0,  485,  485,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  485,    0,  485,  485,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  485,  485,  485,  482,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  479,  479,  479,    0,  479,  276,  276,  276,
  479,  479,  276,  276,  276,  479,  276,  479,  479,  479,
  479,  479,  479,  479,    0,  479,  276,  276,  479,  479,
  479,  479,  479,  479,  479,  276,  276,    0,  276,  276,
  276,  276,  276,    0,  479,    0,    0,  479,  479,  479,
  479,  479,  479,  479,  479,  479,  479,    0,  479,  479,
    0,  479,  479,  276,  276,  276,  276,  276,  276,  276,
  276,  276,  276,  276,  276,  276,    0,    0,  276,  276,
  276,  479,    0,  276,  479,  479,    0,  479,  479,  276,
  479,  479,  479,  479,  479,  479,  479,  479,    0,  482,
  482,  482,  479,  482,  485,  485,  485,  482,  482,  485,
  485,  485,  482,  485,  482,  482,  482,  482,  482,  482,
  482,    0,  485,  485,  485,  482,  482,  482,  482,  482,
  482,  482,  485,  485,    0,  485,  485,  485,  485,  485,
    0,  482,    0,    0,  482,  482,  482,  482,  482,  482,
  482,  482,  482,  482,    0,  482,  482,    0,  482,  482,
  485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
  485,  485,  485,  486,    0,  485,  485,  485,  482,    0,
  485,  482,  482,  486,  482,  482,  485,  482,  482,  482,
  482,  482,  482,  482,  482,    0,    0,    0,    0,  482,
    0,    0,    0,    0,    0,    0,  483,    0,    0,    0,
  486,  486,    0,  483,  486,  486,  486,  486,  486,  486,
  486,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  486,  486,  486,    0,  486,  486,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  486,    0,  486,  486,    0,    0,
  355,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  355,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  486,  486,  486,  483,
    0,    0,    0,  253,    0,    0,    0,  355,  355,    0,
    0,  355,  355,  355,  355,  355,  355,  355,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  355,  355,
  355,    0,  355,  355,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  355,    0,  355,  355,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  355,  355,  355,  253,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  483,  483,  483,    0,  483,  486,  486,  486,  483,  483,
  486,  486,  486,  483,  486,  483,  483,  483,  483,  483,
  483,  483,    0,  486,  486,  486,  483,  483,  483,  483,
  483,  483,  483,  486,  486,    0,  486,  486,  486,  486,
  486,    0,  483,    0,    0,  483,  483,  483,  483,  483,
  483,  483,  483,  483,  483,    0,  483,  483,    0,  483,
  483,  486,  486,  486,  486,  486,  486,  486,  486,  486,
  486,  486,  486,  486,    0,    0,  486,  486,  486,  483,
    0,  486,  483,  483,    0,  483,  483,  486,  483,  483,
  483,  483,  483,  483,  483,  483,    0,  253,  253,  253,
  483,  253,  355,  355,  355,  253,  253,  355,  355,  355,
  253,  355,  253,  253,  253,  253,  253,  253,  253,    0,
  355,  355,  355,  253,  253,  253,  253,  253,  253,  253,
  355,  355,    0,  355,  355,  355,  355,  355,    0,  253,
    0,    0,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,    0,  253,  253,    0,  253,  253,  355,  355,
  355,  355,  355,  355,  355,  355,  355,  355,  355,  355,
  355,  500,    0,  355,  355,  355,  253,    0,  355,  253,
  253,  500,  253,  253,  355,  253,  253,  253,  253,  253,
  253,  253,  253,    0,    0,    0,    0,  253,    0,    0,
    0,    0,    0,    0,  253,    0,    0,    0,  500,  500,
    0,    0,  500,  500,  500,  500,  500,  500,  500,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  500,
  500,  500,    0,  500,  500,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  500,    0,  500,  500,    0,    0,  282,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  282,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  500,  500,  500,  253,    0,    0,
    0,  481,    0,    0,    0,  282,  282,    0,  481,  282,
  282,  282,  282,  282,  282,  282,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  282,  282,  282,   88,
  282,  282,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  282,
    0,  282,  282,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  282,  282,  481,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  253,  253,
  253,    0,  253,  500,  500,  500,  253,  253,  500,  500,
  500,  253,  500,  253,  253,  253,  253,  253,  253,  253,
    0,  500,  500,  500,  253,  253,  253,  253,  253,  253,
  253,  500,  500,    0,  500,  500,  500,  500,  500,    0,
  253,    0,    0,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,    0,  253,  253,    0,  253,  253,  500,
  500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
  500,  500,    0,    0,  500,  500,  500,  253,    0,  500,
  253,  253,    0,  253,  253,  500,  253,  253,  253,  253,
  253,  253,  253,  253,    0,  481,  481,  481,  253,  481,
  282,  282,  282,  481,  481,  282,  282,  282,  481,  282,
  481,  481,  481,  481,  481,  481,  481,    0,    0,  282,
  282,  481,  481,  481,  481,  481,  481,  481,  282,  282,
    0,  282,  282,  282,  282,  282,    0,  481,    0,    0,
  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
    0,  481,  481,    0,  481,  481,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  290,
    0,  282,  282,  282,  481,    0,  282,  481,  481,  290,
  481,  481,  282,  481,  481,  481,  481,  481,  481,  481,
  481,    0,    0,    0,    0,  481,    0,    0,    0,    0,
    0,    0,  253,    0,    0,    0,  290,  290,    0,    0,
  290,  290,  290,  290,  290,  290,  290,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  290,  290,  290,
    0,  290,  290,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  290,    0,  290,  290,    0,    0,  484,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  484,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  290,  290,  253,    0,    0,    0,  480,
    0,    0,    0,  484,  484,    0,  480,  484,  484,  484,
   78,  484,  484,  484,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  484,  484,   86,  484,  484,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  484,    0,    0,
  484,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  484,
  484,  484,  480,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    7,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    7,    0,
    0,    0,    0,    0,    0,    0,  253,  253,  253,    0,
  253,  290,  290,  290,  253,  253,  290,  290,  290,  253,
  290,  253,  253,  253,  253,  253,  253,  253,    0,    7,
  290,  290,  253,  253,  253,  253,  253,  253,  253,  290,
  290,    0,  290,  290,  290,  290,  290,    7,  253,    0,
    0,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,    0,  253,  253,    0,  253,  253,  290,  290,  290,
  290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
    0,    0,  290,  290,  290,  253,    0,  290,  253,  253,
    0,  253,  253,  290,  253,  253,  253,  253,  253,  253,
  253,  253,    0,  480,  480,  480,  253,  480,  484,  484,
  484,  480,  480,    7,  484,  484,  480,  484,  480,  480,
  480,  480,  480,  480,  480,    0,  484,    0,    0,  480,
  480,  480,  480,  480,  480,  480,  484,  484,    0,  484,
  484,  484,  484,  484,    0,  480,    0,    0,  480,  480,
  480,  480,  480,  480,  480,  480,  480,  480,    0,  480,
  480,    0,  480,  480,  484,  484,  484,  484,  484,  484,
  484,  484,  484,  484,  484,  484,  484,  480,    0,  484,
  484,  484,  480,    0,    0,  480,  480,  480,  480,  480,
    0,  480,  480,  480,  480,  480,  480,  480,  480,    0,
    0,    0,    0,  480,    0,    0,    0,    0,    0,    0,
  480,    0,    0,    0,  480,  480,    0,  480,  480,  480,
  480,   77,  480,  480,  480,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  480,  480,   85,  480,
  480,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    7,    7,    7,    0,    0,    0,    7,    7,    0,    7,
    0,    0,    0,    0,    0,    0,    0,    0,  480,    0,
    0,  480,    0,    0,  481,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  481,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  480,  480,  480,  480,    0,    0,    0,  481,    0,    0,
    0,  481,  481,    0,  481,  481,  481,  481,   79,  481,
  481,  481,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  481,  481,   87,  481,  481,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  481,    0,    0,  481,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  481,  481,  481,
  481,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  480,  480,  480,    0,  480,  480,
  480,  480,  480,  480,    0,  480,  480,  480,  480,  480,
  480,  480,  480,  480,  480,  480,    0,  480,    0,    0,
  480,  480,  480,  480,  480,  480,  480,  480,  480,    0,
  480,  480,  480,  480,  480,    0,  480,    0,    0,  480,
  480,  480,  480,  480,  480,  480,  480,  480,  480,    0,
  480,  480,    0,  480,  480,  480,  480,  480,  480,  480,
  480,  480,  480,  480,  480,  480,  480,  480,    0,    0,
  480,  480,  480,  480,    0,    0,  480,  480,    0,  480,
  480,    0,  480,  480,  480,  480,  480,  480,  480,  480,
    0,  481,  481,  481,  480,  481,  481,  481,  481,  481,
  481,   58,  481,  481,  481,  481,  481,  481,  481,  481,
  481,  481,  481,    0,  481,    0,    0,  481,  481,  481,
  481,  481,  481,  481,  481,  481,    0,  481,  481,  481,
  481,  481,    0,  481,    0,    0,  481,  481,  481,  481,
  481,  481,  481,  481,  481,  481,    0,  481,  481,    0,
  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
  481,  481,  481,  481,  481,  282,    0,  481,  481,  481,
  481,    0,    0,  481,  481,  282,  481,  481,    0,  481,
  481,  481,  481,  481,  481,  481,  481,    0,    0,    0,
    0,  481,    0,    0,   59,    0,    0,    0,  481,    0,
    0,    0,  282,  282,    0,  481,  282,  282,  282,   80,
  282,  282,  282,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  282,  282,   88,  282,  282,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  282,    0,    0,  282,
    0,    0,  500,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  500,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  282,
  282,  481,    0,    0,    0,  253,    0,    0,    0,    0,
    0,    0,    0,  500,    0,    0,    0,    0,  500,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  500,  500,    0,    0,    3,    4,    5,    6,    7,    8,
    0,    0,    0,    9,   10,    0,    0,    0,   11,    0,
   12,   13,   14,   15,   16,   17,   18,    0,    0,    0,
    0,   19,   20,   21,   22,   23,   24,   25,    0,    0,
   26,    0,    0,    0,    0,    0,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
    0,   41,   42,    0,   43,   44,    0,  500,  253,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   45,    0,    0,   46,   47,    0,
   48,   49,    0,   50,    0,   51,   52,   53,   54,   55,
   56,    0,  481,  481,  481,   57,  481,  282,  282,  282,
  481,  481,    0,  282,  282,  481,  282,  481,  481,  481,
  481,  481,  481,  481,    0,    0,    0,    0,  481,  481,
  481,  481,  481,  481,  481,  282,  282,    0,  282,  282,
  282,  282,  282,    0,  481,    0,    0,  481,  481,  481,
  481,  481,  481,  481,  481,  481,  481,    0,  481,  481,
    0,  481,  481,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,    0,    0,  282,  282,
  282,  481,    0,    0,  481,  481,    0,  481,  481,    0,
  481,  481,  481,  481,  481,  481,  481,  481,    0,  253,
  253,  253,  481,  253,  500,  500,  500,  253,  253,  500,
  500,  500,  253,  500,  253,  253,  253,  253,  253,  253,
  253,    0,    0,  500,    0,  253,  253,  253,  253,  253,
  253,  253,  500,  500,    0,  500,  500,  500,  500,  500,
    0,  253,    0,    0,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,    0,  253,  253,    0,  253,  253,
    0,    0,  480,   77,    0,    0,   77,    0,  480,    0,
    0,    0,   91,    0,    0,    0,    0,  500,  253,    0,
    0,  253,  253,   77,  253,  253,    0,  253,  253,  253,
  253,  253,  253,  253,  253,   91,    0,    0,    0,  253,
    0,    0,  477,    0,    0,    0,    0,    0,  419,    0,
    0,    0,    0,  480,    0,    0,    0,    0,    0,    0,
    0,   91,   91,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  480,   77,    0,  481,   79,
    0,    0,   79,  419,  481,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   79,
    0,    0,    0,    0,   92,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  477,    0,    0,   91,    0,
    0,    0,    0,    0,    0,    0,    0,   92,    0,  481,
    0,    0,    0,    0,  478,    0,    0,    0,    0,    0,
  422,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   92,   92,    0,    0,    0,    0,    0,
  252,  481,   79,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  422,    0,  333,  328,    0,
    0,    0,  331,  329,    0,  330,    0,  332,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  325,    0,  324,  323,    0,    0,    0,  478,    0,    0,
   92,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   77,  480,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  327,    0,    0,    0,   91,   91,
   91,   91,   91,   91,   91,   91,   91,   91,   91,    0,
    0,   91,   91,   34,   91,   91,   91,   91,   91,   91,
   91,    0,  477,   34,  326,   91,   91,   91,   91,   91,
   91,   91,    0,    0,   91,    0,    0,  480,    0,    0,
   91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
   91,   91,   91,   91,   34,   91,   91,    0,   91,   91,
    0,    0,    0,    0,    0,    0,    0,   79,  481,    0,
    0,    0,   34,    0,    0,    0,    0,  419,   91,    0,
    0,   91,   91,    0,   91,   91,    0,   91,    0,   91,
   91,   91,   91,   91,   91,    0,    0,    0,    0,   91,
   92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
   92,    0,    0,   92,   92,   53,   92,   92,   92,   92,
   92,   92,   92,  481,  478,   53,    0,   92,   92,   92,
   92,   92,   92,   92,    0,    0,   92,    0,   34,    0,
    0,    0,   92,   92,   92,   92,   92,   92,   92,   92,
   92,   92,   92,   92,   92,   92,   53,   92,   92,    0,
   92,   92,    0,    0,    0,    0,    0,   91,    0,    0,
    0,    0,    0,   53,   53,    0,    0,    0,    0,  422,
   92,    0,    0,   92,   92,    0,   92,   92,    0,   92,
   91,   92,   92,   92,   92,   92,   92,  480,    0,    0,
    0,   92,    0,  484,    0,    0,    0,    0,   53,    0,
    0,    0,    0,    0,    0,    0,   91,   91,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
  320,    0,    0,  321,  322,    0,    0,    0,    0,    0,
   53,    0,    0,    0,    0,    0,    0,    0,  484,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   92,
    0,    0,    0,    0,    0,   34,   34,   34,    0,    0,
  484,   34,   34,   91,   34,    0,    0,    0,    0,    0,
    0,    0,   92,    0,    0,    0,    0,    0,    0,  481,
    0,    0,    0,    0,    0,  282,   34,   34,   34,   34,
   34,    0,    0,    0,    0,    0,    0,    0,   92,   92,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  282,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  327,    0,   53,   53,   53,
    0,    0,   53,   53,   53,   92,   53,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   53,   53,  327,    0,
    0,    0,    0,    0,    0,   53,   53,    0,   53,   53,
   53,   53,   53,   91,   91,   91,   91,   91,   91,   91,
   91,   91,   91,   91,  327,    0,   91,   91,    0,   91,
   91,   91,   91,   91,   91,   91,    0,  484,    0,    0,
   91,   91,   91,   91,   91,   91,   91,    0,    0,   91,
    0,    0,    0,    0,    0,   91,   91,   91,   91,   91,
   91,   91,   91,   91,   91,   91,   91,   91,   91,    0,
   91,   91,    0,   91,   91,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  327,  484,   91,    0,    0,   91,   91,    0,   91,
   91,    0,   91,   92,   91,   91,   91,   91,   91,   91,
    0,    0,    0,    0,   91,   92,   92,   92,   92,   92,
   92,   92,   92,   92,   92,   92,   92,    0,   92,   92,
    0,   92,   92,   92,   92,   92,   92,   92,    0,  283,
    0,    0,   92,   92,   92,   92,   92,   92,   92,    0,
    0,   92,   92,   92,    0,    0,    0,   92,   92,   92,
   92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
   92,    0,   92,   92,    0,   92,   92,    0,    0,    0,
    0,    0,    0,    0,  283,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  282,   92,    0,    0,   92,   92,
    0,   92,   92,  264,   92,    0,   92,   92,   92,   92,
   92,   92,    0,  264,    0,    0,   92,    0,    0,   92,
    0,  327,  327,  327,  327,  327,  327,  327,  327,  327,
  327,  327,    0,  327,  327,  327,  327,  327,  327,  327,
  327,  327,  327,  327,  264,    0,    0,  264,  327,  327,
  327,  327,  327,  327,  327,    0,    0,  327,    0,    0,
    0,  264,  264,  327,  327,  327,  327,  327,  327,  327,
  327,  327,  327,  327,  327,  327,  327,    0,  327,  327,
    0,  327,  327,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  500,  264,    0,    0,    0,
    0,  327,    0,    0,  327,  327,    0,  327,  327,    0,
  327,    0,  327,  327,  327,  327,  327,  327,  500,    0,
    0,    0,  327,    0,    0,    0,    0,    0,  264,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  500,    0,    0,    0,    0,   92,
   92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
    0,    0,   92,   92,    0,   92,   92,   92,   92,   92,
   92,   92,    0,    0,    0,    0,   92,   92,   92,   92,
   92,   92,   92,    0,    0,   92,    0,    0,    0,    0,
    0,   92,   92,   92,   92,   92,   92,   92,   92,   92,
   92,   92,   92,   92,   92,    0,   92,   92,  500,   92,
   92,  500,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  283,   92,
    0,  500,   92,   92,    0,   92,   92,    0,   92,    0,
   92,   92,   92,   92,   92,   92,    0,    0,    0,    0,
   92,    0,    0,    0,    0,    0,    0,  500,    0,    0,
    0,    0,    0,    0,    0,  264,  264,  264,    0,    0,
  264,  264,  264,    0,  264,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  264,  264,    0,    0,    0,    0,
    0,    0,    0,  264,  264,    0,  264,  264,  264,  264,
  264,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  215,    0,    0,    0,    0,
    0,    0,    0,  500,  500,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,    0,
    0,  500,  500,  500,  500,  500,  500,  264,    0,  500,
  500,  500,    0,    0,    0,  500,    0,  500,  500,  500,
  500,  500,  500,  500,  216,    0,    0,    0,  500,  500,
  500,  500,  500,  500,  500,    0,    0,  500,    0,    0,
    0,    0,    0,  500,  500,  500,  500,  500,  500,  500,
  500,  500,  500,  500,  500,  500,  500,    0,  500,  500,
    0,  500,  500,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  500,    0,    0,  500,  500,    0,  500,  500,    0,
  500,   59,  500,  500,  500,  500,  500,  500,    0,    0,
    0,    0,  500,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  500,  500,  500,  500,  500,  500,
    0,    0,    0,  500,  500,    0,    0,    0,  500,    0,
  500,  500,  500,  500,  500,  500,  500,    0,    0,    0,
    0,  500,  500,  500,  500,  500,  500,  500,    0,    0,
  500,    0,    0,    0,    0,    0,  500,  500,  500,  500,
  500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
    0,  500,  500,    0,  500,  500,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   40,    0,    0,    0,
    0,    0,    0,    0,  500,    0,   40,  500,  500,    0,
  500,  500,    0,  500,    0,  500,  500,  500,  500,  500,
  500,    0,    0,    0,    0,  500,    0,    0,    0,    0,
    0,    0,    4,    5,    6,    0,    8,   40,    0,    0,
    9,   10,    0,    0,    0,   11,    0,   12,   13,   14,
   15,   16,   17,   18,   40,   40,    0,    0,   19,   20,
   21,   22,   23,   24,   25,    0,    0,   26,    0,    0,
    0,    0,    0,    0,   28,    0,    0,   31,   32,   33,
   34,   35,   36,   37,   38,   39,   40,    0,   41,   42,
    0,   43,   44,  355,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  355,    0,    0,    0,    0,    0,    0,
    0,  206,    0,    0,  106,   47,    0,   48,   49,    0,
    0,   40,   51,   52,   53,   54,   55,   56,    0,    0,
  355,  355,   57,    0,  355,  355,  355,  355,  355,  355,
  355,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  355,  355,  355,    0,  355,  355,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  430,    0,  355,    0,  355,  355,    0,    0,
    0,    0,  430,    0,    0,    0,    0,   14,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   14,    0,    0,
    0,    0,    0,    0,    0,    0,  355,  355,  355,  430,
  430,    0,    0,  430,  430,  430,  430,  430,  430,  430,
    0,    0,    0,    0,    0,    0,    0,    0,   14,    0,
  430,  430,  430,   83,  430,  430,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   14,    0,   40,   40,
   40,    0,    0,   40,   40,   40,    0,   40,    0,    0,
    0,    0,  500,  430,    0,  430,  430,   40,    0,    0,
    0,    0,  500,    0,    0,    0,   40,   40,    0,   40,
   40,   40,   40,   40,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  430,  430,    0,  500,
  500,    0,    0,  500,  500,  500,  500,  500,  500,  500,
    0,    0,   14,    0,    0,    0,    0,    0,    0,    0,
  500,  500,  500,    0,  500,  500,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  355,  355,  355,    0,    0,
  355,  355,  355,  500,  355,  500,  500,    0,    0,    0,
    0,    0,    0,  355,  355,  355,    0,    0,    0,    0,
    0,    0,    0,  355,  355,    0,  355,  355,  355,  355,
  355,    0,    0,    0,    0,  500,  500,  500,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  355,  355,  355,  355,  355,  355,  355,  355,  355,
  355,  355,  355,  355,    0,    0,  355,  355,  355,    0,
    0,  355,    0,    0,    0,    0,    0,  355,    0,    0,
    0,    0,    0,    0,  430,  430,  430,    0,    0,  430,
  430,  430,    0,  430,    0,    0,    0,    0,    0,   14,
   14,   14,    0,  430,  430,   14,   14,    0,   14,    0,
    0,    0,  430,  430,    0,  430,  430,  430,  430,  430,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   14,   14,   14,   14,   14,    0,    0,    0,    0,    0,
  430,  430,  430,  430,  430,  430,  430,  430,  430,  430,
  430,  430,  430,    0,    0,  430,  430,  430,    0,  431,
  430,    0,    0,    0,    0,    0,  430,    0,    0,    0,
    0,    0,    0,    0,  500,  500,  500,    0,    0,  500,
  500,  500,    0,  500,    0,    0,    0,    0,    0,    0,
    0,    0,  500,  500,  500,    0,    0,    0,    0,    0,
    0,    0,  500,  500,    0,  500,  500,  500,  500,  500,
    0,    0,    0,    0,    0,    0,  275,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  275,    0,    0,    0,
  500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
  500,  500,  500,    0,    0,  500,  500,  500,    0,    0,
  500,    0,    0,  275,  275,    0,  500,  275,  275,  275,
  275,  275,  275,  275,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  275,  275,  275,   90,  275,  275,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  333,  328,    0,    0,    0,  331,  329,    0,
  330,  283,  332,    0,    0,    0,    0,  275,    0,  275,
  275,  283,    0,    0,    0,  325,    0,  324,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  283,  283,
  275,  275,  283,  283,  283,  283,  283,  283,  283,  327,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  283,
  283,  283,   89,  283,  283,    0,  333,  328,    0,    0,
    0,  331,  329,    0,  330,    0,  332,    0,    0,  326,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  325,
    0,  324,  283,    0,  283,  283,    0,  284,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  284,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  327,    0,  283,  283,    0,    0,    0,
    0,    0,    0,    0,  284,  284,    0,    0,  284,  284,
  284,  284,  284,  284,  284,    0,    0,    0,    0,    0,
    0,    0,    0,  326,    0,  284,  284,  284,   84,  284,
  284,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  275,  275,
  275,    0,    0,  275,  275,  275,    0,  275,  284,    0,
  284,  284,    0,    0,    0,    0,    0,  275,  275,    0,
    0,    0,    0,    0,    0,    0,  275,  275,    0,  275,
  275,  275,  275,  275,    0,    0,  500,    0,    0,    0,
    0,  284,  284,    0,    0,    0,  500,    0,    0,    0,
    0,    0,    0,    0,  275,  275,  275,  275,  275,  275,
  275,  275,  275,  275,  275,  275,  275,    0,    0,  275,
  275,  275,    0,    0,  275,    0,    0,  500,    0,    0,
  275,    0,    0,  283,  283,  283,    0,    0,  283,  283,
  283,    0,  283,  308,  500,  500,    0,    0,  313,  314,
    0,    0,  283,  283,    0,    0,    0,    0,  321,  322,
    0,  283,  283,    0,  283,  283,  283,  283,  283,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  500,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  283,
  283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
  283,  283,    0,    0,  283,  283,  283,    0,    0,  283,
    0,  500,    0,    0,    0,  283,    0,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,    0,  284,
  284,  284,  321,  322,  284,  284,  284,    0,  284,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  284,  284,
    0,    0,    0,    0,    0,    0,    0,  284,  284,    0,
  284,  284,  284,  284,  284,    0,    0,    0,    0,    0,
    0,  380,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  380,    0,    0,    0,  284,  284,  284,  284,  284,
  284,  284,  284,  284,  284,  284,  284,  284,    0,    0,
  284,  284,  284,    0,    0,  284,    0,    0,  380,  380,
    0,  284,  380,  380,  380,  380,  380,  380,  380,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  380,
  380,  380,    0,  380,  380,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  500,  500,
  500,    0,    0,  500,  500,  500,  218,  500,    0,    0,
    0,    0,  380,    0,  380,  380,  218,  500,  500,    0,
    0,    0,    0,    0,    0,    0,  500,  500,    0,  500,
  500,  500,  500,  500,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  218,  218,  380,  380,  218,  218,  218,
  218,  218,  326,  218,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  218,  218,  218,    0,  218,  218,
    0,  333,  328,    0,    0,    0,  331,  329,    0,  330,
  500,  332,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  325,    0,  324,  326,    0,  218,
  218,    0,  294,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  294,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  327,    0,
  218,  218,    0,    0,    0,    0,    0,    0,    0,  294,
  294,    0,    0,  294,  294,  294,  294,  294,  294,  294,
    0,    0,    0,    0,    0,    0,    0,    0,  326,    0,
  294,  294,  294,    0,  294,  294,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  380,  380,  380,    0,    0,  380,  380,
  380,    0,  380,  294,    0,  294,  294,    0,    0,    0,
    0,    0,  380,  380,    0,    0,    0,    0,    0,    0,
    0,  380,  380,    0,  380,  380,  380,  380,  380,    0,
    0,   57,    0,    0,    0,    0,  294,  294,    0,    0,
    0,   57,    0,    0,    0,    0,    0,    0,    0,  380,
  380,  380,  380,  380,  380,  380,  380,  380,  380,  380,
  380,  380,    0,    0,  380,  380,  380,    0,    0,  380,
    0,    0,   57,    0,    0,  380,    0,    0,  218,  218,
  218,    0,    0,  218,  218,  218,    0,  218,    0,   57,
   57,    0,    0,    0,    0,    0,    0,  218,  218,    0,
    0,    0,    0,    0,    0,    0,  218,  218,    0,  218,
  218,  218,  218,  218,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   57,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  218,  218,  218,  218,  218,  218,
  218,  218,  218,  218,  218,  218,  218,    0,    0,  218,
  218,  326,    0,    0,  218,    0,   57,    0,    0,    0,
  218,    0,  308,  309,  310,  311,  312,  313,  314,  315,
    0,  317,  318,    0,  294,  294,  294,  321,  322,  294,
  294,  294,    0,  294,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  294,  294,    0,    0,    0,    0,    0,
    0,    0,  294,  294,    0,  294,  294,  294,  294,  294,
    0,    0,    0,    0,    0,    0,  290,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  290,    0,    0,    0,
  294,  294,  294,  294,  294,  294,  294,  294,  294,  294,
  294,  294,  294,    0,    0,  294,  294,  294,    0,    0,
  294,    0,    0,  290,  290,    0,  294,  290,  290,  290,
  290,  290,  290,  290,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  290,  290,  290,    0,  290,  290,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   57,   57,   57,    0,    0,   57,   57,
   57,  417,   57,    0,    0,    0,    0,  290,    0,  290,
  290,  417,   57,   57,    0,    0,    0,    0,    0,    0,
    0,   57,   57,    0,   57,   57,   57,   57,   57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  417,  417,
  290,  290,  417,  417,  417,  417,  417,  417,  417,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  417,
  417,  417,    0,  417,  417,    0,  333,  328,    0,    0,
    0,  331,  329,    0,  330,    0,  332,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  325,
    0,  324,  417,    0,  417,  417,    0,  418,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  418,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  327,    0,  417,  417,    0,    0,    0,
    0,    0,    0,    0,  418,  418,    0,    0,  418,  418,
  418,  418,  418,  418,  418,    0,    0,    0,    0,    0,
    0,    0,    0,  326,    0,  418,  418,  418,    0,  418,
  418,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  290,  290,
  290,    0,    0,  290,  290,  290,    0,  290,  418,    0,
  418,  418,    0,    0,    0,    0,    0,  290,  290,    0,
    0,    0,    0,    0,    0,    0,  290,  290,    0,  290,
  290,  290,  290,  290,    0,    0,   55,    0,    0,    0,
    0,  418,  418,    0,    0,    0,   55,    0,    0,    0,
    0,    0,    0,    0,  290,  290,  290,  290,  290,  290,
  290,  290,  290,  290,  290,  290,  290,    0,    0,  290,
  290,  290,    0,    0,  290,    0,    0,   55,    0,    0,
  290,    0,    0,  417,  417,  417,    0,    0,  417,  417,
  417,    0,  417,    0,   55,   55,    0,    0,    0,    0,
  333,  328,  417,  417,    0,  331,  329,    0,  330,    0,
  332,  417,  417,    0,  417,  417,  417,  417,  417,    0,
    0,  651,    0,  325,    0,  324,  323,    0,    0,   55,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  417,  417,  417,  417,  417,  417,  417,  417,  417,  417,
  417,  417,    0,    0,  417,  417,  417,  327,    0,  417,
    0,   55,    0,    0,    0,  417,    0,  308,  309,  310,
  311,  312,  313,  314,    0,    0,  317,  318,    0,  418,
  418,  418,  321,  322,  418,  418,  418,  326,  418,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  418,  418,
    0,    0,    0,    0,    0,    0,    0,  418,  418,    0,
  418,  418,  418,  418,  418,    0,    0,    0,    0,    0,
    0,  195,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  195,    0,    0,    0,    0,  418,  418,  418,  418,
  418,  418,  418,  418,  418,  418,  418,  418,    0,    0,
  418,  418,  418,    0,    0,  418,    0,    0,  195,  195,
    0,  418,  195,  195,  195,  195,  195,    0,  195,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  195,
  195,  195,    0,  195,  195,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   55,   55,
   55,    0,    0,   55,   55,   55,  191,   55,    0,    0,
    0,    0,    0,    0,  195,  195,  191,   55,   55,    0,
    0,    0,    0,    0,    0,    0,   55,   55,    0,   55,
   55,   55,   55,   55,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  191,  191,  195,  195,  191,  191,  191,
  191,  191,    0,  191,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  191,  191,  191,    0,  191,  191,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,    0,    0,  321,  322,    0,  191,
  191,  188,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  188,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  191,  191,    0,    0,    0,    0,    0,    0,  188,  188,
    0,    0,  188,  188,  188,  188,  188,    0,  188,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  188,
  188,  188,    0,  188,  188,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  195,  195,  195,    0,    0,  195,  195,
  195,    0,  195,    0,  188,  188,    0,    0,    0,    0,
    0,    0,  195,  195,    0,    0,    0,    0,    0,    0,
    0,  195,  195,    0,  195,  195,  195,  195,  195,    0,
    0,    0,    0,    0,    0,  188,  188,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  195,  195,  195,  195,  195,  195,  195,  195,  195,  195,
  195,  195,   42,    0,  195,  195,    0,    0,    0,  195,
    0,    0,   42,    0,    0,  195,    0,    0,  191,  191,
  191,    0,    0,  191,  191,  191,    0,  191,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  191,  191,    0,
    0,    0,    0,   42,    0,    0,  191,  191,    0,  191,
  191,  191,  191,  191,    0,    0,    0,    0,  174,    0,
   42,   42,    0,    0,    0,    0,    0,    0,  174,    0,
    0,    0,    0,    0,    0,  191,  191,  191,  191,  191,
  191,  191,  191,  191,  191,  191,  191,    0,    0,  191,
  191,    0,    0,  189,  191,    0,    0,    0,    0,  174,
  191,    0,  219,  189,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  188,  188,  188,    0,  174,  188,  188,
  188,    0,  188,    0,    0,    0,    0,   42,    0,    0,
  189,  189,  188,  188,  189,  189,  189,  189,  189,    0,
  189,  188,  188,    0,  188,  188,  188,  188,  188,    0,
    0,  189,  189,  189,    0,  189,  189,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
  188,  188,  190,  174,  188,  188,  189,  189,    0,  188,
    0,    0,  190,    0,    0,  188,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  189,  189,  190,
  190,    0,    0,  190,  190,  190,  190,  190,    0,  190,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  190,  190,  190,    0,  190,  190,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   42,   42,   42,    0,    0,   42,
   42,   42,  192,   42,    0,  190,  190,    0,    0,    0,
    0,    0,  192,   42,    0,    0,    0,    0,    0,    0,
    0,    0,   42,   42,    0,   42,   42,   42,   42,   42,
    0,    0,    0,    0,    0,    0,  190,  190,    0,  192,
  192,    0,    0,  192,  192,  192,  192,  192,    0,  192,
  174,  174,  174,    0,    0,    0,  174,  174,    0,  174,
  192,  192,  192,    0,  192,  192,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  174,  174,
    0,  174,  174,  174,  174,  189,  189,  189,    0,    0,
  189,  189,  189,    0,  189,  192,  192,    0,    0,    0,
    0,    0,    0,    0,  189,  189,    0,    0,    0,    0,
    0,    0,    0,  189,  189,    0,  189,  189,  189,  189,
  189,    0,    0,    0,    0,    0,  192,  192,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  189,  189,  189,  189,  189,  189,  189,  189,
  189,  189,  189,  189,  193,    0,  189,  189,    0,    0,
    0,  189,    0,    0,  193,    0,    0,  189,    0,    0,
    0,    0,    0,    0,  190,  190,  190,    0,    0,  190,
  190,  190,    0,  190,    0,    0,    0,    0,    0,    0,
    0,  193,  193,  190,  190,  193,  193,  193,  193,  193,
    0,  193,  190,  190,    0,  190,  190,  190,  190,  190,
    0,    0,  193,  193,  193,    0,  193,  193,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  190,  190,  190,  190,  190,  190,  190,  190,  190,
  190,  190,  190,    0,  186,  190,  190,  193,  193,    0,
  190,    0,    0,    0,  186,    0,  190,    0,    0,    0,
    0,    0,    0,    0,  192,  192,  192,    0,    0,  192,
  192,  192,    0,  192,    0,    0,    0,    0,  193,  193,
    0,    0,  186,  192,  192,  186,    0,  186,  186,  186,
    0,    0,  192,  192,    0,  192,  192,  192,  192,  192,
    0,    0,  186,  186,  186,    0,  186,  186,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  192,  192,  192,  192,  192,  192,  192,  192,  192,
  192,  192,  192,  187,    0,  192,  192,  186,  186,    0,
  192,    0,    0,  187,    0,    0,  192,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  186,  186,
    0,  187,    0,    0,  187,    0,  187,  187,  187,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  187,  187,  187,    0,  187,  187,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  193,  193,  193,    0,
    0,  193,  193,  193,    0,  193,  187,  187,    0,    0,
    0,    0,    0,    0,    0,  193,  193,    0,    0,    0,
    0,    0,    0,    0,  193,  193,    0,  193,  193,  193,
  193,  193,    0,    0,    0,    0,    0,  187,  187,  211,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  211,
    0,    0,    0,  193,  193,  193,  193,  193,  193,  193,
  193,  193,  193,  193,  193,    0,    0,  193,  193,    0,
    0,    0,  193,    0,    0,    0,    0,  211,  193,    0,
  211,    0,    0,  211,    0,    0,  186,  186,  186,    0,
    0,  186,  186,  186,    0,  186,    0,  211,  211,  211,
    0,  211,  211,    0,    0,  186,  186,    0,    0,    0,
    0,    0,    0,    0,  186,  186,    0,  186,  186,  186,
  186,  186,    0,    0,    0,    0,    0,    0,  212,    0,
    0,    0,  211,  211,    0,    0,    0,    0,  212,    0,
    0,    0,    0,  186,  186,  186,  186,  186,  186,  186,
  186,  186,  186,  186,  186,    0,    0,  186,  186,    0,
    0,    0,  186,  211,  211,    0,  212,    0,  186,  212,
    0,    0,  212,    0,    0,  187,  187,  187,    0,    0,
  187,  187,  187,    0,  187,    0,  212,  212,  212,    0,
  212,  212,    0,    0,  187,  187,    0,    0,    0,    0,
    0,    0,    0,  187,  187,    0,  187,  187,  187,  187,
  187,    0,    0,    0,    0,    0,    0,    0,  198,    0,
    0,  212,  212,    0,    0,    0,    0,    0,  198,    0,
    0,    0,  187,  187,  187,  187,  187,  187,  187,  187,
  187,  187,  187,  187,    0,    0,  187,  187,    0,    0,
    0,  187,  212,  212,    0,    0,  198,  187,    0,  198,
    0,    0,  198,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  198,  198,  198,    0,
  198,  198,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  211,  211,  211,    0,    0,  211,  211,  211,    0,
  211,  198,  198,    0,    0,    0,    0,    0,    0,    0,
  211,  211,    0,    0,    0,    0,    0,    0,    0,  211,
  211,    0,  211,  211,  211,  211,  211,    0,    0,    0,
    0,    0,  198,  198,  196,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  196,    0,    0,    0,  211,  211,
  211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
    0,    0,  211,  211,    0,    0,    0,  211,    0,    0,
    0,    0,    0,  211,    0,  196,    0,    0,  196,    0,
  212,  212,  212,    0,    0,  212,  212,  212,    0,  212,
    0,    0,  196,  196,  196,    0,  196,  196,    0,  212,
  212,    0,    0,    0,    0,    0,    0,    0,  212,  212,
    0,  212,  212,  212,  212,  212,    0,    0,    0,    0,
    0,    0,    0,  197,    0,    0,    0,  196,  196,    0,
    0,    0,    0,  197,    0,    0,    0,  212,  212,  212,
  212,  212,  212,  212,  212,  212,  212,  212,  212,    0,
    0,  212,  212,    0,    0,    0,  212,    0,  196,  196,
    0,    0,  212,    0,  197,    0,    0,  197,    0,    0,
  198,  198,  198,    0,    0,  198,  198,  198,    0,  198,
    0,  197,  197,  197,    0,  197,  197,    0,    0,  198,
  198,    0,    0,    0,    0,    0,    0,    0,  198,  198,
    0,  198,  198,  198,  198,  198,    0,    0,    0,    0,
    0,    0,    0,  201,    0,    0,  197,  197,    0,    0,
    0,    0,    0,  201,    0,    0,    0,  198,  198,  198,
  198,  198,  198,  198,  198,  198,  198,  198,  198,    0,
    0,    0,    0,    0,    0,    0,  198,  197,  197,    0,
    0,    0,  198,    0,  201,    0,    0,  201,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  201,  201,  201,    0,  201,  201,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  196,  196,  196,    0,
    0,  196,  196,  196,    0,  196,  201,  203,    0,    0,
    0,    0,    0,    0,    0,  196,  196,  203,    0,    0,
    0,    0,    0,    0,  196,  196,    0,  196,  196,  196,
  196,  196,    0,    0,    0,    0,    0,    0,  201,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  203,    0,
    0,  203,    0,  196,  196,  196,  196,  196,  196,  196,
  196,  196,  196,  196,  196,  203,  203,  203,    0,  203,
  203,    0,  196,    0,    0,    0,    0,    0,  196,    0,
    0,    0,    0,    0,    0,  197,  197,  197,    0,    0,
  197,  197,  197,    0,  197,    0,  200,    0,    0,    0,
  203,    0,    0,    0,  197,  197,  200,    0,    0,    0,
    0,    0,    0,  197,  197,    0,  197,  197,  197,  197,
  197,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  203,    0,    0,    0,    0,  200,    0,    0,
  200,    0,  197,  197,  197,  197,  197,  197,  197,  197,
  197,  197,  197,  197,  200,  200,  200,    0,  200,  200,
    0,  197,    0,    0,    0,    0,    0,  197,    0,    0,
    0,    0,    0,    0,    0,  201,  201,  201,    0,    0,
  201,  201,  201,    0,  201,    0,  202,    0,    0,  200,
    0,    0,    0,    0,  201,  201,  202,    0,    0,    0,
    0,    0,    0,  201,  201,    0,  201,  201,  201,  201,
  201,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  200,    0,    0,    0,    0,    0,  202,    0,    0,
  202,    0,  201,  201,  201,  201,  201,  201,  201,  201,
  201,  201,  201,  201,  202,  202,  202,    0,  202,  202,
    0,  201,    0,    0,    0,    0,    0,  201,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  203,
  203,  203,    0,    0,  203,  203,  203,    0,  203,  202,
  199,    0,    0,    0,    0,    0,    0,    0,  203,  203,
  199,    0,    0,    0,    0,    0,    0,  203,  203,    0,
  203,  203,  203,  203,  203,    0,    0,    0,    0,    0,
    0,  202,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  199,    0,    0,  199,    0,  203,  203,  203,  203,
  203,  203,  203,  203,  203,  203,  203,  203,  199,  199,
    0,    0,    0,  199,    0,  203,    0,    0,    0,    0,
    0,  203,    0,    0,    0,    0,    0,    0,  200,  200,
  200,    0,    0,  200,  200,  200,    0,  200,    0,  204,
    0,    0,    0,  199,    0,    0,    0,  200,  200,  204,
    0,    0,    0,    0,    0,    0,  200,  200,    0,  200,
  200,  200,  200,  200,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  199,    0,    0,    0,    0,
  204,    0,    0,  204,    0,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  204,  204,    0,
    0,    0,  204,    0,  200,    0,    0,    0,    0,    0,
  200,    0,    0,    0,    0,    0,    0,    0,  202,  202,
  202,    0,    0,  202,  202,  202,    0,  202,    0,  205,
    0,    0,  204,    0,    0,    0,    0,  202,  202,  205,
    0,    0,    0,    0,    0,    0,  202,  202,    0,  202,
  202,  202,  202,  202,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  204,    0,    0,    0,    0,    0,
  205,    0,    0,  205,    0,  202,  202,  202,  202,  202,
  202,  202,  202,  202,  202,  202,  202,  205,  205,    0,
    0,    0,  205,    0,  202,    0,    0,    0,    0,    0,
  202,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  199,  199,  199,    0,    0,  199,  199,  199,
    0,  199,  205,  206,    0,    0,    0,    0,    0,    0,
    0,  199,  199,  206,    0,    0,    0,    0,    0,    0,
  199,  199,    0,  199,  199,  199,  199,  199,    0,    0,
    0,    0,    0,    0,  205,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  206,    0,    0,  206,    0,    0,
    0,    0,    0,    0,    0,  199,  199,    0,    0,  199,
  199,  206,  206,    0,    0,    0,  206,    0,  199,    0,
    0,    0,    0,    0,  199,    0,    0,    0,    0,    0,
    0,  204,  204,  204,    0,    0,  204,  204,  204,    0,
  204,    0,  213,    0,    0,    0,  206,    0,    0,    0,
  204,  204,  213,    0,    0,    0,    0,    0,    0,  204,
  204,    0,  204,  204,  204,  204,  204,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  206,    0,
    0,    0,    0,  213,    0,    0,  213,    0,    0,    0,
    0,    0,    0,    0,  204,  204,    0,    0,  204,  204,
  213,  213,    0,    0,    0,  213,    0,  204,    0,    0,
    0,    0,    0,  204,    0,    0,    0,    0,    0,    0,
    0,  205,  205,  205,    0,    0,  205,  205,  205,    0,
  205,    0,  207,    0,    0,  213,    0,    0,    0,    0,
  205,  205,  207,    0,    0,    0,    0,    0,    0,  205,
  205,    0,  205,  205,  205,  205,  205,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  213,    0,    0,
    0,    0,    0,  207,    0,    0,  207,    0,    0,    0,
    0,    0,    0,    0,  205,  205,    0,    0,  205,  205,
  207,  207,    0,    0,    0,  207,    0,  205,    0,    0,
    0,    0,    0,  205,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  206,  206,  206,    0,    0,
  206,  206,  206,    0,  206,  207,  208,    0,    0,    0,
    0,    0,    0,    0,  206,  206,  208,    0,    0,    0,
    0,    0,    0,  206,  206,    0,  206,  206,  206,  206,
  206,    0,    0,    0,    0,    0,    0,  207,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  208,    0,    0,
  208,    0,    0,    0,    0,    0,    0,    0,  206,  206,
    0,    0,  206,  206,  208,  208,    0,    0,    0,  208,
    0,  206,    0,    0,    0,    0,    0,  206,    0,    0,
    0,    0,    0,    0,  213,  213,  213,    0,    0,  213,
  213,  213,    0,  213,    0,  214,    0,    0,    0,  208,
    0,    0,    0,  213,  213,  214,    0,    0,    0,    0,
    0,    0,  213,  213,    0,  213,  213,  213,  213,  213,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  208,    0,    0,    0,    0,  214,    0,    0,  214,
    0,    0,    0,    0,    0,    0,    0,  213,  213,    0,
    0,  213,  213,  214,  214,    0,    0,    0,  214,    0,
  213,    0,    0,    0,    0,    0,  213,    0,    0,    0,
    0,    0,    0,    0,  207,  207,  207,    0,    0,  207,
  207,  207,    0,  207,    0,  184,    0,    0,  214,    0,
    0,    0,    0,  207,  207,  184,    0,    0,    0,    0,
    0,    0,  207,  207,    0,  207,  207,  207,  207,  207,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  214,  185,    0,    0,    0,    0,  184,    0,    0,  184,
    0,  185,    0,    0,    0,    0,    0,  207,  207,    0,
    0,  207,  207,  184,  184,    0,    0,    0,  184,    0,
  207,    0,    0,    0,    0,    0,  207,    0,    0,    0,
    0,    0,  185,    0,    0,  185,    0,    0,  208,  208,
  208,    0,    0,  208,  208,  208,    0,  208,  184,  185,
  185,  176,    0,    0,  185,    0,    0,  208,  208,    0,
    0,  176,    0,    0,    0,    0,  208,  208,    0,  208,
  208,  208,  208,  208,    0,    0,    0,    0,    0,    0,
  184,    0,    0,    0,  185,    0,    0,    0,    0,    0,
    0,    0,  176,    0,    0,  176,    0,    0,    0,    0,
    0,  208,  208,    0,    0,  208,  208,    0,    0,  176,
  176,    0,    0,    0,  208,    0,  185,    0,    0,    0,
  208,    0,    0,    0,    0,    0,    0,  214,  214,  214,
    0,    0,  214,  214,  214,    0,  214,    0,  183,    0,
    0,    0,    0,    0,  176,    0,  214,  214,  183,    0,
    0,    0,    0,    0,    0,  214,  214,    0,  214,  214,
  214,  214,  214,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  176,    0,    0,  183,
    0,    0,  183,    0,    0,    0,    0,    0,    0,    0,
    0,  214,    0,    0,  214,  214,  183,  183,  216,    0,
    0,    0,    0,  214,    0,    0,    0,    0,  216,  214,
    0,    0,    0,    0,    0,    0,    0,  184,  184,  184,
    0,    0,  184,  184,  184,    0,  184,    0,    0,    0,
    0,  183,    0,    0,    0,    0,  184,  184,    0,  216,
    0,    0,  216,    0,    0,  184,  184,    0,  184,  184,
  184,  184,  184,  185,  185,  185,  216,  216,  185,  185,
  185,    0,  185,  183,    0,    0,  182,    0,    0,    0,
    0,    0,  185,  185,    0,    0,  182,    0,    0,    0,
    0,  185,  185,    0,  185,  185,  185,  185,  185,    0,
    0,  216,    0,  184,    0,    0,    0,    0,    0,  184,
    0,    0,    0,    0,    0,    0,    0,  182,    0,    0,
  182,    0,    0,  176,  176,  176,    0,    0,  176,  176,
  176,  217,  176,  216,  182,  182,    0,    0,    0,  185,
    0,  217,  176,  176,    0,  185,    0,    0,    0,    0,
    0,  176,  176,    0,  176,  176,  176,  176,  176,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  182,
    0,    0,  217,    0,    0,  217,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  217,
  217,    0,  180,    0,    0,    0,    0,    0,    0,  176,
    0,  182,  180,    0,    0,  176,    0,    0,    0,    0,
  183,  183,  183,    0,    0,  183,  183,  183,    0,  183,
    0,    0,    0,    0,  217,    0,    0,    0,    0,  183,
  183,    0,    0,  180,    0,    0,  180,    0,  183,  183,
    0,  183,  183,  183,  183,  183,    0,    0,    0,    0,
  180,  180,    0,    0,    0,    0,  217,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  216,  216,  216,    0,    0,  216,  216,  216,    0,  216,
    0,    0,    0,  181,    0,  180,  183,    0,    0,  216,
  216,    0,  183,  181,    0,    0,    0,    0,  216,  216,
    0,  216,  216,  216,  216,  216,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  180,    0,    0,
    0,    0,    0,    0,  181,    0,    0,  181,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  182,  182,
  182,  181,  181,  182,  182,  182,  216,  182,    0,    0,
    0,    0,  216,    0,    0,    0,    0,  182,  182,    0,
    0,    0,    0,    0,    0,    0,  182,  182,    0,  182,
  182,  182,  182,  182,  178,    0,  181,    0,    0,    0,
    0,    0,    0,    0,  178,    0,    0,    0,    0,    0,
    0,    0,    0,  217,  217,  217,    0,    0,  217,  217,
  217,    0,  217,    0,    0,    0,    0,    0,  181,    0,
    0,    0,  217,  217,  182,  178,    0,    0,  178,    0,
  182,  217,  217,    0,  217,  217,  217,  217,  217,    0,
    0,    0,  178,  178,    0,  179,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  179,    0,    0,    0,    0,
    0,    0,    0,    0,  180,  180,  180,    0,    0,  180,
  180,  180,    0,  180,    0,    0,    0,  178,    0,  217,
    0,    0,    0,  180,  180,  217,  179,    0,    0,  179,
    0,    0,  180,  180,    0,  180,  180,  180,  180,  180,
  175,    0,    0,  179,  179,    0,    0,    0,    0,  178,
  175,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  177,  179,    0,
  180,  175,    0,    0,  175,    0,  180,  177,    0,    0,
    0,    0,    0,    0,    0,  181,  181,  181,  175,  175,
  181,  181,  181,    0,  181,    0,    0,    0,    0,    0,
  179,    0,    0,    0,  181,  181,    0,    0,  177,    0,
    0,  177,    0,  181,  181,    0,  181,  181,  181,  181,
  181,    0,    0,  175,    0,  177,  177,    0,  174,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  174,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  175,    0,    0,    0,    0,
  177,  181,    0,    0,    0,    0,    0,  181,    0,  174,
    0,    0,  174,    0,    0,    0,  178,  178,  178,    0,
    0,  178,  178,  178,    0,  178,  174,  174,    0,    0,
    0,    0,  177,    0,    0,  178,  178,    0,    0,    0,
    0,    0,    0,    0,  178,  178,    0,  178,  178,  178,
  178,  178,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  174,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  179,  179,  179,
    0,    0,  179,  179,  179,    0,  179,    0,    0,    0,
    0,    0,  178,  174,    0,    0,  179,  179,  178,    0,
    0,    0,    0,    0,    0,  179,  179,    0,  179,  179,
  179,  179,  179,    0,    0,    0,    0,    0,    0,    0,
    0,   47,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   47,  175,  175,  175,    0,    0,  175,  175,  175,
    0,  175,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  175,  175,  179,    0,    0,    0,    0,    0,  179,
  175,  175,   47,  175,  175,  175,  175,  175,    0,  177,
  177,  177,    0,    0,  177,  177,  177,    0,  177,   47,
   47,    0,    0,    0,    0,    0,    0,    0,  177,  177,
    0,    0,    0,    0,    0,    0,    0,  177,  177,    0,
  177,  177,  177,  177,  177,    0,    0,    0,  175,    0,
    0,    0,    0,    0,  175,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  322,    0,
  174,  174,  174,    0,    0,  174,  174,  174,  322,  174,
    0,    0,    0,    0,    0,  177,   47,    0,    0,  174,
  174,  177,    0,    0,    0,    0,    0,    0,  174,  174,
    0,  174,  174,  174,  174,  322,  322,    0,    0,  322,
  322,  322,  322,  322,  322,  322,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  322,  322,  322,    0,
  322,  322,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  174,    0,    0,    0,
    0,    0,  174,  323,    0,    0,    0,    0,    0,  322,
    0,    0,  322,  323,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  323,  323,  322,  322,  323,  323,  323,  323,  323,  323,
  323,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  323,  323,  323,    0,  323,  323,    0,    0,    0,
    0,    0,    0,   47,   47,   47,    0,    0,   47,   47,
   47,    0,   47,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   47,    0,  323,    0,    0,  323,    0,  287,
    0,   47,   47,    0,   47,   47,   47,   47,   47,  287,
   41,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   41,    0,    0,    0,    0,    0,    0,  323,  323,    0,
    0,    0,    0,    0,    0,    0,  287,  287,    0,    0,
  287,  287,  287,  287,  287,  287,  287,    0,    0,    0,
    0,   41,    0,    0,    0,    0,    0,  287,  287,  287,
    0,  287,  287,    0,    0,    0,    0,    0,   41,   41,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  322,  322,  322,    0,    0,  322,  322,  322,    0,  322,
  287,    0,    0,  287,    0,    0,    0,    0,    0,  322,
    0,    0,    0,    0,    0,    0,    0,    0,  322,  322,
    0,  322,  322,  322,  322,  322,    0,    0,    0,    0,
    0,    0,    0,  287,  287,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   41,  322,  322,  322,  322,
  322,  322,  322,  322,  322,  322,  322,  322,  322,    0,
    0,  322,  322,  322,    0,    0,  322,    0,    0,    0,
    0,    0,    0,    0,    0,  323,  323,  323,    0,    0,
  323,  323,  323,    0,  323,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  323,    0,    0,    0,    0,    0,
    0,    0,    0,  323,  323,    0,  323,  323,  323,  323,
  323,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  323,  323,  323,  323,  323,  323,  323,  323,  323,
  323,  323,  323,  323,    0,    0,  323,  323,  323,    0,
    0,  323,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  287,  287,  287,    0,    0,  287,  287,  287,    0,
  287,    0,   41,   41,   41,    0,    0,   41,   41,   41,
  287,   41,    0,    0,    0,    0,    0,    0,    0,  287,
  287,   41,  287,  287,  287,  287,  287,    0,  430,    0,
    0,    0,    0,   41,   41,   41,   41,   41,  430,    0,
    0,    0,    0,    0,    0,    0,    0,  287,  287,  287,
  287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
    0,    0,  287,  287,  287,  430,  430,  287,    0,  430,
  430,  430,   75,  430,  430,  430,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  430,  430,   83,
  430,  430,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  275,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  275,    0,    0,    0,    0,  430,
    0,    0,  430,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  275,  275,    0,    0,  275,  275,  275,   82,  275,
  275,  275,  430,  430,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  275,  275,   90,  275,  275,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  283,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  283,    0,
    0,    0,    0,    0,    0,  275,    0,    0,  275,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  283,  283,    0,    0,  283,
  283,  283,   81,  283,  283,  283,    0,    0,  275,  275,
    0,    0,    0,    0,    0,    0,    0,  283,  283,   89,
  283,  283,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  283,
    0,    0,  283,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  430,  430,  430,    0,    0,    0,  430,  430,    0,  430,
    0,    0,  283,  283,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  430,  430,
    0,  430,  430,  430,  430,  430,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  430,  430,  430,  430,
  430,  430,  430,  430,  430,  430,  430,  430,  430,    0,
    0,  430,  430,  430,    0,  431,  275,  275,  275,    0,
    0,   58,  275,  275,    0,  275,    0,    0,    0,  333,
  328,    0,    0,    0,  331,  329,  604,  330,    0,  332,
    0,    0,    0,    0,  275,  275,    0,  275,  275,  275,
  275,  275,  325,    0,  324,  323,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  275,  275,  275,  275,  275,  275,  275,  275,
  275,  275,  275,  275,  275,    0,  327,  275,  275,  275,
  283,  283,  283,    0,    0,    0,  283,  283,    0,  283,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   59,    0,  326,    0,  283,  283,
    0,  283,  283,  283,  283,  283,    0,  284,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  284,    0,    0,
    0,    0,    0,    0,    0,    0,  283,  283,  283,  283,
  283,  283,  283,  283,  283,  283,  283,  283,  283,    0,
    0,  283,  283,  283,  284,  284,    0,    0,  284,  284,
  284,   76,  284,  284,  284,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  284,  284,   84,  284,
  284,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  284,    0,
    0,  284,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   58,    0,    0,    3,    4,    5,    6,    7,    8,
    0,  284,  284,    9,   10,    0,    0,    0,   11,    0,
   12,   13,   14,   15,   16,   17,   18,  394,    0,    0,
    0,   19,   20,   21,   22,   23,   24,   25,    0,    0,
   26,    0,    0,    0,    0,    0,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
    0,   41,   42,    0,   43,   44,    0,    0,    0,    0,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,    0,   45,  321,  322,  260,   47,    0,
   48,   49,    0,   50,   59,   51,   52,   53,   54,   55,
   56,    0,   58,    0,    0,   57,    0,  333,  328,    0,
    0,    0,  331,  329,    0,  330,    0,  332,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  325,    0,  324,  323,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  284,
  284,  284,    0,    0,    0,  284,  284,    0,  284,    0,
    0,    0,    0,    0,  327,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  284,  284,    0,
  284,  284,  284,  284,  284,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  326,   59,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  284,  284,  284,  284,  284,
  284,  284,  284,  284,  284,  284,  284,  284,    0,    0,
  284,  284,  284,    0,    0,    4,    5,    6,    7,    8,
    0,  232,    0,    9,   10,    0,    0,    0,   11,  410,
   12,   13,   14,   15,   16,   17,   18,    0,    0,    0,
    0,   19,   20,   21,   22,   23,   24,   25,    0,    0,
   26,    0,    0,    0,    0,    0,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
    0,   41,   42,    0,   43,   44,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   45,    0,    0,   46,   47,    0,
   48,   49,    0,   50,    0,   51,   52,   53,   54,   55,
   56,    0,    0,    0,   59,   57,    4,    5,    6,    7,
    8,    0,   58,    0,    9,   10,    0,    0,    0,   11,
    0,   12,   13,   14,   15,   16,   17,   18,    0,    0,
    0,    0,   19,   20,   21,   22,   23,   24,   25,    0,
    0,   26,    0,    0,    0,    0,    0,   27,   28,   29,
   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   40,    0,   41,   42,    0,   43,   44,    0,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
  320,    0,    0,  321,  322,   45,    0,    0,   46,   47,
    0,   48,   49,    0,   50,    0,   51,   52,   53,   54,
   55,   56,    0,    0,    0,   59,   57,    0,    0,  232,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    4,    5,    6,    0,    8,
    0,    0,    0,    9,   10,    0,    0,    0,   11,    0,
   12,   13,   14,   96,   97,   17,   18,    0,    0,    0,
    0,   98,   20,   21,   22,   23,   24,   25,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   28,    0,    0,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
    0,   41,   42,    0,   43,   44,    0,    0,    0,    0,
    0,    0,   59,    0,    0,    0,  232,    0,    0,    0,
    0,    0,    0,    0,  206,    0,    0,  106,   47,    0,
   48,   49,    0,  230,  231,   51,   52,   53,   54,   55,
   56,    0,    0,    0,    0,   57,    4,    5,    6,    0,
    8,    0,    0,    0,    9,   10,    0,    0,    0,   11,
    0,   12,   13,   14,   15,   16,   17,   18,    0,    0,
    0,    0,   19,   20,   21,   22,   23,   24,   25,    0,
    0,   26,    0,    0,    0,    0,    0,    0,   28,    0,
    0,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   40,    0,   41,   42,    0,   43,   44,    0,    0,   59,
    0,    0,    0,  232,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  206,    0,    0,  106,   47,
    0,   48,   49,    0,  615,  231,   51,   52,   53,   54,
   55,   56,    0,    4,    5,    6,   57,    8,    0,    0,
    0,    9,   10,    0,    0,    0,   11,    0,   12,   13,
   14,   96,   97,   17,   18,    0,    0,    0,    0,   98,
   20,   21,   22,   23,   24,   25,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   28,    0,    0,   31,   32,
   33,   34,   35,   36,   37,   38,   39,   40,    0,   41,
   42,    0,   43,   44,    0,    0,   59,    0,    0,    0,
  232,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  206,    0,    0,  106,   47,    0,   48,   49,
    0,  230,  231,   51,   52,   53,   54,   55,   56,    0,
    4,    5,    6,   57,    8,    0,    0,    0,    9,   10,
    0,    0,    0,   11,    0,   12,   13,   14,   96,   97,
   17,   18,    0,    0,    0,    0,   98,   20,   21,   22,
   23,   24,   25,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   28,    0,    0,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,    0,   41,   42,    0,   43,
   44,    0,    0,   59,    0,    0,    0,  232,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  206,
    0,    0,  106,  412,    0,   48,   49,    0,  230,  231,
   51,   52,   53,   54,   55,   56,    0,    4,    5,    6,
   57,    8,    0,    0,    0,    9,   10,    0,    0,    0,
   11,    0,   12,   13,   14,   96,   97,   17,   18,    0,
    0,    0,    0,   98,   99,  100,   22,   23,   24,   25,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   28,
    0,    0,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,    0,   41,   42,    0,   43,   44,    0,    0,
   59,    0,    0,    0,  232,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  206,    0,    0,  106,
   47,    0,   48,   49,    0,  607,  231,   51,   52,   53,
   54,   55,   56,    0,    4,    5,    6,   57,    8,    0,
    0,    0,    9,   10,    0,    0,    0,   11,    0,   12,
   13,   14,   96,   97,   17,   18,    0,    0,    0,    0,
   98,   99,  100,   22,   23,   24,   25,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   28,    0,    0,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,    0,
   41,   42,    0,   43,   44,    0,    0,   59,    0,    0,
    0,  232,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  206,    0,    0,  106,   47,    0,   48,
   49,    0,  611,  231,   51,   52,   53,   54,   55,   56,
    0,    4,    5,    6,   57,    8,    0,    0,    0,    9,
   10,    0,    0,    0,   11,    0,   12,   13,   14,   96,
   97,   17,   18,    0,    0,    0,    0,   98,   20,   21,
   22,   23,   24,   25,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   28,    0,    0,   31,   32,   33,   34,
   35,   36,   37,   38,   39,   40,    0,   41,   42,    0,
   43,   44,    0,    0,   59,    0,    0,    0,  232,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  206,    0,    0,  106,   47,    0,   48,   49,    0,  607,
  231,   51,   52,   53,   54,   55,   56,    0,    4,    5,
    6,   57,    8,    0,    0,    0,    9,   10,    0,    0,
    0,   11,    0,   12,   13,   14,   96,   97,   17,   18,
    0,    0,    0,    0,   98,   99,  100,   22,   23,   24,
   25,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   28,    0,    0,   31,   32,   33,   34,   35,   36,   37,
   38,   39,   40,    0,   41,   42,    0,   43,   44,    0,
    0,   59,    0,    0,    0,  232,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  206,    0,    0,
  106,   47,    0,   48,   49,    0,  802,  231,   51,   52,
   53,   54,   55,   56,    0,    4,    5,    6,   57,    8,
    0,    0,    0,    9,   10,    0,    0,    0,   11,    0,
   12,   13,   14,   96,   97,   17,   18,    0,    0,    0,
    0,   98,   99,  100,   22,   23,   24,   25,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   28,    0,    0,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
    0,   41,   42,    0,   43,   44,    0,    0,   59,    0,
    0,    0,  232,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  206,    0,    0,  106,   47,    0,
   48,   49,    0,  805,  231,   51,   52,   53,   54,   55,
   56,    0,    4,    5,    6,   57,    8,    0,    0,    0,
    9,   10,    0,    0,    0,   11,    0,   12,   13,   14,
   96,   97,   17,   18,    0,    0,    0,    0,   98,   99,
  100,   22,   23,   24,   25,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   28,    0,    0,   31,   32,   33,
   34,   35,   36,   37,   38,   39,   40,    0,   41,   42,
    0,   43,   44,    0,    0,   59,    0,    0,    0,  232,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  206,    0,    0,  106,   47,    0,   48,   49,    0,
  810,  231,   51,   52,   53,   54,   55,   56,    0,    4,
    5,    6,   57,    8,    0,    0,    0,    9,   10,    0,
    0,    0,   11,    0,   12,   13,   14,   96,   97,   17,
   18,    0,    0,    0,    0,   98,   99,  100,   22,   23,
   24,   25,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   28,    0,    0,   31,   32,   33,   34,   35,   36,
   37,   38,   39,   40,    0,   41,   42,    0,   43,   44,
    0,    0,   59,    0,    0,    0,  253,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  206,    0,
    0,  106,   47,    0,   48,   49,    0,  869,  231,   51,
   52,   53,   54,   55,   56,    0,    4,    5,    6,   57,
    8,    0,    0,    0,    9,   10,    0,    0,    0,   11,
    0,   12,   13,   14,   96,   97,   17,   18,    0,    0,
    0,    0,   98,   99,  100,   22,   23,   24,   25,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   28,    0,
    0,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   40,    0,   41,   42,    0,   43,   44,    0,    0,  253,
    0,    0,    0,   58,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  206,    0,    0,  106,   47,
    0,   48,   49,    0,  871,  231,   51,   52,   53,   54,
   55,   56,    0,    4,    5,    6,   57,    8,    0,    0,
    0,    9,   10,    0,    0,    0,   11,    0,   12,   13,
   14,   96,   97,   17,   18,    0,    0,    0,    0,   98,
   99,  100,   22,   23,   24,   25,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   28,    0,    0,   31,   32,
   33,   34,   35,   36,   37,   38,   39,   40,    0,   41,
   42,    0,   43,   44,    0,    0,   59,    0,    0,    0,
  232,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  206,    0,    0,  106,   47,    0,   48,   49,
    0,  890,  231,   51,   52,   53,   54,   55,   56,    0,
  253,  253,  253,   57,  253,    0,    0,    0,  253,  253,
    0,    0,    0,  253,    0,  253,  253,  253,  253,  253,
  253,  253,    0,    0,    0,    0,  253,  253,  253,  253,
  253,  253,  253,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  253,    0,    0,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,    0,  253,  253,    0,  253,
  253,    0,    0,   59,    0,    0,    0,  232,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  253,
    0,    0,  253,  253,    0,  253,  253,    0,  253,  253,
  253,  253,  253,  253,  253,  253,    0,    4,    5,    6,
  253,    8,    0,    0,    0,    9,   10,    0,    0,    0,
   11,    0,   12,   13,   14,   15,   16,   17,   18,    0,
    0,    0,    0,   19,   20,   21,   22,   23,   24,   25,
    0,    0,   26,    0,    0,    0,    0,    0,    0,   28,
    0,    0,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,    0,   41,   42,    0,   43,   44,    0,    0,
   59,    0,    0,    0,  232,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  206,    0,    0,  106,
   47,    0,   48,   49,    0,    0,    0,   51,   52,   53,
   54,   55,   56,    0,    4,    5,    6,   57,    8,    0,
    0,    0,    9,   10,    0,    0,    0,   11,    0,   12,
   13,   14,   96,   97,   17,   18,    0,    0,    0,    0,
   98,   20,   21,   22,   23,   24,   25,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   28,    0,    0,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,    0,
   41,   42,    0,   43,   44,    0,    0,   59,    0,    0,
    0,  232,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  206,    0,    0,  106,   47,    0,   48,
   49,    0,  265,    0,   51,   52,   53,   54,   55,   56,
    0,    4,    5,    6,   57,    8,    0,    0,    0,    9,
   10,    0,    0,    0,   11,    0,   12,   13,   14,   15,
   16,   17,   18,    0,    0,    0,    0,   19,   20,   21,
   22,   23,   24,   25,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   28,    0,    0,   31,   32,   33,   34,
   35,   36,   37,   38,   39,   40,    0,   41,   42,    0,
   43,   44,    0,    0,   59,    0,    0,    0,  232,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  206,    0,    0,  106,   47,    0,   48,   49,    0,  526,
    0,   51,   52,   53,   54,   55,   56,    0,    4,    5,
    6,   57,    8,    0,    0,    0,    9,   10,    0,    0,
    0,   11,    0,   12,   13,   14,   96,   97,   17,   18,
    0,    0,    0,    0,   98,   99,  100,   22,   23,   24,
   25,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   28,    0,    0,   31,   32,   33,   34,   35,   36,   37,
   38,   39,   40,    0,   41,   42,    0,   43,   44,    0,
    0,   59,    0,    0,    0,  232,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  206,    0,    0,
  106,   47,    0,   48,   49,    0,  589,    0,   51,   52,
   53,   54,   55,   56,    0,    4,    5,    6,   57,    8,
    0,    0,    0,    9,   10,    0,    0,    0,   11,    0,
   12,   13,   14,   96,   97,   17,   18,    0,    0,    0,
    0,   98,   99,  100,   22,   23,   24,   25,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   28,    0,    0,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
    0,   41,   42,    0,   43,   44,    0,    0,   59,    0,
    0,    0,  232,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  206,    0,    0,  106,   47,    0,
   48,   49,    0,  637,    0,   51,   52,   53,   54,   55,
   56,    0,    4,    5,    6,   57,    8,    0,    0,    0,
    9,   10,    0,    0,    0,   11,    0,   12,   13,   14,
   96,   97,   17,   18,    0,    0,    0,    0,   98,   99,
  100,   22,   23,   24,   25,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   28,    0,    0,   31,   32,   33,
   34,   35,   36,   37,   38,   39,   40,    0,   41,   42,
    0,   43,   44,    0,    0,   59,    0,    0,    0,  491,
    0,    0,    0,    0,    0,    0,  491,    0,    0,    0,
    0,  206,    0,    0,  106,   47,    0,   48,   49,    0,
  526,    0,   51,   52,   53,   54,   55,   56,    0,    4,
    5,    6,   57,    8,    0,    0,    0,    9,   10,    0,
    0,    0,   11,    0,   12,   13,   14,   96,   97,   17,
   18,    0,    0,    0,    0,   98,   99,  100,   22,   23,
   24,   25,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   28,    0,    0,   31,   32,   33,   34,   35,   36,
   37,   38,   39,   40,    0,   41,   42,    0,   43,   44,
    0,    0,  491,    0,    0,    0,  232,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  206,    0,
    0,  106,   47,    0,   48,   49,    0,  767,    0,   51,
   52,   53,   54,   55,   56,    0,    4,    5,    6,   57,
    8,    0,    0,    0,    9,   10,    0,    0,    0,   11,
    0,   12,   13,   14,   96,   97,   17,   18,    0,    0,
    0,    0,   98,   99,  100,   22,   23,   24,   25,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   28,    0,
    0,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   40,    0,   41,   42,    0,   43,   44,    0,    0,   59,
    0,    0,    0,  232,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  206,    0,    0,  106,   47,
    0,   48,   49,    0,  796,    0,   51,   52,   53,   54,
   55,   56,    0,  491,  491,  491,   57,  491,    0,    0,
    0,  491,  491,    0,    0,    0,  491,    0,  491,  491,
  491,  491,  491,  491,  491,    0,    0,    0,    0,  491,
  491,  491,  491,  491,  491,  491,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  491,    0,    0,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,    0,  491,
  491,    0,  491,  491,    0,    0,   59,    0,    0,    0,
  215,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  491,    0,    0,  491,  491,    0,  491,  491,
    0,    0,    0,  491,  491,  491,  491,  491,  491,    0,
    4,    5,    6,  491,    8,    0,    0,    0,    9,   10,
    0,    0,    0,   11,    0,   12,   13,   14,   96,   97,
   17,   18,    0,    0,    0,    0,   98,   99,  100,   22,
   23,   24,   25,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   28,    0,    0,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,    0,   41,   42,    0,   43,
   44,    0,    0,  215,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  206,
    0,    0,  106,   47,    0,   48,   49,    0,    0,    0,
   51,   52,   53,   54,   55,   56,    0,    4,    5,    6,
   57,    8,    0,    0,    0,    9,   10,    0,    0,    0,
   11,    0,   12,   13,   14,   15,   16,   17,   18,    0,
    0,    0,    0,   19,   20,   21,   22,   23,   24,   25,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   28,
    0,    0,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,    0,   41,   42,    0,   43,   44,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  206,    0,    0,  106,
   47,    0,   48,   49,    0,    0,    0,   51,   52,   53,
   54,   55,   56,    0,  215,  215,  215,   57,  215,    0,
    0,    0,  215,  215,    0,    0,    0,  215,    0,  215,
  215,  215,  215,  215,  215,  215,    0,    0,    0,    0,
  215,  215,  215,  215,  215,  215,  215,    0,    0,    0,
    0,    0,    0,    0,  751,    0,  215,    0,    0,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,    0,
  215,  215,    0,  215,  215,    0,    0,    0,  182,  177,
    0,    0,    0,  180,  178,    0,  179,    0,  181,    0,
    0,    0,    0,  215,    0,    0,  215,  215,    0,  215,
  215,  174,    0,  173,  215,  215,  215,  215,  215,  215,
    0,    0,    0,    0,  215,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  176,    0,  184,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  175,    0,  183,    0,  182,
  177,    0,    0,    0,  180,  178,    0,  179,    0,  181,
    0,    0,    0,    0,    0,    0,    0,    4,    5,    6,
    0,    8,  174,    0,  173,    9,   10,    0,    0,    0,
   11,    0,   12,   13,   14,   96,   97,   17,   18,    0,
    0,    0,    0,   98,   99,  100,   22,   23,   24,   25,
    0,    0,    0,    0,    0,    0,  176,    0,  184,  101,
    0,    0,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,    0,   41,   42,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  175,    0,  183,    0,
    0,    0,    0,    0,    0,    0,  223,    0,    0,   46,
   47,    0,   48,   49,    0,   50,    0,   51,   52,   53,
   54,   55,   56,    0,    0,    0,    0,  107,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  116,  117,
  118,  119,  120,  121,  122,  123,  124,  125,  126,  127,
  128,  129,  130,  131,  132,  133,  134,  135,  136,  137,
  138,  139,    0,    0,  140,  141,  142,  191,  192,  193,
  194,  147,  148,  149,    0,    0,    0,    0,    0,  150,
  151,  152,  153,  195,  196,  197,  157,  250,    0,  198,
    0,    0,    0,    0,    0,    0,    0,  159,  160,  161,
  162,  163,  164,    0,  165,  166,    0,    0,  167,    0,
    0,    0,  168,  169,  170,  171,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  172,    0,   51,  116,
  117,  118,  119,  120,  121,  122,  123,  124,  125,  126,
  127,  128,  129,  130,  131,  132,  133,  134,  135,  136,
  137,  138,  139,    0,    0,  140,  141,  142,  191,  192,
  193,  194,  147,  148,  149,    0,    0,    0,    0,    0,
  150,  151,  152,  153,  195,  196,  197,  157,    0,    0,
  198,    0,    0,    0,    0,    0,    0,    0,  159,  160,
  161,  162,  163,  164,    0,  165,  166,    0,    0,  167,
    0,    0,    0,  168,  169,  170,  171,    0,  182,  177,
    0,  185,    0,  180,  178,    0,  179,  172,  181,   51,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  174,    0,  173,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  176,    0,  184,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  175,    0,  183,  182,  177,
    0,    0,    0,  180,  178,    0,  179,    0,  181,    0,
    0,    0,    0,    0,    0,    0,    4,    5,    6,    0,
    8,  174,    0,  173,    9,   10,    0,    0,    0,   11,
    0,   12,   13,   14,   96,   97,   17,   18,    0,    0,
    0,    0,   98,   99,  100,   22,   23,   24,   25,    0,
    0,    0,    0,    0,    0,  176,    0,  184,  101,    0,
    0,   31,   32,  102,   34,   35,   36,  103,   38,   39,
   40,    0,   41,   42,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  175,    0,  183,    0,    0,
    0,    0,  104,    0,    0,  105,    0,    0,  106,   47,
    0,   48,   49,    0,    0,    0,   51,   52,   53,   54,
   55,   56,    0,    0,    0,    0,  107,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  116,  117,
  118,  119,  120,  121,  122,  123,  124,  125,  126,  127,
  128,  129,  130,  131,  132,  133,  134,  135,  136,  137,
  138,  139,    0,    0,  140,  141,  142,  143,  144,  145,
  146,  147,  148,  149,    0,    0,    0,    0,    0,  150,
  151,  152,  153,  154,  155,  156,  157,   35,   36,  158,
   38,    0,    0,    0,    0,    0,    0,  159,  160,  161,
  162,  163,  164,    0,  165,  166,    0,    0,  167,    0,
    0,    0,  168,  169,  170,  171,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  172,    0,  116,  117,
  118,  119,  120,  121,  122,  123,  124,  125,  126,  127,
  128,  129,  130,  131,  132,  133,  134,  135,  136,  137,
  138,  139,    0,    0,  140,  141,  142,  191,  192,  193,
  194,  147,  148,  149,    0,    0,    0,    0,    0,  150,
  151,  152,  153,  195,  196,  197,  157,  280,  281,  198,
  282,    0,    0,    0,    0,    0,    0,  159,  160,  161,
  162,  163,  164,    0,  165,  166,    0,    0,  167,    0,
    0,    0,  168,  169,  170,  171,    0,  182,  177,    0,
    0,    0,  180,  178,    0,  179,  172,  181,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  174,    0,  173,    0,    0,    0,    0,    0,  182,  177,
    0,    0,    0,  180,  178,    0,  179,    0,  181,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  174,    0,  173,  176,    0,  184,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  182,  177,    0,    0,
    0,  180,  178,    0,  179,    0,  181,    0,    0,    0,
    0,    0,    0,    0,  175,  176,  183,  184,    0,  174,
    0,  173,    0,    0,    0,    0,    0,  182,  177,    0,
    0,    0,  180,  178,    0,  179,    0,  181,    0,    0,
    0,    0,    0,    0,    0,  175,    0,  183,    0,    0,
  174,    0,  173,  176,    0,  184,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  175,  176,  183,  184,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  175,    0,  183,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
  139,    0,    0,  140,  141,  142,  191,  192,  193,  194,
  147,  148,  149,    0,    0,    0,    0,    0,  150,  151,
  152,  153,  195,  196,  197,  157,    0,    0,  198,    0,
    0,    0,    0,    0,    0,    0,  159,  160,  161,  162,
  163,  164,    0,  165,  166,    0,    0,  167,    0,    0,
    0,  168,  169,  170,  171,  506,  507,    0,    0,  508,
    0,    0,    0,    0,    0,  172,    0,  159,  160,  161,
  162,  163,  164,    0,  165,  166,    0,    0,  167,    0,
    0,    0,  168,  169,  170,  171,    0,    0,    0,    0,
    0,    0,    0,  513,  514,    0,  172,  515,    0,    0,
    0,    0,    0,    0,    0,  159,  160,  161,  162,  163,
  164,    0,  165,  166,    0,    0,  167,    0,    0,    0,
  168,  169,  170,  171,  520,  514,    0,    0,  521,    0,
    0,    0,    0,    0,  172,    0,  159,  160,  161,  162,
  163,  164,    0,  165,  166,    0,    0,  167,    0,    0,
    0,  168,  169,  170,  171,    0,  182,  177,    0,    0,
    0,  180,  178,    0,  179,  172,  181,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  174,
    0,  173,    0,    0,    0,    0,    0,  182,  177,    0,
    0,    0,  180,  178,    0,  179,    0,  181,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  174,    0,  173,  176,    0,  184,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  182,  177,    0,    0,    0,
  180,  178,    0,  179,    0,  181,    0,    0,    0,    0,
    0,    0,    0,  175,  176,  183,  184,    0,  174,    0,
  173,    0,    0,    0,    0,    0,  182,  177,    0,    0,
    0,  180,  178,    0,  179,    0,  181,    0,    0,    0,
    0,    0,    0,    0,  175,    0,  183,    0,    0,  174,
    0,  173,  176,    0,  184,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  182,  177,    0,    0,    0,  180,
  178,    0,  179,    0,  181,    0,    0,    0,    0,    0,
    0,    0,  175,  176,  183,  184,    0,  174,    0,  173,
    0,    0,    0,    0,    0,  182,  177,    0,    0,    0,
  180,  178,    0,  179,    0,  181,    0,    0,    0,    0,
    0,    0,    0,  175,    0,  183,    0,    0,  174,    0,
  173,  176,    0,  184,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  175,  176,  183,  184,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  175,    0,  183,    0,    0,    0,    0,    0,
    0,    0,    0,  544,  507,    0,    0,  545,    0,    0,
    0,    0,    0,    0,    0,  159,  160,  161,  162,  163,
  164,    0,  165,  166,    0,    0,  167,    0,    0,    0,
  168,  169,  170,  171,  580,  507,    0,    0,  581,    0,
    0,    0,    0,    0,  172,    0,  159,  160,  161,  162,
  163,  164,    0,  165,  166,    0,    0,  167,    0,    0,
    0,  168,  169,  170,  171,    0,    0,    0,    0,    0,
    0,    0,  583,  514,    0,  172,  584,    0,    0,    0,
    0,    0,    0,    0,  159,  160,  161,  162,  163,  164,
    0,  165,  166,    0,    0,  167,    0,    0,    0,  168,
  169,  170,  171,  598,  507,    0,    0,  599,    0,    0,
    0,    0,    0,  172,    0,  159,  160,  161,  162,  163,
  164,    0,  165,  166,    0,    0,  167,    0,    0,    0,
  168,  169,  170,  171,    0,    0,    0,    0,    0,    0,
    0,  601,  514,    0,  172,  602,    0,    0,    0,    0,
    0,    0,    0,  159,  160,  161,  162,  163,  164,    0,
  165,  166,    0,    0,  167,    0,    0,    0,  168,  169,
  170,  171,  639,  507,    0,    0,  640,    0,    0,    0,
    0,    0,  172,    0,  159,  160,  161,  162,  163,  164,
    0,  165,  166,    0,    0,  167,    0,    0,    0,  168,
  169,  170,  171,    0,  182,  177,    0,    0,    0,  180,
  178,    0,  179,  172,  181,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  174,    0,  173,
    0,    0,    0,    0,    0,  182,  177,    0,    0,    0,
  180,  178,    0,  179,    0,  181,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  174,    0,
  173,  176,    0,  184,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  182,  177,    0,    0,    0,  180,  178,
    0,  179,    0,  181,    0,    0,    0,    0,    0,    0,
    0,  175,  176,  183,  184,    0,  174,    0,  173,    0,
    0,    0,  333,  328,    0,    0,    0,  331,  329,    0,
  330,    0,  332,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  175,    0,  183,  325,    0,  324,  323,    0,
  176,    0,  184,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    4,    5,
    6,    0,    8,    0,    0,    0,    9,   10,    0,  327,
  175,   11,  183,   12,   13,   14,   96,   97,   17,   18,
    0,    0,    0,    0,   98,   99,  100,   22,   23,   24,
   25,    0,    0,    0,    0,    0,    0,    0,    0,  326,
  101,    0,    0,   31,   32,   33,   34,   35,   36,   37,
   38,   39,   40,    0,   41,   42,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  223,    0,    0,
   46,   47,    0,   48,   49,    0,   50,    0,   51,   52,
   53,   54,   55,   56,    0,    0,    0,    0,  107,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  642,  514,    0,    0,  643,    0,    0,    0,    0,
    0,    0,    0,  159,  160,  161,  162,  163,  164,    0,
  165,  166,    0,    0,  167,    0,    0,    0,  168,  169,
  170,  171,  876,  507,    0,    0,  877,    0,    0,    0,
    0,    0,  172,    0,  159,  160,  161,  162,  163,  164,
    0,  165,  166,    0,    0,  167,    0,    0,    0,  168,
  169,  170,  171,    0,    0,    0,    0,    0,    0,    0,
  879,  514,    0,  172,  880,    0,    0,    0,    0,    0,
    0,    0,  159,  160,  161,  162,  163,  164,    0,  165,
  166,    0,  674,  167,    0,    0,    0,  168,  169,  170,
  171,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  172,    0,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,  319,  320,    0,    0,  321,  322,
    4,    5,    6,    0,    8,    0,    0,    0,    9,   10,
    0,    0,    0,   11,    0,   12,   13,   14,   96,   97,
   17,   18,    0,    0,    0,    0,   98,   99,  100,   22,
   23,   24,   25,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  101,    0,    0,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,    0,   41,   42,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  275,
    0,    0,  348,   47,    0,   48,   49,    0,  349,    0,
   51,   52,   53,   54,   55,   56,    0,    4,    5,    6,
  107,    8,    0,    0,    0,    9,   10,    0,    0,    0,
   11,    0,   12,   13,   14,   96,   97,   17,   18,    0,
    0,    0,    0,   98,   99,  100,   22,   23,   24,   25,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  101,
    0,    0,   31,   32,  102,   34,   35,   36,  103,   38,
   39,   40,    0,   41,   42,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  105,    0,    0,  106,
   47,    0,   48,   49,    0,    0,    0,   51,   52,   53,
   54,   55,   56,    0,    4,    5,    6,  107,    8,    0,
    0,    0,    9,   10,    0,    0,    0,   11,    0,   12,
   13,   14,   96,   97,   17,   18,    0,    0,    0,    0,
   98,   99,  100,   22,   23,   24,   25,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  101,    0,    0,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,    0,
   41,   42,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  275,    0,    0,  106,   47,    0,   48,
   49,    0,    0,    0,   51,   52,   53,   54,   55,   56,
    0,    4,    5,    6,  107,    8,    0,    0,    0,    9,
   10,    0,    0,    0,   11,    0,   12,   13,   14,   96,
   97,   17,   18,    0,    0,    0,    0,   98,   99,  100,
   22,   23,   24,   25,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  101,    0,    0,   31,   32,   33,   34,
   35,   36,   37,   38,   39,   40,    0,   41,   42,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  830,    0,    0,  106,   47,    0,   48,   49,    0,    0,
    0,   51,   52,   53,   54,   55,   56,    0,    0,    0,
    0,  107,
};
const short yycheck[] = {                                      15,
   16,    6,    7,   19,    4,    5,   15,   16,  246,  214,
   19,   14,  369,  390,   14,    6,   27,   21,  396,   21,
  408,  105,   27,   50,  374,   15,   16,   43,   44,   19,
  347,   46,   48,   49,   15,   16,  340,   10,   19,   10,
  689,    7,   58,   59,   38,  576,   51,    7,   15,   16,
   50,   58,   19,  441,   46,  586,   44,   11,  239,   49,
   51,   27,    3,  367,   46,   10,   10,   27,   49,  123,
   41,   10,  339,   44,  341,  124,  343,  344,   71,   37,
  384,   48,  286,   32,   42,   46,  290,   10,   88,   47,
   94,   10,   94,   46,   10,  399,  308,  260,  100,   91,
   44,  368,  504,  505,  312,  269,   46,  271,   46,   91,
   10,  113,   10,   10,   58,   59,  383,   71,  385,   58,
   59,   40,   10,  312,   10,   41,   41,   46,   10,  689,
   46,   41,    0,  400,  694,  661,   59,   40,   91,   58,
   59,  667,   10,   10,   11,  449,   61,  355,   10,   46,
   40,   91,  304,   91,  108,   46,  308,   46,   40,   59,
   58,   59,  429,   40,   46,   46,  355,  101,  123,   10,
   58,   59,   91,   59,   37,   38,   58,   59,  827,   42,
   43,   93,   45,  450,   47,  348,  543,    2,    3,    4,
    5,   59,   32,   10,    9,   10,   11,   59,   10,   14,
   15,   16,   91,   10,   19,   46,  563,  310,  311,   91,
   91,   26,  562,  125,  230,  231,  232,   58,   59,   10,
  123,  402,   10,   10,  217,  125,  280,  243,   32,  245,
  246,   46,   47,   48,  243,   50,  245,  246,   44,   46,
   46,  123,   59,   58,  269,  260,  271,   59,  273,  265,
   91,   58,   59,  243,   41,  245,  246,   38,  575,  463,
  348,   42,  243,  217,  245,  246,  797,  827,   59,   60,
  282,   59,   59,   88,  337,  677,  243,  326,  245,  246,
  567,  337,  366,  570,   91,   91,  269,   10,  271,  104,
   61,  106,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  124,  290,
  291,   44,  349,  267,  340,   10,  342,   61,  267,  345,
  346,  347,  266,  348,  339,  342,  724,   44,  345,  346,
  347,  264,  730,  335,  722,  290,  291,   44,  267,  349,
  338,  367,  346,  335,  221,  222,   41,  624,  625,  300,
  318,  366,  308,  312,  305,  346,  347,  338,  384,  267,
  386,  387,  388,  340,  335,  337,  392,  280,  383,  267,
  290,  291,  335,  399,  622,  267,  591,  337,  404,  405,
  205,   61,  408,  398,  338,  335,  412,  335,  280,  338,
  367,  263,  264,  412,  353,  354,  221,  222,  362,  425,
   59,  392,  423,  770,  430,  405,  335,  384,  423,  335,
  797,  437,  412,  428,  774,  441,  267,  443,  243,  610,
  245,  246,  399,  449,  301,  302,  303,  304,  335,  620,
  255,  395,  396,  448,  335,  260,  335,  522,  523,  308,
   10,  467,  468,  335,  335,  318,  269,  423,  271,  279,
  267,  849,  338,  423,   10,  256,  269,  824,  271,   37,
  333,  334,   10,  279,   42,   43,  264,   45,   44,   47,
  268,  269,  449,  417,  418,  300,  301,  302,  303,  304,
  305,  306,  307,  780,  335,  782,  783,  885,   58,   59,
  434,  435,   40,   44,   10,  509,   40,  509,   46,   10,
  526,  123,  516,   59,  290,  291,  318,   41,  522,  523,
   58,   59,   41,  304,   41,  340,  337,  342,  335,  335,
  345,  346,  347,  348,  349,   93,   10,   61,   44,  125,
   44,   10,  723,   44,  546,  726,  727,  552,   10,  310,
  311,   10,  367,   91,  369,  370,  308,   61,  862,  575,
  355,  552,  573,  355,  345,  346,  381,   41,  573,  384,
   10,   40,  859,  589,  389,  318,  391,   46,  318,   41,
   10,  786,   41,   41,  399,  123,  540,  792,   10,   58,
   59,  607,   10,   44,  575,  611,  863,  412,  344,  615,
  124,   41,  264,   61,   44,   16,  622,  573,   19,  262,
  564,  426,  267,  573,    9,   10,   11,  551,   10,   59,
  124,  637,   91,   41,   10,  806,   44,  808,   58,   59,
  271,   26,  622,  264,  449,  651,   44,   59,  306,  268,
  269,   59,  658,  659,   41,  313,  314,  663,  664,  312,
  653,  658,   47,  653,  123,  622,  663,  664,  674,  675,
   46,  736,  737,   44,  845,  846,  124,   59,   10,  685,
  851,   41,   58,   59,   41,  542,   37,   38,   41,   41,
  125,   42,   43,   32,   45,  337,   47,  263,  264,  870,
  353,  354,  355,  709,  337,  711,  712,   93,   61,   61,
  337,  717,  337,  884,   46,   91,  887,   44,  724,  104,
   41,  892,  728,   44,  730,   46,   58,   59,  264,  728,
   38,  281,   40,  269,   42,  679,   61,  542,  543,  267,
   61,  312,   41,   94,  315,   37,  603,   93,  728,  264,
   42,   43,  280,   45,  760,   47,   44,  728,  563,   91,
  318,  767,  686,  760,   44,  279,   41,    2,    3,   44,
   91,  124,  124,  124,    9,   10,   11,   44,  722,  304,
   15,   16,  353,  354,   19,  279,   61,  304,  794,  269,
  796,   26,  312,   53,   54,  785,  802,  337,  603,  805,
  263,  264,   93,  124,  810,  337,  269,  335,  267,  264,
  734,   46,   47,   48,   48,   49,   38,  622,  742,  337,
   42,  280,   40,   58,  629,  264,   44,   44,   46,   46,
   44,  279,   93,  353,  354,  355,  221,  222,  346,  644,
   44,  847,  243,  849,  245,  246,   44,  267,  653,  706,
  262,  263,  264,  658,  312,   41,  862,  269,  663,  664,
   41,  312,   44,  869,   46,  871,  861,  847,   41,  104,
  125,  106,   41,   91,   91,  337,  335,   93,  338,  885,
  264,   44,  264,   46,  890,  306,  307,  269,  309,  271,
   41,  267,  313,  314,  264,  353,  354,  355,  703,  263,
  337,  706,  353,  354,  355,  862,  124,  124,  264,   91,
  312,   10,   41,  718,  719,  720,  301,  302,  303,  304,
  264,  306,  307,  125,  124,   41,  279,  279,   91,   44,
    0,    2,   44,  264,  264,  267,   44,   41,  264,   38,
   10,   40,  124,   42,  264,  125,  264,   46,  753,  754,
  755,  353,  354,  355,  308,  760,   44,  125,  279,  335,
   59,  124,  264,  264,  125,  770,   93,  318,   93,   41,
  205,   41,   40,  271,   44,   46,   93,  125,   41,   93,
  785,   41,  333,  334,  789,  370,  221,  222,   58,   59,
   93,  125,    2,    3,    4,    5,  304,   61,  306,  307,
  308,  309,  236,  335,   14,  239,  264,  312,  243,    5,
  245,  246,  246,  864,  335,   10,    6,  822,  865,  824,
  255,  774,  694,   93,  562,  260,  318,  412,   78,  653,
  835,   88,  837,  694,    0,  106,   46,  345,  346,  844,
   50,  333,  334,   38,   10,   40,   71,   42,  353,  354,
  355,   46,   40,   41,   -1,  125,   44,  862,   46,   -1,
   -1,  279,  279,   -1,   59,  300,  301,  302,  303,  304,
  305,  306,  307,   61,   -1,   41,   -1,   -1,   88,   -1,
   -1,   -1,  304,   -1,  306,  307,  308,  309,  293,  294,
  295,  296,  297,   59,   -1,   -1,  106,  279,   -1,   -1,
   -1,   -1,   -1,   91,   -1,  340,  340,  342,   -1,   -1,
  345,  346,  347,  348,   -1,   -1,  279,  335,  335,   -1,
   -1,   -1,   -1,  345,  346,   -1,   -1,    2,    3,    4,
    5,    6,  367,  367,  369,  370,  124,   -1,   -1,   14,
   -1,   -1,   -1,  377,   -1,   -1,  381,   -1,   -1,  384,
  384,   10,   -1,  335,  389,   -1,  391,  542,   -1,  125,
   -1,   -1,   -1,   -1,  399,  399,   -1,   -1,  402,   -1,
   -1,   46,  335,   -1,   -1,   50,   -1,  412,   -1,   38,
   -1,   40,  416,   42,  255,   -1,   -1,   46,   -1,  260,
   -1,  426,  262,  263,  264,  205,   -1,  267,  268,  269,
   59,  271,   10,   -1,   -1,  304,   -1,  306,  307,  308,
  309,  281,  282,   88,  449,  449,   -1,   -1,  603,   -1,
  290,  291,   -1,  293,  294,  295,  296,  297,   -1,   -1,
   38,  106,   40,   -1,   42,   -1,  335,   -1,   46,   -1,
   -1,   -1,   -1,   -1,  629,  255,  345,  346,   -1,   -1,
  260,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  338,  503,
  504,  505,   -1,   -1,  344,   -1,   -1,  348,   -1,   -1,
   -1,   -1,  516,   -1,   -1,   -1,   -1,   -1,  522,  523,
  300,  279,   -1,   -1,   -1,  305,  262,  263,  264,   -1,
   -1,   -1,  268,  269,   -1,  271,   -1,  542,  543,  304,
  381,  306,  307,  308,  309,  549,   -1,   -1,  389,   -1,
  391,  706,   -1,   -1,   -1,   -1,   -1,   -1,  563,   -1,
  205,  565,   -1,  567,   -1,   -1,  570,   -1,  348,  349,
  335,  575,  576,   -1,  578,   -1,   -1,  335,   -1,   -1,
  345,  346,  586,   -1,   -1,  426,   -1,   -1,   -1,  369,
   -1,    2,    3,   -1,   -1,   -1,   -1,   -1,  603,   41,
   -1,  381,   44,   14,   46,   -1,  610,   -1,   -1,  389,
  255,  391,   -1,   -1,   -1,  260,  620,  622,   -1,   61,
   -1,   -1,   -1,   -1,  629,   -1,   -1,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   46,   -1,   -1,   10,  644,
   -1,   -1,   -1,   -1,   -1,   -1,  426,    2,    3,   91,
   -1,   -1,   -1,  658,   -1,  300,   -1,   -1,  663,  664,
  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   -1,  677,   -1,  304,   -1,  306,  307,  308,
  309,   -1,  124,   -1,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   46,   -1,   -1,   -1,  106,  700,   -1,  703,   -1,
  704,  706,   -1,  348,  349,   -1,  335,   -1,   -1,   -1,
   -1,   -1,   -1,  718,  719,  720,  345,  346,   -1,  723,
   -1,   -1,  726,  727,  369,   -1,  304,   -1,  306,  307,
  308,  309,  736,  737,   -1,   -1,  381,   -1,   -1,   -1,
   -1,   10,   -1,   -1,  389,   -1,  391,   -1,  753,  754,
  755,  106,   -1,  125,   -1,  760,    0,  335,   -1,   -1,
   -1,   -1,   -1,  543,   -1,  770,   10,  345,  346,   38,
   -1,   40,   -1,   42,   -1,   -1,  780,   46,  782,  783,
   -1,  426,   -1,  563,  789,   -1,   -1,   -1,   -1,   -1,
   59,   -1,   40,  797,  205,   -1,   44,   41,   46,   -1,
   44,   -1,  806,  644,  808,   -1,   -1,   -1,   -1,   -1,
  230,  231,   -1,   -1,   -1,   59,   -1,  822,   -1,  824,
   -1,   -1,   -1,   40,   -1,   -1,    0,   44,   -1,   46,
  835,   -1,  837,   -1,   -1,   -1,   10,  279,   -1,  844,
   -1,  845,  846,   91,  255,   -1,   -1,  851,   -1,  260,
  205,   -1,   -1,   -1,   -1,  859,   -1,  862,  862,   -1,
  864,  865,  703,   -1,  644,  645,  870,   41,   -1,   -1,
   44,   -1,   -1,  653,   91,  123,  124,  718,  719,  720,
  884,  125,   -1,  887,   58,   59,   -1,   -1,  892,  300,
  262,  263,  264,  335,  305,   -1,  268,  269,  543,  271,
  255,   -1,   -1,   -1,   -1,  260,  123,  124,   -1,   -1,
   -1,   -1,  753,  754,  755,   -1,   -1,   -1,  563,   -1,
   -1,   -1,   -1,  703,   -1,   -1,  346,  347,   -1,   -1,
   -1,   -1,   -1,   10,   -1,   -1,   -1,  348,  718,  719,
  720,   -1,   -1,   -1,   -1,  300,   -1,   -1,  789,   -1,
  305,  125,   -1,   -1,    0,   -1,   -1,   -1,  369,   -1,
   -1,   38,   -1,   40,   10,   42,   -1,   -1,   -1,   46,
  381,   -1,  392,  753,  754,  755,   -1,   -1,  389,   -1,
  391,  822,   59,   -1,  404,  405,   -1,   -1,  408,   -1,
  770,   -1,  412,  348,  835,   41,  837,   -1,   44,  644,
   -1,   -1,   -1,  844,   -1,  785,   -1,   -1,  653,  789,
   -1,   -1,   58,   59,  369,  426,   -1,  437,  262,  263,
  264,  441,   -1,  443,  268,  269,  381,  271,   -1,   -1,
   -1,  279,  280,   -1,  389,  304,  391,  306,  307,  308,
  309,   -1,  822,   -1,  824,   -1,   -1,   93,   -1,  293,
  294,  295,  296,  297,   -1,  835,   -1,  837,  703,   -1,
   -1,   -1,  279,  280,  844,   -1,  335,   -1,   -1,   -1,
   -1,  426,   -1,  718,  719,  720,  345,  346,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  262,  263,
  264,   -1,   -1,  267,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  526,   -1,  753,  754,
  755,   10,   -1,   -1,   -1,   -1,   -1,   -1,  335,  293,
  294,  295,  296,  297,   -1,  770,   -1,   -1,   -1,   -1,
   -1,   -1,  543,   -1,   -1,   -1,   -1,   -1,   -1,   38,
  785,   40,   -1,   42,  789,   -1,   -1,   46,   -1,   -1,
   -1,   41,  563,   -1,   44,  575,   46,   -1,   -1,   -1,
   59,   -1,   -1,   -1,  338,   -1,   -1,   -1,   -1,  589,
   -1,   61,   -1,   -1,   -1,   -1,   -1,  822,   -1,  824,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  607,  543,   -1,
  835,  611,  837,   41,   -1,  615,   44,   -1,   46,  844,
   -1,   91,  622,   40,   41,   -1,   -1,   44,  563,   46,
   -1,   -1,   -1,   61,   -1,   -1,  262,  263,  264,   -1,
   -1,  267,  268,  269,   61,  271,   -1,  304,   -1,  306,
  307,  308,  309,  644,  124,  281,  282,   -1,   -1,   -1,
   -1,    0,  653,   91,  290,  291,   -1,  293,  294,  295,
  296,  297,    0,   -1,   91,  675,   -1,   -1,  335,   -1,
   -1,   -1,   -1,   -1,   -1,  685,   -1,   -1,  345,  346,
   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,    0,   -1,
   -1,   -1,   41,   -1,   -1,   -1,  123,  124,   10,  644,
   -1,   -1,  703,   41,   -1,   -1,   -1,  717,  344,   -1,
   -1,   -1,   -1,   -1,  724,   -1,   -1,  718,  719,  720,
  730,   33,   -1,   -1,   -1,   37,   38,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   63,  753,  754,  755,   -1,   -1,  767,  703,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  770,
   -1,   -1,   -1,  718,  719,  720,  125,   -1,   -1,   91,
   -1,   93,   94,   -1,  785,   -1,  796,  125,  789,   -1,
   -1,   -1,   -1,   -1,   -1,  805,   10,   -1,   -1,  279,
  810,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  753,  754,
  755,  123,  124,  125,  126,  304,   -1,  306,  307,  308,
  309,  822,   -1,  824,   38,  770,   40,   -1,   42,   -1,
   -1,   -1,   46,   -1,  835,   -1,  837,  847,   -1,  849,
   -1,  279,   -1,  844,  789,   59,  335,   -1,   -1,   -1,
   -1,   -1,  279,  280,   -1,  335,  345,  346,   -1,  869,
   40,  871,   -1,   -1,   44,   -1,   46,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  885,   -1,  822,   -1,  824,
  890,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  835,   -1,  837,   -1,   -1,   -1,   -1,  335,   -1,  844,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,
   -1,   91,   -1,  262,  263,  264,   -1,   -1,   -1,  268,
  269,   -1,  271,   -1,  262,  263,  264,   -1,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,  124,  257,  258,  259,   -1,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
   -1,  293,  294,  295,  296,  297,   -1,  299,   -1,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
   -1,  313,  314,   -1,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,    0,
   -1,  333,  334,  335,  336,  337,  338,  339,  340,   10,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,   -1,   -1,   -1,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   37,   38,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  304,   -1,  306,  307,  308,  309,   -1,   -1,   -1,  279,
  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   94,   -1,   -1,    0,   -1,   -1,   -1,
   -1,  335,   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,
   -1,  345,  346,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  123,  124,  125,  126,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   37,   38,  335,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
  124,  125,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,   -1,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,   -1,  293,  294,  295,  296,  297,   -1,  299,   -1,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,   -1,  313,  314,   -1,  316,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
   -1,   -1,  333,  334,  335,  336,  337,  338,  339,  340,
   -1,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,   -1,  257,  258,  259,  357,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,  299,   -1,   -1,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,   -1,  313,
  314,   -1,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,    0,   -1,  333,
  334,  335,  336,   -1,  338,  339,  340,   10,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,   -1,
   -1,   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   37,   38,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   94,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  123,  124,  125,  126,   -1,   -1,   -1,   33,   -1,   -1,
   -1,   37,   38,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,   -1,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,   -1,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,   -1,
  293,  294,  295,  296,  297,   -1,  299,   -1,   -1,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,   -1,
  313,  314,   -1,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,   -1,   -1,
  333,  334,  335,  336,   -1,  338,  339,  340,   -1,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
   -1,  257,  258,  259,  357,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,   -1,  293,  294,  295,
  296,  297,   -1,  299,   -1,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,   -1,  313,  314,   -1,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,    0,   -1,  333,  334,  335,
  336,   -1,  338,  339,  340,   10,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,   -1,   -1,   -1,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   37,   38,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   -1,   62,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   94,
   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,
  125,  126,   -1,   -1,   -1,   33,   -1,   -1,   -1,   37,
   38,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  123,  124,  125,  126,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,   -1,  293,  294,
  295,  296,  297,   -1,  299,   -1,   -1,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,   -1,  313,  314,
   -1,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,   -1,   -1,  333,  334,
  335,  336,   -1,  338,  339,  340,   -1,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,   -1,  257,
  258,  259,  357,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,   -1,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,  299,   -1,   -1,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,   -1,  313,  314,   -1,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,    0,   -1,  333,  334,  335,  336,   -1,
  338,  339,  340,   10,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,   -1,   -1,   -1,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,
   37,   38,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   94,   -1,   -1,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,  126,
   -1,   -1,   -1,   33,   -1,   -1,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,  124,  125,  126,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,   -1,  261,  262,  263,  264,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,  299,   -1,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,   -1,  313,  314,   -1,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,   -1,  333,  334,  335,  336,
   -1,  338,  339,  340,   -1,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,   -1,  257,  258,  259,
  357,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,   -1,  293,  294,  295,  296,  297,   -1,  299,
   -1,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,   -1,  313,  314,   -1,  316,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,    0,   -1,  333,  334,  335,  336,   -1,  338,  339,
  340,   10,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,   -1,   -1,   -1,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,   37,   38,
   -1,   -1,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   94,   -1,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  123,  124,  125,  126,   -1,   -1,
   -1,   33,   -1,   -1,   -1,   37,   38,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  124,  125,  126,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,   -1,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
  299,   -1,   -1,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,   -1,  313,  314,   -1,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,   -1,   -1,  333,  334,  335,  336,   -1,  338,
  339,  340,   -1,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,   -1,  257,  258,  259,  357,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,   -1,   -1,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
   -1,  293,  294,  295,  296,  297,   -1,  299,   -1,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
   -1,  313,  314,   -1,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,    0,
   -1,  333,  334,  335,  336,   -1,  338,  339,  340,   10,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,   -1,   -1,   -1,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   37,   38,   -1,   -1,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   94,   -1,   -1,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,  125,  126,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   37,   38,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
  124,  125,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,   -1,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,   -1,   41,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,   -1,  293,  294,  295,  296,  297,   59,  299,   -1,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,   -1,  313,  314,   -1,  316,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
   -1,   -1,  333,  334,  335,  336,   -1,  338,  339,  340,
   -1,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,   -1,  257,  258,  259,  357,  261,  262,  263,
  264,  265,  266,  125,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,   -1,  280,   -1,   -1,  283,
  284,  285,  286,  287,  288,  289,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,  299,   -1,   -1,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,   -1,  313,
  314,   -1,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,    0,   -1,  333,
  334,  335,  336,   -1,   -1,  339,  340,   10,  342,  343,
   -1,  345,  346,  347,  348,  349,  350,  351,  352,   -1,
   -1,   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   37,   38,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,  263,  264,   -1,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   -1,   94,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  123,  124,  125,  126,   -1,   -1,   -1,   33,   -1,   -1,
   -1,   37,   38,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   60,   61,   62,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,   -1,  261,  262,
  263,  264,  265,  266,   -1,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,   -1,  280,   -1,   -1,
  283,  284,  285,  286,  287,  288,  289,  290,  291,   -1,
  293,  294,  295,  296,  297,   -1,  299,   -1,   -1,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,   -1,
  313,  314,   -1,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,   -1,   -1,
  333,  334,  335,  336,   -1,   -1,  339,  340,   -1,  342,
  343,   -1,  345,  346,  347,  348,  349,  350,  351,  352,
   -1,  257,  258,  259,  357,  261,  262,  263,  264,  265,
  266,   33,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,   -1,  280,   -1,   -1,  283,  284,  285,
  286,  287,  288,  289,  290,  291,   -1,  293,  294,  295,
  296,  297,   -1,  299,   -1,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,   -1,  313,  314,   -1,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,    0,   -1,  333,  334,  335,
  336,   -1,   -1,  339,  340,   10,  342,  343,   -1,  345,
  346,  347,  348,  349,  350,  351,  352,   -1,   -1,   -1,
   -1,  357,   -1,   -1,  126,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   37,   38,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   60,   61,   62,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,   94,
   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,
  125,  126,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   -1,   -1,   46,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   -1,   -1,  256,  257,  258,  259,  260,  261,
   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,
   -1,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,   -1,   -1,   -1,   -1,   -1,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
   -1,  313,  314,   -1,  316,  317,   -1,  125,  126,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,  340,   -1,
  342,  343,   -1,  345,   -1,  347,  348,  349,  350,  351,
  352,   -1,  257,  258,  259,  357,  261,  262,  263,  264,
  265,  266,   -1,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,   -1,   -1,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,  290,  291,   -1,  293,  294,
  295,  296,  297,   -1,  299,   -1,   -1,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,   -1,  313,  314,
   -1,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,   -1,   -1,  333,  334,
  335,  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,
  345,  346,  347,  348,  349,  350,  351,  352,   -1,  257,
  258,  259,  357,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,   -1,   -1,  281,   -1,  283,  284,  285,  286,  287,
  288,  289,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,  299,   -1,   -1,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,   -1,  313,  314,   -1,  316,  317,
   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   46,   -1,
   -1,   -1,   10,   -1,   -1,   -1,   -1,  335,  336,   -1,
   -1,  339,  340,   61,  342,  343,   -1,  345,  346,  347,
  348,  349,  350,  351,  352,   33,   -1,   -1,   -1,  357,
   -1,   -1,   40,   -1,   -1,   -1,   -1,   -1,   46,   -1,
   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   60,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  123,  124,   -1,   40,   41,
   -1,   -1,   44,   91,   46,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   61,
   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,  126,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   91,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   -1,
   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   60,   -1,   -1,   -1,   -1,   -1,
   10,  123,  124,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   60,   -1,   62,   63,   -1,   -1,   -1,  123,   -1,   -1,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  279,  280,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,  256,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,   -1,
   -1,  269,  270,    0,  272,  273,  274,  275,  276,  277,
  278,   -1,  280,   10,  124,  283,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,   -1,   -1,  335,   -1,   -1,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,   41,  313,  314,   -1,  316,  317,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  279,  280,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,  335,  336,   -1,
   -1,  339,  340,   -1,  342,  343,   -1,  345,   -1,  347,
  348,  349,  350,  351,  352,   -1,   -1,   -1,   -1,  357,
  256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,   -1,   -1,  269,  270,    0,  272,  273,  274,  275,
  276,  277,  278,  335,  280,   10,   -1,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,  292,   -1,  125,   -1,
   -1,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,   41,  313,  314,   -1,
  316,  317,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,   -1,  335,
  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,  345,
   33,  347,  348,  349,  350,  351,  352,   40,   -1,   -1,
   -1,  357,   -1,   46,   -1,   -1,   -1,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,
   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,
  123,  268,  269,  126,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   -1,   -1,   -1,   46,  293,  294,  295,  296,
  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   10,   -1,  262,  263,  264,
   -1,   -1,  267,  268,  269,  126,  271,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,   33,   -1,
   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,  294,
  295,  296,  297,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,   59,   -1,  269,  270,   -1,  272,
  273,  274,  275,  276,  277,  278,   -1,  280,   -1,   -1,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,  292,
   -1,   -1,   -1,   -1,   -1,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,   -1,
  313,  314,   -1,  316,  317,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  126,  335,  336,   -1,   -1,  339,  340,   -1,  342,
  343,   -1,  345,   10,  347,  348,  349,  350,  351,  352,
   -1,   -1,   -1,   -1,  357,  256,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,   33,   -1,  269,  270,
   -1,  272,  273,  274,  275,  276,  277,  278,   -1,   46,
   -1,   -1,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,  292,   59,   60,   -1,   -1,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,   -1,  313,  314,   -1,  316,  317,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,   -1,   -1,  339,  340,
   -1,  342,  343,    0,  345,   -1,  347,  348,  349,  350,
  351,  352,   -1,   10,   -1,   -1,  357,   -1,   -1,  126,
   -1,  256,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,   -1,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,   41,   -1,   -1,   44,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,   -1,   -1,
   -1,   58,   59,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,   -1,  313,  314,
   -1,  316,  317,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   10,   93,   -1,   -1,   -1,
   -1,  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,
  345,   -1,  347,  348,  349,  350,  351,  352,   33,   -1,
   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,  256,
  257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
   -1,   -1,  269,  270,   -1,  272,  273,  274,  275,  276,
  277,  278,   -1,   -1,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,  292,   -1,   -1,   -1,   -1,
   -1,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,   -1,  313,  314,   10,  316,
  317,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
   -1,   33,  339,  340,   -1,  342,  343,   -1,  345,   -1,
  347,  348,  349,  350,  351,  352,   -1,   -1,   -1,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,
  267,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  125,  126,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,  256,  257,  258,  259,  260,  261,  344,   -1,  264,
  265,  266,   -1,   -1,   -1,  270,   -1,  272,  273,  274,
  275,  276,  277,  278,   59,   -1,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,   -1,   -1,
   -1,   -1,   -1,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,   -1,  313,  314,
   -1,  316,  317,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,
  345,  126,  347,  348,  349,  350,  351,  352,   -1,   -1,
   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  256,  257,  258,  259,  260,  261,
   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,
   -1,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,   -1,   -1,   -1,   -1,   -1,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
   -1,  313,  314,   -1,  316,  317,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  336,   -1,   10,  339,  340,   -1,
  342,  343,   -1,  345,   -1,  347,  348,  349,  350,  351,
  352,   -1,   -1,   -1,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,   -1,  261,   41,   -1,   -1,
  265,  266,   -1,   -1,   -1,  270,   -1,  272,  273,  274,
  275,  276,  277,  278,   58,   59,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,   -1,  313,  314,
   -1,  316,  317,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,
   -1,  125,  347,  348,  349,  350,  351,  352,   -1,   -1,
   37,   38,  357,   -1,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,   -1,   91,   -1,   93,   94,   -1,   -1,
   -1,   -1,   10,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,   37,
   38,   -1,   -1,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,
   58,   59,   60,   61,   62,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,    0,   91,   -1,   93,   94,  281,   -1,   -1,
   -1,   -1,   10,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,   -1,   37,
   38,   -1,   -1,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,
  267,  268,  269,   91,  271,   93,   94,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,   -1,   -1,   -1,  123,  124,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,   -1,  333,  334,  335,   -1,
   -1,  338,   -1,   -1,   -1,   -1,   -1,  344,   -1,   -1,
   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  262,
  263,  264,   -1,  281,  282,  268,  269,   -1,  271,   -1,
   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,   -1,  333,  334,  335,   -1,  337,
  338,   -1,   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,  281,  282,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,   -1,  333,  334,  335,   -1,   -1,
  338,   -1,   -1,   37,   38,   -1,  344,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   37,   38,   -1,   -1,   -1,   42,   43,   -1,
   45,    0,   47,   -1,   -1,   -1,   -1,   91,   -1,   93,
   94,   10,   -1,   -1,   -1,   60,   -1,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,
  124,  125,   41,   42,   43,   44,   45,   46,   47,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   63,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,  124,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,
   -1,   62,   91,   -1,   93,   94,   -1,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,  124,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,   -1,   58,   59,   60,   61,   62,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,   -1,  271,   91,   -1,
   93,   94,   -1,   -1,   -1,   -1,   -1,  281,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,    0,   -1,   -1,   -1,
   -1,  124,  125,   -1,   -1,   -1,   10,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   -1,   -1,  333,
  334,  335,   -1,   -1,  338,   -1,   -1,   41,   -1,   -1,
  344,   -1,   -1,  262,  263,  264,   -1,   -1,  267,  268,
  269,   -1,  271,  318,   58,   59,   -1,   -1,  323,  324,
   -1,   -1,  281,  282,   -1,   -1,   -1,   -1,  333,  334,
   -1,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,   -1,   -1,  333,  334,  335,   -1,   -1,  338,
   -1,  125,   -1,   -1,   -1,  344,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,   -1,  262,
  263,  264,  333,  334,  267,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,
  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   10,   -1,   -1,   -1,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,   -1,   -1,
  333,  334,  335,   -1,   -1,  338,   -1,   -1,   37,   38,
   -1,  344,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,    0,  271,   -1,   -1,
   -1,   -1,   91,   -1,   93,   94,   10,  281,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   38,  124,  125,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   -1,   62,   63,
   -1,   37,   38,   -1,   -1,   -1,   42,   43,   -1,   45,
  344,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   60,   -1,   62,   91,   -1,   93,
   94,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,
  124,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,
   38,   -1,   -1,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,
   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,  268,
  269,   -1,  271,   91,   -1,   93,   94,   -1,   -1,   -1,
   -1,   -1,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
   -1,    0,   -1,   -1,   -1,   -1,  124,  125,   -1,   -1,
   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,   -1,   -1,  333,  334,  335,   -1,   -1,  338,
   -1,   -1,   41,   -1,   -1,  344,   -1,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,   -1,  271,   -1,   58,
   59,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   -1,   -1,  333,
  334,  335,   -1,   -1,  338,   -1,  125,   -1,   -1,   -1,
  344,   -1,  318,  319,  320,  321,  322,  323,  324,  325,
   -1,  327,  328,   -1,  262,  263,  264,  333,  334,  267,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,   -1,  333,  334,  335,   -1,   -1,
  338,   -1,   -1,   37,   38,   -1,  344,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   -1,   62,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,  268,
  269,    0,  271,   -1,   -1,   -1,   -1,   91,   -1,   93,
   94,   10,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,
  124,  125,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,
   -1,   62,   91,   -1,   93,   94,   -1,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,  124,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,   -1,   58,   59,   60,   -1,   62,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,   -1,  271,   91,   -1,
   93,   94,   -1,   -1,   -1,   -1,   -1,  281,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,    0,   -1,   -1,   -1,
   -1,  124,  125,   -1,   -1,   -1,   10,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   -1,   -1,  333,
  334,  335,   -1,   -1,  338,   -1,   -1,   41,   -1,   -1,
  344,   -1,   -1,  262,  263,  264,   -1,   -1,  267,  268,
  269,   -1,  271,   -1,   58,   59,   -1,   -1,   -1,   -1,
   37,   38,  281,  282,   -1,   42,   43,   -1,   45,   -1,
   47,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
   -1,   58,   -1,   60,   -1,   62,   63,   -1,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,   -1,   -1,  333,  334,  335,   94,   -1,  338,
   -1,  125,   -1,   -1,   -1,  344,   -1,  318,  319,  320,
  321,  322,  323,  324,   -1,   -1,  327,  328,   -1,  262,
  263,  264,  333,  334,  267,  268,  269,  124,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,
  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   10,   -1,   -1,   -1,   -1,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,   -1,   -1,
  333,  334,  335,   -1,   -1,  338,   -1,   -1,   37,   38,
   -1,  344,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,    0,  271,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   94,   10,  281,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   38,  124,  125,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   -1,   62,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,   -1,  333,  334,   -1,   93,
   94,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  124,  125,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,
   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,  268,
  269,   -1,  271,   -1,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
   -1,   -1,   -1,   -1,   -1,  124,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,    0,   -1,  333,  334,   -1,   -1,   -1,  338,
   -1,   -1,   10,   -1,   -1,  344,   -1,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,   -1,
   -1,   -1,   -1,   41,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,   -1,   -1,    0,   -1,
   58,   59,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,
   -1,   -1,   -1,   -1,   -1,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   -1,   -1,  333,
  334,   -1,   -1,    0,  338,   -1,   -1,   -1,   -1,   41,
  344,   -1,   44,   10,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,  263,  264,   -1,   59,  267,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   37,   38,  281,  282,   41,   42,   43,   44,   45,   -1,
   47,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,    0,  125,  333,  334,   93,   94,   -1,  338,
   -1,   -1,   10,   -1,   -1,  344,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,   37,
   38,   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,
  268,  269,    0,  271,   -1,   93,   94,   -1,   -1,   -1,
   -1,   -1,   10,  281,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,   -1,   37,
   38,   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,
  262,  263,  264,   -1,   -1,   -1,  268,  269,   -1,  271,
   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,
   -1,  293,  294,  295,  296,  262,  263,  264,   -1,   -1,
  267,  268,  269,   -1,  271,   93,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,   -1,   -1,   -1,   -1,  124,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,    0,   -1,  333,  334,   -1,   -1,
   -1,  338,   -1,   -1,   10,   -1,   -1,  344,   -1,   -1,
   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   37,   38,  281,  282,   41,   42,   43,   44,   45,
   -1,   47,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,    0,  333,  334,   93,   94,   -1,
  338,   -1,   -1,   -1,   10,   -1,  344,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,  124,  125,
   -1,   -1,   38,  281,  282,   41,   -1,   43,   44,   45,
   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,    0,   -1,  333,  334,   93,   94,   -1,
  338,   -1,   -1,   10,   -1,   -1,  344,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,
   -1,   38,   -1,   -1,   41,   -1,   43,   44,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   -1,
   -1,  267,  268,  269,   -1,  271,   93,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,
  296,  297,   -1,   -1,   -1,   -1,   -1,  124,  125,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,
   -1,   -1,   -1,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,   -1,   -1,  333,  334,   -1,
   -1,   -1,  338,   -1,   -1,   -1,   -1,   38,  344,   -1,
   41,   -1,   -1,   44,   -1,   -1,  262,  263,  264,   -1,
   -1,  267,  268,  269,   -1,  271,   -1,   58,   59,   60,
   -1,   62,   63,   -1,   -1,  281,  282,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,
  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,
   -1,   -1,   93,   94,   -1,   -1,   -1,   -1,   10,   -1,
   -1,   -1,   -1,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,   -1,   -1,  333,  334,   -1,
   -1,   -1,  338,  124,  125,   -1,   38,   -1,  344,   41,
   -1,   -1,   44,   -1,   -1,  262,  263,  264,   -1,   -1,
  267,  268,  269,   -1,  271,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,  281,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,
   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,   10,   -1,
   -1,   -1,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,   -1,  333,  334,   -1,   -1,
   -1,  338,  124,  125,   -1,   -1,   38,  344,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,  263,  264,   -1,   -1,  267,  268,  269,   -1,
  271,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,
  291,   -1,  293,  294,  295,  296,  297,   -1,   -1,   -1,
   -1,   -1,  124,  125,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
   -1,   -1,  333,  334,   -1,   -1,   -1,  338,   -1,   -1,
   -1,   -1,   -1,  344,   -1,   41,   -1,   -1,   44,   -1,
  262,  263,  264,   -1,   -1,  267,  268,  269,   -1,  271,
   -1,   -1,   58,   59,   60,   -1,   62,   63,   -1,  281,
  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,
   -1,  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   93,   94,   -1,
   -1,   -1,   -1,   10,   -1,   -1,   -1,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
   -1,  333,  334,   -1,   -1,   -1,  338,   -1,  124,  125,
   -1,   -1,  344,   -1,   41,   -1,   -1,   44,   -1,   -1,
  262,  263,  264,   -1,   -1,  267,  268,  269,   -1,  271,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,  281,
  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,
   -1,  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   93,   94,   -1,   -1,
   -1,   -1,   -1,   10,   -1,   -1,   -1,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  338,  124,  125,   -1,
   -1,   -1,  344,   -1,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   -1,
   -1,  267,  268,  269,   -1,  271,   93,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  281,  282,   10,   -1,   -1,
   -1,   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,
  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,
   -1,   44,   -1,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,   58,   59,   60,   -1,   62,
   63,   -1,  338,   -1,   -1,   -1,   -1,   -1,  344,   -1,
   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,
  267,  268,  269,   -1,  271,   -1,    0,   -1,   -1,   -1,
   93,   -1,   -1,   -1,  281,  282,   10,   -1,   -1,   -1,
   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  125,   -1,   -1,   -1,   -1,   41,   -1,   -1,
   44,   -1,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   58,   59,   60,   -1,   62,   63,
   -1,  338,   -1,   -1,   -1,   -1,   -1,  344,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,
  267,  268,  269,   -1,  271,   -1,    0,   -1,   -1,   93,
   -1,   -1,   -1,   -1,  281,  282,   10,   -1,   -1,   -1,
   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,
   44,   -1,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   58,   59,   60,   -1,   62,   63,
   -1,  338,   -1,   -1,   -1,   -1,   -1,  344,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
  263,  264,   -1,   -1,  267,  268,  269,   -1,  271,   93,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,
   10,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,
  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   -1,   -1,   44,   -1,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,   58,   59,
   -1,   -1,   -1,   63,   -1,  338,   -1,   -1,   -1,   -1,
   -1,  344,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,   -1,  271,   -1,    0,
   -1,   -1,   -1,   93,   -1,   -1,   -1,  281,  282,   10,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,   -1,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   58,   59,   -1,
   -1,   -1,   63,   -1,  338,   -1,   -1,   -1,   -1,   -1,
  344,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,   -1,  271,   -1,    0,
   -1,   -1,   93,   -1,   -1,   -1,   -1,  281,  282,   10,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,   -1,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   58,   59,   -1,
   -1,   -1,   63,   -1,  338,   -1,   -1,   -1,   -1,   -1,
  344,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,  263,  264,   -1,   -1,  267,  268,  269,
   -1,  271,   93,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  281,  282,   10,   -1,   -1,   -1,   -1,   -1,   -1,
  290,  291,   -1,  293,  294,  295,  296,  297,   -1,   -1,
   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  325,  326,   -1,   -1,  329,
  330,   58,   59,   -1,   -1,   -1,   63,   -1,  338,   -1,
   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,   -1,   -1,
   -1,  262,  263,  264,   -1,   -1,  267,  268,  269,   -1,
  271,   -1,    0,   -1,   -1,   -1,   93,   -1,   -1,   -1,
  281,  282,   10,   -1,   -1,   -1,   -1,   -1,   -1,  290,
  291,   -1,  293,  294,  295,  296,  297,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  325,  326,   -1,   -1,  329,  330,
   58,   59,   -1,   -1,   -1,   63,   -1,  338,   -1,   -1,
   -1,   -1,   -1,  344,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,  263,  264,   -1,   -1,  267,  268,  269,   -1,
  271,   -1,    0,   -1,   -1,   93,   -1,   -1,   -1,   -1,
  281,  282,   10,   -1,   -1,   -1,   -1,   -1,   -1,  290,
  291,   -1,  293,  294,  295,  296,  297,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  325,  326,   -1,   -1,  329,  330,
   58,   59,   -1,   -1,   -1,   63,   -1,  338,   -1,   -1,
   -1,   -1,   -1,  344,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,
  267,  268,  269,   -1,  271,   93,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  281,  282,   10,   -1,   -1,   -1,
   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  325,  326,
   -1,   -1,  329,  330,   58,   59,   -1,   -1,   -1,   63,
   -1,  338,   -1,   -1,   -1,   -1,   -1,  344,   -1,   -1,
   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,
  268,  269,   -1,  271,   -1,    0,   -1,   -1,   -1,   93,
   -1,   -1,   -1,  281,  282,   10,   -1,   -1,   -1,   -1,
   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  125,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  325,  326,   -1,
   -1,  329,  330,   58,   59,   -1,   -1,   -1,   63,   -1,
  338,   -1,   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,
  268,  269,   -1,  271,   -1,    0,   -1,   -1,   93,   -1,
   -1,   -1,   -1,  281,  282,   10,   -1,   -1,   -1,   -1,
   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,  297,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  125,    0,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   10,   -1,   -1,   -1,   -1,   -1,  325,  326,   -1,
   -1,  329,  330,   58,   59,   -1,   -1,   -1,   63,   -1,
  338,   -1,   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,  262,  263,
  264,   -1,   -1,  267,  268,  269,   -1,  271,   93,   58,
   59,    0,   -1,   -1,   63,   -1,   -1,  281,  282,   -1,
   -1,   10,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,
  125,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,  325,  326,   -1,   -1,  329,  330,   -1,   -1,   58,
   59,   -1,   -1,   -1,  338,   -1,  125,   -1,   -1,   -1,
  344,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,  264,
   -1,   -1,  267,  268,  269,   -1,  271,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   93,   -1,  281,  282,   10,   -1,
   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,  294,
  295,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  326,   -1,   -1,  329,  330,   58,   59,    0,   -1,
   -1,   -1,   -1,  338,   -1,   -1,   -1,   -1,   10,  344,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,  264,
   -1,   -1,  267,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   -1,   -1,  281,  282,   -1,   41,
   -1,   -1,   44,   -1,   -1,  290,  291,   -1,  293,  294,
  295,  296,  297,  262,  263,  264,   58,   59,  267,  268,
  269,   -1,  271,  125,   -1,   -1,    0,   -1,   -1,   -1,
   -1,   -1,  281,  282,   -1,   -1,   10,   -1,   -1,   -1,
   -1,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
   -1,   93,   -1,  338,   -1,   -1,   -1,   -1,   -1,  344,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,
   44,   -1,   -1,  262,  263,  264,   -1,   -1,  267,  268,
  269,    0,  271,  125,   58,   59,   -1,   -1,   -1,  338,
   -1,   10,  281,  282,   -1,  344,   -1,   -1,   -1,   -1,
   -1,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,  338,
   -1,  125,   10,   -1,   -1,  344,   -1,   -1,   -1,   -1,
  262,  263,  264,   -1,   -1,  267,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,  281,
  282,   -1,   -1,   41,   -1,   -1,   44,   -1,  290,  291,
   -1,  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,
   58,   59,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,  263,  264,   -1,   -1,  267,  268,  269,   -1,  271,
   -1,   -1,   -1,    0,   -1,   93,  338,   -1,   -1,  281,
  282,   -1,  344,   10,   -1,   -1,   -1,   -1,  290,  291,
   -1,  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,
  264,   58,   59,  267,  268,  269,  338,  271,   -1,   -1,
   -1,   -1,  344,   -1,   -1,   -1,   -1,  281,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,
  294,  295,  296,  297,    0,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  125,   -1,
   -1,   -1,  281,  282,  338,   41,   -1,   -1,   44,   -1,
  344,  290,  291,   -1,  293,  294,  295,  296,  297,   -1,
   -1,   -1,   58,   59,   -1,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,
  268,  269,   -1,  271,   -1,   -1,   -1,   93,   -1,  338,
   -1,   -1,   -1,  281,  282,  344,   41,   -1,   -1,   44,
   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,  297,
    0,   -1,   -1,   58,   59,   -1,   -1,   -1,   -1,  125,
   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   93,   -1,
  338,   41,   -1,   -1,   44,   -1,  344,   10,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   58,   59,
  267,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  125,   -1,   -1,   -1,  281,  282,   -1,   -1,   41,   -1,
   -1,   44,   -1,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,   -1,   93,   -1,   58,   59,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,
   93,  338,   -1,   -1,   -1,   -1,   -1,  344,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,  262,  263,  264,   -1,
   -1,  267,  268,  269,   -1,  271,   58,   59,   -1,   -1,
   -1,   -1,  125,   -1,   -1,  281,  282,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,
  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,  264,
   -1,   -1,  267,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  338,  125,   -1,   -1,  281,  282,  344,   -1,
   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,  293,  294,
  295,  296,  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   10,  262,  263,  264,   -1,   -1,  267,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  281,  282,  338,   -1,   -1,   -1,   -1,   -1,  344,
  290,  291,   41,  293,  294,  295,  296,  297,   -1,  262,
  263,  264,   -1,   -1,  267,  268,  269,   -1,  271,   58,
   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,
  293,  294,  295,  296,  297,   -1,   -1,   -1,  338,   -1,
   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,
  262,  263,  264,   -1,   -1,  267,  268,  269,   10,  271,
   -1,   -1,   -1,   -1,   -1,  338,  125,   -1,   -1,  281,
  282,  344,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,
   -1,  293,  294,  295,  296,   37,   38,   -1,   -1,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  338,   -1,   -1,   -1,
   -1,   -1,  344,    0,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   -1,   94,   10,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   37,   38,  124,  125,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,  262,  263,  264,   -1,   -1,  267,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  281,   -1,   91,   -1,   -1,   94,   -1,    0,
   -1,  290,  291,   -1,  293,  294,  295,  296,  297,   10,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   10,   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   41,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,   58,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,  263,  264,   -1,   -1,  267,  268,  269,   -1,  271,
   91,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,  281,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,
   -1,  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  125,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
   -1,  333,  334,  335,   -1,   -1,  338,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,  263,  264,   -1,   -1,
  267,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  281,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,  296,
  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,   -1,  333,  334,  335,   -1,
   -1,  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,  263,  264,   -1,   -1,  267,  268,  269,   -1,
  271,   -1,  262,  263,  264,   -1,   -1,  267,  268,  269,
  281,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,
  291,  281,  293,  294,  295,  296,  297,   -1,    0,   -1,
   -1,   -1,   -1,  293,  294,  295,  296,  297,   10,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
   -1,   -1,  333,  334,  335,   37,   38,  338,   -1,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   91,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   37,   38,   -1,   -1,   41,   42,   43,   44,   45,
   46,   47,  124,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   60,   61,   62,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,  124,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,  263,  264,   -1,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,  124,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,
   -1,  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
   -1,  333,  334,  335,   -1,  337,  262,  263,  264,   -1,
   -1,   33,  268,  269,   -1,  271,   -1,   -1,   -1,   37,
   38,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,  290,  291,   -1,  293,  294,  295,
  296,  297,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,   -1,   94,  333,  334,  335,
  262,  263,  264,   -1,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  126,   -1,  124,   -1,  290,  291,
   -1,  293,  294,  295,  296,  297,   -1,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
   -1,  333,  334,  335,   37,   38,   -1,   -1,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   33,   -1,   -1,  256,  257,  258,  259,  260,  261,
   -1,  124,  125,  265,  266,   -1,   -1,   -1,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,   59,   -1,   -1,
   -1,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,   -1,   -1,   -1,   -1,   -1,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
   -1,  313,  314,   -1,  316,  317,   -1,   -1,   -1,   -1,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,  336,  333,  334,  339,  340,   -1,
  342,  343,   -1,  345,  126,  347,  348,  349,  350,  351,
  352,   -1,   33,   -1,   -1,  357,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
  263,  264,   -1,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,   -1,
  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,  126,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,   -1,   -1,
  333,  334,  335,   -1,   -1,  257,  258,  259,  260,  261,
   -1,   33,   -1,  265,  266,   -1,   -1,   -1,  270,   41,
  272,  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,
   -1,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,   -1,   -1,   -1,   -1,   -1,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
   -1,  313,  314,   -1,  316,  317,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,  340,   -1,
  342,  343,   -1,  345,   -1,  347,  348,  349,  350,  351,
  352,   -1,   -1,   -1,  126,  357,  257,  258,  259,  260,
  261,   -1,   33,   -1,  265,  266,   -1,   -1,   -1,  270,
   -1,  272,  273,  274,  275,  276,  277,  278,   -1,   -1,
   -1,   -1,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,  292,   -1,   -1,   -1,   -1,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,   -1,  313,  314,   -1,  316,  317,   -1,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,   -1,   -1,  333,  334,  336,   -1,   -1,  339,  340,
   -1,  342,  343,   -1,  345,   -1,  347,  348,  349,  350,
  351,  352,   -1,   -1,   -1,  126,  357,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,   -1,  261,
   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,
   -1,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
   -1,  313,  314,   -1,  316,  317,   -1,   -1,   -1,   -1,
   -1,   -1,  126,   -1,   -1,   -1,   33,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,  340,   -1,
  342,  343,   -1,  345,  346,  347,  348,  349,  350,  351,
  352,   -1,   -1,   -1,   -1,  357,  257,  258,  259,   -1,
  261,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,
   -1,  272,  273,  274,  275,  276,  277,  278,   -1,   -1,
   -1,   -1,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,  292,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,   -1,  313,  314,   -1,  316,  317,   -1,   -1,  126,
   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,  340,
   -1,  342,  343,   -1,  345,  346,  347,  348,  349,  350,
  351,  352,   -1,  257,  258,  259,  357,  261,   -1,   -1,
   -1,  265,  266,   -1,   -1,   -1,  270,   -1,  272,  273,
  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,  283,
  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,   -1,  313,
  314,   -1,  316,  317,   -1,   -1,  126,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  336,   -1,   -1,  339,  340,   -1,  342,  343,
   -1,  345,  346,  347,  348,  349,  350,  351,  352,   -1,
  257,  258,  259,  357,  261,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,  270,   -1,  272,  273,  274,  275,  276,
  277,  278,   -1,   -1,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,   -1,  313,  314,   -1,  316,
  317,   -1,   -1,  126,   -1,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,
   -1,   -1,  339,  340,   -1,  342,  343,   -1,  345,  346,
  347,  348,  349,  350,  351,  352,   -1,  257,  258,  259,
  357,  261,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  270,   -1,  272,  273,  274,  275,  276,  277,  278,   -1,
   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,   -1,  313,  314,   -1,  316,  317,   -1,   -1,
  126,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,
  340,   -1,  342,  343,   -1,  345,  346,  347,  348,  349,
  350,  351,  352,   -1,  257,  258,  259,  357,  261,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  270,   -1,  272,
  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,   -1,
  313,  314,   -1,  316,  317,   -1,   -1,  126,   -1,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  336,   -1,   -1,  339,  340,   -1,  342,
  343,   -1,  345,  346,  347,  348,  349,  350,  351,  352,
   -1,  257,  258,  259,  357,  261,   -1,   -1,   -1,  265,
  266,   -1,   -1,   -1,  270,   -1,  272,  273,  274,  275,
  276,  277,  278,   -1,   -1,   -1,   -1,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,   -1,  313,  314,   -1,
  316,  317,   -1,   -1,  126,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,  345,
  346,  347,  348,  349,  350,  351,  352,   -1,  257,  258,
  259,  357,  261,   -1,   -1,   -1,  265,  266,   -1,   -1,
   -1,  270,   -1,  272,  273,  274,  275,  276,  277,  278,
   -1,   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,
  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,   -1,  313,  314,   -1,  316,  317,   -1,
   -1,  126,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,
  339,  340,   -1,  342,  343,   -1,  345,  346,  347,  348,
  349,  350,  351,  352,   -1,  257,  258,  259,  357,  261,
   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,
   -1,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
   -1,  313,  314,   -1,  316,  317,   -1,   -1,  126,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,  340,   -1,
  342,  343,   -1,  345,  346,  347,  348,  349,  350,  351,
  352,   -1,  257,  258,  259,  357,  261,   -1,   -1,   -1,
  265,  266,   -1,   -1,   -1,  270,   -1,  272,  273,  274,
  275,  276,  277,  278,   -1,   -1,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,   -1,  313,  314,
   -1,  316,  317,   -1,   -1,  126,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,
  345,  346,  347,  348,  349,  350,  351,  352,   -1,  257,
  258,  259,  357,  261,   -1,   -1,   -1,  265,  266,   -1,
   -1,   -1,  270,   -1,  272,  273,  274,  275,  276,  277,
  278,   -1,   -1,   -1,   -1,  283,  284,  285,  286,  287,
  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,   -1,  313,  314,   -1,  316,  317,
   -1,   -1,  126,   -1,   -1,   -1,   33,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,
   -1,  339,  340,   -1,  342,  343,   -1,  345,  346,  347,
  348,  349,  350,  351,  352,   -1,  257,  258,  259,  357,
  261,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,
   -1,  272,  273,  274,  275,  276,  277,  278,   -1,   -1,
   -1,   -1,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,   -1,  313,  314,   -1,  316,  317,   -1,   -1,  126,
   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,  340,
   -1,  342,  343,   -1,  345,  346,  347,  348,  349,  350,
  351,  352,   -1,  257,  258,  259,  357,  261,   -1,   -1,
   -1,  265,  266,   -1,   -1,   -1,  270,   -1,  272,  273,
  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,  283,
  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,   -1,  313,
  314,   -1,  316,  317,   -1,   -1,  126,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  336,   -1,   -1,  339,  340,   -1,  342,  343,
   -1,  345,  346,  347,  348,  349,  350,  351,  352,   -1,
  257,  258,  259,  357,  261,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,  270,   -1,  272,  273,  274,  275,  276,
  277,  278,   -1,   -1,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,   -1,  313,  314,   -1,  316,
  317,   -1,   -1,  126,   -1,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,
   -1,   -1,  339,  340,   -1,  342,  343,   -1,  345,  346,
  347,  348,  349,  350,  351,  352,   -1,  257,  258,  259,
  357,  261,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  270,   -1,  272,  273,  274,  275,  276,  277,  278,   -1,
   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,  292,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,   -1,  313,  314,   -1,  316,  317,   -1,   -1,
  126,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,
  340,   -1,  342,  343,   -1,   -1,   -1,  347,  348,  349,
  350,  351,  352,   -1,  257,  258,  259,  357,  261,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  270,   -1,  272,
  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,   -1,
  313,  314,   -1,  316,  317,   -1,   -1,  126,   -1,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  336,   -1,   -1,  339,  340,   -1,  342,
  343,   -1,  345,   -1,  347,  348,  349,  350,  351,  352,
   -1,  257,  258,  259,  357,  261,   -1,   -1,   -1,  265,
  266,   -1,   -1,   -1,  270,   -1,  272,  273,  274,  275,
  276,  277,  278,   -1,   -1,   -1,   -1,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,   -1,  313,  314,   -1,
  316,  317,   -1,   -1,  126,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,  345,
   -1,  347,  348,  349,  350,  351,  352,   -1,  257,  258,
  259,  357,  261,   -1,   -1,   -1,  265,  266,   -1,   -1,
   -1,  270,   -1,  272,  273,  274,  275,  276,  277,  278,
   -1,   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,
  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,   -1,  313,  314,   -1,  316,  317,   -1,
   -1,  126,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,
  339,  340,   -1,  342,  343,   -1,  345,   -1,  347,  348,
  349,  350,  351,  352,   -1,  257,  258,  259,  357,  261,
   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,
   -1,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
   -1,  313,  314,   -1,  316,  317,   -1,   -1,  126,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,  340,   -1,
  342,  343,   -1,  345,   -1,  347,  348,  349,  350,  351,
  352,   -1,  257,  258,  259,  357,  261,   -1,   -1,   -1,
  265,  266,   -1,   -1,   -1,  270,   -1,  272,  273,  274,
  275,  276,  277,  278,   -1,   -1,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,   -1,  313,  314,
   -1,  316,  317,   -1,   -1,  126,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   -1,  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,
  345,   -1,  347,  348,  349,  350,  351,  352,   -1,  257,
  258,  259,  357,  261,   -1,   -1,   -1,  265,  266,   -1,
   -1,   -1,  270,   -1,  272,  273,  274,  275,  276,  277,
  278,   -1,   -1,   -1,   -1,  283,  284,  285,  286,  287,
  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,   -1,  313,  314,   -1,  316,  317,
   -1,   -1,  126,   -1,   -1,   -1,   33,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,
   -1,  339,  340,   -1,  342,  343,   -1,  345,   -1,  347,
  348,  349,  350,  351,  352,   -1,  257,  258,  259,  357,
  261,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,
   -1,  272,  273,  274,  275,  276,  277,  278,   -1,   -1,
   -1,   -1,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,   -1,  313,  314,   -1,  316,  317,   -1,   -1,  126,
   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,  340,
   -1,  342,  343,   -1,  345,   -1,  347,  348,  349,  350,
  351,  352,   -1,  257,  258,  259,  357,  261,   -1,   -1,
   -1,  265,  266,   -1,   -1,   -1,  270,   -1,  272,  273,
  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,  283,
  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,   -1,  313,
  314,   -1,  316,  317,   -1,   -1,  126,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  336,   -1,   -1,  339,  340,   -1,  342,  343,
   -1,   -1,   -1,  347,  348,  349,  350,  351,  352,   -1,
  257,  258,  259,  357,  261,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,  270,   -1,  272,  273,  274,  275,  276,
  277,  278,   -1,   -1,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,   -1,  313,  314,   -1,  316,
  317,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,
   -1,   -1,  339,  340,   -1,  342,  343,   -1,   -1,   -1,
  347,  348,  349,  350,  351,  352,   -1,  257,  258,  259,
  357,  261,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  270,   -1,  272,  273,  274,  275,  276,  277,  278,   -1,
   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,   -1,  313,  314,   -1,  316,  317,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,
  340,   -1,  342,  343,   -1,   -1,   -1,  347,  348,  349,
  350,  351,  352,   -1,  257,  258,  259,  357,  261,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  270,   -1,  272,
  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   -1,  299,   -1,   -1,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,   -1,
  313,  314,   -1,  316,  317,   -1,   -1,   -1,   37,   38,
   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,  336,   -1,   -1,  339,  340,   -1,  342,
  343,   60,   -1,   62,  347,  348,  349,  350,  351,  352,
   -1,   -1,   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   96,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,  126,   -1,   37,
   38,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
   -1,  261,   60,   -1,   62,  265,  266,   -1,   -1,   -1,
  270,   -1,  272,  273,  274,  275,  276,  277,  278,   -1,
   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   96,  299,
   -1,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,   -1,  313,  314,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,  126,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,
  340,   -1,  342,  343,   -1,  345,   -1,  347,  348,  349,
  350,  351,  352,   -1,   -1,   -1,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,   -1,   -1,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,   -1,   -1,   -1,   -1,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,  306,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,
  319,  320,  321,   -1,  323,  324,   -1,   -1,  327,   -1,
   -1,   -1,  331,  332,  333,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  345,   -1,  347,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,   -1,   -1,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,   -1,   -1,   -1,   -1,   -1,
  298,  299,  300,  301,  302,  303,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  316,  317,
  318,  319,  320,  321,   -1,  323,  324,   -1,   -1,  327,
   -1,   -1,   -1,  331,  332,  333,  334,   -1,   37,   38,
   -1,   40,   -1,   42,   43,   -1,   45,  345,   47,  347,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   60,   -1,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   96,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,  126,   37,   38,
   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,   -1,
  261,   60,   -1,   62,  265,  266,   -1,   -1,   -1,  270,
   -1,  272,  273,  274,  275,  276,  277,  278,   -1,   -1,
   -1,   -1,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   96,  299,   -1,
   -1,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,   -1,  313,  314,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,  126,   -1,   -1,
   -1,   -1,  333,   -1,   -1,  336,   -1,   -1,  339,  340,
   -1,  342,  343,   -1,   -1,   -1,  347,  348,  349,  350,
  351,  352,   -1,   -1,   -1,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,   -1,   -1,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,   -1,   -1,   -1,   -1,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,
  319,  320,  321,   -1,  323,  324,   -1,   -1,  327,   -1,
   -1,   -1,  331,  332,  333,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  345,   -1,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,   -1,   -1,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,   -1,   -1,   -1,   -1,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,
  319,  320,  321,   -1,  323,  324,   -1,   -1,  327,   -1,
   -1,   -1,  331,  332,  333,  334,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   -1,   45,  345,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   60,   -1,   62,   -1,   -1,   -1,   -1,   -1,   37,   38,
   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   60,   -1,   62,   94,   -1,   96,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   94,  126,   96,   -1,   60,
   -1,   62,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,  126,   -1,   -1,
   60,   -1,   62,   94,   -1,   96,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,   94,  126,   96,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   -1,  126,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,   -1,   -1,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,   -1,   -1,   -1,   -1,   -1,  298,  299,
  300,  301,  302,  303,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,  319,
  320,  321,   -1,  323,  324,   -1,   -1,  327,   -1,   -1,
   -1,  331,  332,  333,  334,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,  345,   -1,  316,  317,  318,
  319,  320,  321,   -1,  323,  324,   -1,   -1,  327,   -1,
   -1,   -1,  331,  332,  333,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  304,  305,   -1,  345,  308,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  316,  317,  318,  319,  320,
  321,   -1,  323,  324,   -1,   -1,  327,   -1,   -1,   -1,
  331,  332,  333,  334,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,  345,   -1,  316,  317,  318,  319,
  320,  321,   -1,  323,  324,   -1,   -1,  327,   -1,   -1,
   -1,  331,  332,  333,  334,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,  345,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,
   -1,   62,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,
   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   60,   -1,   62,   94,   -1,   96,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,   94,  126,   96,   -1,   60,   -1,
   62,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   -1,  126,   -1,   -1,   60,
   -1,   62,   94,   -1,   96,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  124,   94,  126,   96,   -1,   60,   -1,   62,
   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  124,   -1,  126,   -1,   -1,   60,   -1,
   62,   94,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  124,   94,  126,   96,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  124,   -1,  126,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  316,  317,  318,  319,  320,
  321,   -1,  323,  324,   -1,   -1,  327,   -1,   -1,   -1,
  331,  332,  333,  334,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,  345,   -1,  316,  317,  318,  319,
  320,  321,   -1,  323,  324,   -1,   -1,  327,   -1,   -1,
   -1,  331,  332,  333,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  304,  305,   -1,  345,  308,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  316,  317,  318,  319,  320,  321,
   -1,  323,  324,   -1,   -1,  327,   -1,   -1,   -1,  331,
  332,  333,  334,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,  345,   -1,  316,  317,  318,  319,  320,
  321,   -1,  323,  324,   -1,   -1,  327,   -1,   -1,   -1,
  331,  332,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  304,  305,   -1,  345,  308,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  316,  317,  318,  319,  320,  321,   -1,
  323,  324,   -1,   -1,  327,   -1,   -1,   -1,  331,  332,
  333,  334,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,  345,   -1,  316,  317,  318,  319,  320,  321,
   -1,  323,  324,   -1,   -1,  327,   -1,   -1,   -1,  331,
  332,  333,  334,   -1,   37,   38,   -1,   -1,   -1,   42,
   43,   -1,   45,  345,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,   -1,   62,
   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,   -1,
   62,   94,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  124,   94,  126,   96,   -1,   60,   -1,   62,   -1,
   -1,   -1,   37,   38,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  124,   -1,  126,   60,   -1,   62,   63,   -1,
   94,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,   -1,  261,   -1,   -1,   -1,  265,  266,   -1,   94,
  124,  270,  126,  272,  273,  274,  275,  276,  277,  278,
   -1,   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,
  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,
  299,   -1,   -1,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,   -1,  313,  314,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,
  339,  340,   -1,  342,  343,   -1,  345,   -1,  347,  348,
  349,  350,  351,  352,   -1,   -1,   -1,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  316,  317,  318,  319,  320,  321,   -1,
  323,  324,   -1,   -1,  327,   -1,   -1,   -1,  331,  332,
  333,  334,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,  345,   -1,  316,  317,  318,  319,  320,  321,
   -1,  323,  324,   -1,   -1,  327,   -1,   -1,   -1,  331,
  332,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  304,  305,   -1,  345,  308,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  316,  317,  318,  319,  320,  321,   -1,  323,
  324,   -1,  297,  327,   -1,   -1,   -1,  331,  332,  333,
  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  345,   -1,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,   -1,   -1,  333,  334,
  257,  258,  259,   -1,  261,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,  270,   -1,  272,  273,  274,  275,  276,
  277,  278,   -1,   -1,   -1,   -1,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,   -1,  313,  314,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,
   -1,   -1,  339,  340,   -1,  342,  343,   -1,  345,   -1,
  347,  348,  349,  350,  351,  352,   -1,  257,  258,  259,
  357,  261,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  270,   -1,  272,  273,  274,  275,  276,  277,  278,   -1,
   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,   -1,  313,  314,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,
  340,   -1,  342,  343,   -1,   -1,   -1,  347,  348,  349,
  350,  351,  352,   -1,  257,  258,  259,  357,  261,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  270,   -1,  272,
  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,   -1,
  313,  314,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  336,   -1,   -1,  339,  340,   -1,  342,
  343,   -1,   -1,   -1,  347,  348,  349,  350,  351,  352,
   -1,  257,  258,  259,  357,  261,   -1,   -1,   -1,  265,
  266,   -1,   -1,   -1,  270,   -1,  272,  273,  274,  275,
  276,  277,  278,   -1,   -1,   -1,   -1,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  311,   -1,  313,  314,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  336,   -1,   -1,  339,  340,   -1,  342,  343,   -1,   -1,
   -1,  347,  348,  349,  350,  351,  352,   -1,   -1,   -1,
   -1,  357,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 358
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"' '","'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'",
"'/'",0,0,0,0,0,0,0,0,0,0,"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,"'`'",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"kCLASS","kMODULE","kDEF","kUNDEF","kBEGIN","kRESCUE","kENSURE","kEND","kIF",
"kUNLESS","kTHEN","kELSIF","kELSE","kCASE","kWHEN","kWHILE","kUNTIL","kFOR",
"kBREAK","kNEXT","kREDO","kRETRY","kIN","kDO","kDO_COND","kDO_BLOCK","kRETURN",
"kYIELD","kSUPER","kSELF","kNIL","kTRUE","kFALSE","kAND","kOR","kNOT","kIF_MOD",
"kUNLESS_MOD","kWHILE_MOD","kUNTIL_MOD","kRESCUE_MOD","kALIAS","kDEFINED",
"klBEGIN","klEND","k__LINE__","k__FILE__","tIDENTIFIER","tFID","tGVAR","tIVAR",
"tCONSTANT","tCVAR","tINTEGER","tFLOAT","tSTRING_CONTENT","tNTH_REF",
"tBACK_REF","tREGEXP_END","tUPLUS","tUMINUS","tPOW","tCMP","tEQ","tEQQ","tNEQ",
"tGEQ","tLEQ","tANDOP","tOROP","tMATCH","tNMATCH","tDOT2","tDOT3","tAREF",
"tASET","tLSHFT","tRSHFT","tCOLON2","tCOLON3","tOP_ASGN","tASSOC","tLPAREN",
"tLPAREN_ARG","tRPAREN","tLBRACK","tLBRACE","tLBRACE_ARG","tSTAR","tAMPER",
"tSYMBEG","tSTRING_BEG","tXSTRING_BEG","tREGEXP_BEG","tWORDS_BEG","tQWORDS_BEG",
"tSTRING_DBEG","tSTRING_DVAR","tSTRING_END","tLOWEST","tUMINUS_NUM",
"tLAST_TOKEN",
};
const char * const yyrule[] = {
"$accept : program",
"$$1 :",
"program : $$1 compstmt",
"bodystmt : compstmt opt_rescue opt_else opt_ensure",
"compstmt : stmts opt_terms",
"stmts : none",
"stmts : stmt",
"stmts : stmts terms stmt",
"stmts : error stmt",
"$$2 :",
"stmt : kALIAS fitem $$2 fitem",
"stmt : kALIAS tGVAR tGVAR",
"stmt : kALIAS tGVAR tBACK_REF",
"stmt : kALIAS tGVAR tNTH_REF",
"stmt : kUNDEF undef_list",
"stmt : stmt kIF_MOD expr_value",
"stmt : stmt kUNLESS_MOD expr_value",
"stmt : stmt kWHILE_MOD expr_value",
"stmt : stmt kUNTIL_MOD expr_value",
"stmt : stmt kRESCUE_MOD stmt",
"$$3 :",
"stmt : klBEGIN $$3 '{' compstmt '}'",
"stmt : klEND '{' compstmt '}'",
"stmt : lhs '=' command_call",
"stmt : mlhs '=' command_call",
"stmt : var_lhs tOP_ASGN command_call",
"stmt : primary_value '[' aref_args ']' tOP_ASGN command_call",
"stmt : primary_value '.' tIDENTIFIER tOP_ASGN command_call",
"stmt : primary_value '.' tCONSTANT tOP_ASGN command_call",
"stmt : primary_value tCOLON2 tIDENTIFIER tOP_ASGN command_call",
"stmt : backref tOP_ASGN command_call",
"stmt : lhs '=' mrhs",
"stmt : mlhs '=' arg_value",
"stmt : mlhs '=' mrhs",
"stmt : expr",
"expr : command_call",
"expr : expr kAND expr",
"expr : expr kOR expr",
"expr : kNOT expr",
"expr : '!' command_call",
"expr : arg",
"expr_value : expr",
"command_call : command",
"command_call : block_command",
"command_call : kRETURN call_args",
"command_call : kBREAK call_args",
"command_call : kNEXT call_args",
"block_command : block_call",
"block_command : block_call '.' operation2 command_args",
"block_command : block_call tCOLON2 operation2 command_args",
"$$4 :",
"$$5 :",
"cmd_brace_block : tLBRACE_ARG $$4 opt_block_var $$5 compstmt '}'",
"command : operation command_args",
"command : operation command_args cmd_brace_block",
"command : primary_value '.' operation2 command_args",
"command : primary_value '.' operation2 command_args cmd_brace_block",
"command : primary_value tCOLON2 operation2 command_args",
"command : primary_value tCOLON2 operation2 command_args cmd_brace_block",
"command : kSUPER command_args",
"command : kYIELD command_args",
"mlhs : mlhs_basic",
"mlhs : tLPAREN mlhs_entry ')'",
"mlhs_entry : mlhs_basic",
"mlhs_entry : tLPAREN mlhs_entry ')'",
"mlhs_basic : mlhs_head",
"mlhs_basic : mlhs_head mlhs_item",
"mlhs_basic : mlhs_head tSTAR mlhs_node",
"mlhs_basic : mlhs_head tSTAR",
"mlhs_basic : tSTAR mlhs_node",
"mlhs_basic : tSTAR",
"mlhs_item : mlhs_node",
"mlhs_item : tLPAREN mlhs_entry ')'",
"mlhs_head : mlhs_item ','",
"mlhs_head : mlhs_head mlhs_item ','",
"mlhs_node : variable",
"mlhs_node : primary_value '[' aref_args ']'",
"mlhs_node : primary_value '.' tIDENTIFIER",
"mlhs_node : primary_value tCOLON2 tIDENTIFIER",
"mlhs_node : primary_value '.' tCONSTANT",
"mlhs_node : primary_value tCOLON2 tCONSTANT",
"mlhs_node : tCOLON3 tCONSTANT",
"mlhs_node : backref",
"lhs : variable",
"lhs : primary_value '[' aref_args ']'",
"lhs : primary_value '.' tIDENTIFIER",
"lhs : primary_value tCOLON2 tIDENTIFIER",
"lhs : primary_value '.' tCONSTANT",
"lhs : primary_value tCOLON2 tCONSTANT",
"lhs : tCOLON3 tCONSTANT",
"lhs : backref",
"cname : tIDENTIFIER",
"cname : tCONSTANT",
"cpath : tCOLON3 cname",
"cpath : cname",
"cpath : primary_value tCOLON2 cname",
"fname : tIDENTIFIER",
"fname : tCONSTANT",
"fname : tFID",
"fname : op",
"fname : reswords",
"fsym : fname",
"fsym : symbol",
"fitem : fsym",
"fitem : dsym",
"undef_list : fitem",
"$$6 :",
"undef_list : undef_list ',' $$6 fitem",
"op : '|'",
"op : '^'",
"op : '&'",
"op : tCMP",
"op : tEQ",
"op : tEQQ",
"op : tMATCH",
"op : '>'",
"op : tGEQ",
"op : '<'",
"op : tLEQ",
"op : tLSHFT",
"op : tRSHFT",
"op : '+'",
"op : '-'",
"op : '*'",
"op : tSTAR",
"op : '/'",
"op : '%'",
"op : tPOW",
"op : '~'",
"op : tUPLUS",
"op : tUMINUS",
"op : tAREF",
"op : tASET",
"op : '`'",
"reswords : k__LINE__",
"reswords : k__FILE__",
"reswords : klBEGIN",
"reswords : klEND",
"reswords : kALIAS",
"reswords : kAND",
"reswords : kBEGIN",
"reswords : kBREAK",
"reswords : kCASE",
"reswords : kCLASS",
"reswords : kDEF",
"reswords : kDEFINED",
"reswords : kDO",
"reswords : kELSE",
"reswords : kELSIF",
"reswords : kEND",
"reswords : kENSURE",
"reswords : kFALSE",
"reswords : kFOR",
"reswords : kIN",
"reswords : kMODULE",
"reswords : kNEXT",
"reswords : kNIL",
"reswords : kNOT",
"reswords : kOR",
"reswords : kREDO",
"reswords : kRESCUE",
"reswords : kRETRY",
"reswords : kRETURN",
"reswords : kSELF",
"reswords : kSUPER",
"reswords : kTHEN",
"reswords : kTRUE",
"reswords : kUNDEF",
"reswords : kWHEN",
"reswords : kYIELD",
"reswords : kIF",
"reswords : kUNLESS",
"reswords : kWHILE",
"reswords : kUNTIL",
"arg : lhs '=' arg",
"arg : lhs '=' arg kRESCUE_MOD arg",
"arg : var_lhs tOP_ASGN arg",
"arg : primary_value '[' aref_args ']' tOP_ASGN arg",
"arg : primary_value '.' tIDENTIFIER tOP_ASGN arg",
"arg : primary_value '.' tCONSTANT tOP_ASGN arg",
"arg : primary_value tCOLON2 tIDENTIFIER tOP_ASGN arg",
"arg : primary_value tCOLON2 tCONSTANT tOP_ASGN arg",
"arg : tCOLON3 tCONSTANT tOP_ASGN arg",
"arg : backref tOP_ASGN arg",
"arg : arg tDOT2 arg",
"arg : arg tDOT3 arg",
"arg : arg '+' arg",
"arg : arg '-' arg",
"arg : arg '*' arg",
"arg : arg '/' arg",
"arg : arg '%' arg",
"arg : arg tPOW arg",
"arg : tUMINUS_NUM tINTEGER tPOW arg",
"arg : tUMINUS_NUM tFLOAT tPOW arg",
"arg : tUPLUS arg",
"arg : tUMINUS arg",
"arg : arg '|' arg",
"arg : arg '^' arg",
"arg : arg '&' arg",
"arg : arg tCMP arg",
"arg : arg '>' arg",
"arg : arg tGEQ arg",
"arg : arg '<' arg",
"arg : arg tLEQ arg",
"arg : arg tEQ arg",
"arg : arg tEQQ arg",
"arg : arg tNEQ arg",
"arg : arg tMATCH arg",
"arg : arg tNMATCH arg",
"arg : '!' arg",
"arg : '~' arg",
"arg : arg tLSHFT arg",
"arg : arg tRSHFT arg",
"arg : arg tANDOP arg",
"arg : arg tOROP arg",
"$$7 :",
"arg : kDEFINED opt_nl $$7 arg",
"arg : arg '?' arg ':' arg",
"arg : primary",
"arg_value : arg",
"aref_args : none",
"aref_args : command opt_nl",
"aref_args : args trailer",
"aref_args : args ',' tSTAR arg opt_nl",
"aref_args : assocs trailer",
"aref_args : tSTAR arg opt_nl",
"paren_args : '(' none ')'",
"paren_args : '(' call_args opt_nl ')'",
"paren_args : '(' block_call opt_nl ')'",
"paren_args : '(' args ',' block_call opt_nl ')'",
"opt_paren_args : none",
"opt_paren_args : paren_args",
"call_args : command",
"call_args : args opt_block_arg",
"call_args : args ',' tSTAR arg_value opt_block_arg",
"call_args : assocs opt_block_arg",
"call_args : assocs ',' tSTAR arg_value opt_block_arg",
"call_args : args ',' assocs opt_block_arg",
"call_args : args ',' assocs ',' tSTAR arg opt_block_arg",
"call_args : tSTAR arg_value opt_block_arg",
"call_args : block_arg",
"call_args2 : arg_value ',' args opt_block_arg",
"call_args2 : arg_value ',' block_arg",
"call_args2 : arg_value ',' tSTAR arg_value opt_block_arg",
"call_args2 : arg_value ',' args ',' tSTAR arg_value opt_block_arg",
"call_args2 : assocs opt_block_arg",
"call_args2 : assocs ',' tSTAR arg_value opt_block_arg",
"call_args2 : arg_value ',' assocs opt_block_arg",
"call_args2 : arg_value ',' args ',' assocs opt_block_arg",
"call_args2 : arg_value ',' assocs ',' tSTAR arg_value opt_block_arg",
"call_args2 : arg_value ',' args ',' assocs ',' tSTAR arg_value opt_block_arg",
"call_args2 : tSTAR arg_value opt_block_arg",
"call_args2 : block_arg",
"$$8 :",
"command_args : $$8 open_args",
"open_args : call_args",
"$$9 :",
"open_args : tLPAREN_ARG $$9 ')'",
"$$10 :",
"open_args : tLPAREN_ARG call_args2 $$10 ')'",
"block_arg : tAMPER arg_value",
"opt_block_arg : ',' block_arg",
"opt_block_arg : none",
"args : arg_value",
"args : args ',' arg_value",
"mrhs : args ',' arg_value",
"mrhs : args ',' tSTAR arg_value",
"mrhs : tSTAR arg_value",
"primary : literal",
"primary : strings",
"primary : xstring",
"primary : regexp",
"primary : words",
"primary : qwords",
"primary : var_ref",
"primary : backref",
"primary : tFID",
"$$11 :",
"primary : kBEGIN $$11 bodystmt kEND",
"$$12 :",
"primary : tLPAREN_ARG expr $$12 opt_nl ')'",
"primary : tLPAREN compstmt ')'",
"primary : primary_value tCOLON2 tCONSTANT",
"primary : tCOLON3 tCONSTANT",
"primary : primary_value '[' aref_args ']'",
"primary : tLBRACK aref_args ']'",
"primary : tLBRACE assoc_list '}'",
"primary : kRETURN",
"primary : kYIELD '(' call_args ')'",
"primary : kYIELD '(' ')'",
"primary : kYIELD",
"$$13 :",
"primary : kDEFINED opt_nl '(' $$13 expr ')'",
"primary : operation brace_block",
"primary : method_call",
"primary : method_call brace_block",
"primary : kIF expr_value then compstmt if_tail kEND",
"primary : kUNLESS expr_value then compstmt opt_else kEND",
"$$14 :",
"$$15 :",
"primary : kWHILE $$14 expr_value do $$15 compstmt kEND",
"$$16 :",
"$$17 :",
"primary : kUNTIL $$16 expr_value do $$17 compstmt kEND",
"primary : kCASE expr_value opt_terms case_body kEND",
"primary : kCASE opt_terms case_body kEND",
"primary : kCASE opt_terms kELSE compstmt kEND",
"$$18 :",
"$$19 :",
"primary : kFOR block_var kIN $$18 expr_value do $$19 compstmt kEND",
"$$20 :",
"primary : kCLASS cpath superclass $$20 bodystmt kEND",
"$$21 :",
"$$22 :",
"primary : kCLASS tLSHFT expr $$21 term $$22 bodystmt kEND",
"$$23 :",
"primary : kMODULE cpath $$23 bodystmt kEND",
"$$24 :",
"primary : kDEF fname $$24 f_arglist bodystmt kEND",
"$$25 :",
"$$26 :",
"primary : kDEF singleton dot_or_colon $$25 fname $$26 f_arglist bodystmt kEND",
"primary : kBREAK",
"primary : kNEXT",
"primary : kREDO",
"primary : kRETRY",
"primary_value : primary",
"then : term",
"then : ':'",
"then : kTHEN",
"then : term kTHEN",
"do : term",
"do : ':'",
"do : kDO_COND",
"if_tail : opt_else",
"if_tail : kELSIF expr_value then compstmt if_tail",
"opt_else : none",
"opt_else : kELSE compstmt",
"block_var : lhs",
"block_var : mlhs",
"opt_block_var : none",
"opt_block_var : '|' '|'",
"opt_block_var : tOROP",
"opt_block_var : '|' block_var '|'",
"$$27 :",
"$$28 :",
"do_block : kDO_BLOCK $$27 opt_block_var $$28 compstmt kEND",
"block_call : command do_block",
"block_call : block_call '.' operation2 opt_paren_args",
"block_call : block_call tCOLON2 operation2 opt_paren_args",
"method_call : operation paren_args",
"method_call : primary_value '.' operation2 opt_paren_args",
"method_call : primary_value tCOLON2 operation2 paren_args",
"method_call : primary_value tCOLON2 operation3",
"method_call : kSUPER paren_args",
"method_call : kSUPER",
"$$29 :",
"$$30 :",
"brace_block : '{' $$29 opt_block_var $$30 compstmt '}'",
"$$31 :",
"$$32 :",
"brace_block : kDO $$31 opt_block_var $$32 compstmt kEND",
"case_body : kWHEN when_args then compstmt cases",
"when_args : args",
"when_args : args ',' tSTAR arg_value",
"when_args : tSTAR arg_value",
"cases : opt_else",
"cases : case_body",
"opt_rescue : kRESCUE exc_list exc_var then compstmt opt_rescue",
"opt_rescue : none",
"exc_list : arg_value",
"exc_list : mrhs",
"exc_list : none",
"exc_var : tASSOC lhs",
"exc_var : none",
"opt_ensure : kENSURE compstmt",
"opt_ensure : none",
"literal : numeric",
"literal : symbol",
"literal : dsym",
"strings : string",
"string : string1",
"string : string string1",
"string1 : tSTRING_BEG string_contents tSTRING_END",
"xstring : tXSTRING_BEG xstring_contents tSTRING_END",
"regexp : tREGEXP_BEG xstring_contents tREGEXP_END",
"words : tWORDS_BEG ' ' tSTRING_END",
"words : tWORDS_BEG word_list tSTRING_END",
"word_list :",
"word_list : word_list word ' '",
"word : string_content",
"word : word string_content",
"qwords : tQWORDS_BEG ' ' tSTRING_END",
"qwords : tQWORDS_BEG qword_list tSTRING_END",
"qword_list :",
"qword_list : qword_list tSTRING_CONTENT ' '",
"string_contents :",
"string_contents : string_contents string_content",
"xstring_contents :",
"xstring_contents : xstring_contents string_content",
"string_content : tSTRING_CONTENT",
"$$33 :",
"string_content : tSTRING_DVAR $$33 string_dvar",
"$$34 :",
"string_content : tSTRING_DBEG $$34 compstmt '}'",
"string_dvar : tGVAR",
"string_dvar : tIVAR",
"string_dvar : tCVAR",
"string_dvar : backref",
"symbol : tSYMBEG sym",
"sym : fname",
"sym : tIVAR",
"sym : tGVAR",
"sym : tCVAR",
"dsym : tSYMBEG xstring_contents tSTRING_END",
"numeric : tINTEGER",
"numeric : tFLOAT",
"numeric : tUMINUS_NUM tINTEGER",
"numeric : tUMINUS_NUM tFLOAT",
"variable : tIDENTIFIER",
"variable : tIVAR",
"variable : tGVAR",
"variable : tCONSTANT",
"variable : tCVAR",
"variable : kNIL",
"variable : kSELF",
"variable : kTRUE",
"variable : kFALSE",
"variable : k__FILE__",
"variable : k__LINE__",
"var_ref : variable",
"var_lhs : variable",
"backref : tNTH_REF",
"backref : tBACK_REF",
"superclass : term",
"$$35 :",
"superclass : '<' $$35 expr_value term",
"superclass : error term",
"f_arglist : '(' f_args opt_nl ')'",
"f_arglist : f_args term",
"f_args : f_arg ',' f_optarg ',' f_rest_arg opt_f_block_arg",
"f_args : f_arg ',' f_optarg opt_f_block_arg",
"f_args : f_arg ',' f_rest_arg opt_f_block_arg",
"f_args : f_arg opt_f_block_arg",
"f_args : f_optarg ',' f_rest_arg opt_f_block_arg",
"f_args : f_optarg opt_f_block_arg",
"f_args : f_rest_arg opt_f_block_arg",
"f_args : f_block_arg",
"f_args :",
"f_norm_arg : tCONSTANT",
"f_norm_arg : tIVAR",
"f_norm_arg : tGVAR",
"f_norm_arg : tCVAR",
"f_norm_arg : tIDENTIFIER",
"f_arg : f_norm_arg",
"f_arg : f_arg ',' f_norm_arg",
"f_opt : tIDENTIFIER '=' arg_value",
"f_optarg : f_opt",
"f_optarg : f_optarg ',' f_opt",
"restarg_mark : '*'",
"restarg_mark : tSTAR",
"f_rest_arg : restarg_mark tIDENTIFIER",
"f_rest_arg : restarg_mark",
"blkarg_mark : '&'",
"blkarg_mark : tAMPER",
"f_block_arg : blkarg_mark tIDENTIFIER",
"opt_f_block_arg : ',' f_block_arg",
"opt_f_block_arg : none",
"singleton : var_ref",
"$$36 :",
"singleton : '(' $$36 expr opt_nl ')'",
"assoc_list : none",
"assoc_list : assocs trailer",
"assoc_list : args trailer",
"assocs : assoc",
"assocs : assocs ',' assoc",
"assoc : arg_value tASSOC arg_value",
"operation : tIDENTIFIER",
"operation : tCONSTANT",
"operation : tFID",
"operation2 : tIDENTIFIER",
"operation2 : tCONSTANT",
"operation2 : tFID",
"operation2 : op",
"operation3 : tIDENTIFIER",
"operation3 : tFID",
"operation3 : op",
"dot_or_colon : '.'",
"dot_or_colon : tCOLON2",
"opt_terms :",
"opt_terms : terms",
"opt_nl :",
"opt_nl : '\\n'",
"trailer :",
"trailer : '\\n'",
"trailer : ','",
"term : ';'",
"term : '\\n'",
"terms : term",
"terms : terms ';'",
"none :",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 2484 "parse.y"
#ifdef yystacksize
#undef YYMALLOC
#endif

#include "regex.h"
#include "util.h"

/* We remove any previous definition of `SIGN_EXTEND_CHAR',
   since ours (we hope) works properly with all combinations of
   machines, compilers, `char' and `unsigned char' argument types.
   (Per Bothner suggested the basic approach.)  */
#undef SIGN_EXTEND_CHAR
#if __STDC__
# define SIGN_EXTEND_CHAR(c) ((signed char)(c))
#else  /* not __STDC__ */
/* As in Harbison and Steele.  */
# define SIGN_EXTEND_CHAR(c) ((((unsigned char)(c)) ^ 128) - 128)
#endif
#define is_identchar(c) (SIGN_EXTEND_CHAR(c)!=-1&&(ISALNUM(c) || (c) == '_' || ismbchar(c)))

static char *tokenbuf = NULL;
static int   tokidx, toksiz = 0;

#define LEAVE_BS 1

static VALUE (*lex_gets)();	/* gets function */
static VALUE lex_input;		/* non-nil if File */
static VALUE lex_lastline;	/* gc protect */
static char *lex_pbeg;
static char *lex_p;
static char *lex_pend;

static int
yyerror(msg)
    const char *msg;
{
    char *p, *pe, *buf;
    int len, i;

    rb_compile_error("%s", msg);
    p = lex_p;
    while (lex_pbeg <= p) {
	if (*p == '\n') break;
	p--;
    }
    p++;

    pe = lex_p;
    while (pe < lex_pend) {
	if (*pe == '\n') break;
	pe++;
    }

    len = pe - p;
    if (len > 4) {
	buf = ALLOCA_N(char, len+2);
	MEMCPY(buf, p, char, len);
	buf[len] = '\0';
	rb_compile_error_append("%s", buf);

	i = lex_p - p;
	p = buf; pe = p + len;

	while (p < pe) {
	    if (*p != '\t') *p = ' ';
	    p++;
	}
	buf[i] = '^';
	buf[i+1] = '\0';
	rb_compile_error_append("%s", buf);
    }

    return 0;
}

static int heredoc_end;

int ruby_in_compile = 0;
int ruby__end__seen;

static VALUE ruby_debug_lines;
#ifdef YYMALLOC
static NODE *parser_heap;
#endif

static NODE*
yycompile(f, line)
    char *f;
    int line;
{
    int n;
    NODE *node = 0;
    struct RVarmap *vp, *vars = ruby_dyna_vars;

    ruby_in_compile = 1;
    if (!compile_for_eval && rb_safe_level() == 0 &&
	rb_const_defined(rb_cObject, rb_intern("SCRIPT_LINES__"))) {
	VALUE hash, fname;

	hash = rb_const_get(rb_cObject, rb_intern("SCRIPT_LINES__"));
	if (TYPE(hash) == T_HASH) {
	    fname = rb_str_new2(f);
	    ruby_debug_lines = rb_hash_aref(hash, fname);
	    if (NIL_P(ruby_debug_lines)) {
		ruby_debug_lines = rb_ary_new();
		rb_hash_aset(hash, fname, ruby_debug_lines);
	    }
	}
	if (line > 1) {
	    VALUE str = rb_str_new(0,0);
	    while (line > 1) {
		rb_ary_push(ruby_debug_lines, str);
		line--;
	    }
	}
    }

    ruby__end__seen = 0;
    ruby_eval_tree = 0;
    heredoc_end = 0;
    lex_strterm = 0;
    ruby_current_node = 0;
    ruby_sourcefile = rb_source_filename(f);
    n = yyparse();
    ruby_debug_lines = 0;
    compile_for_eval = 0;
    ruby_in_compile = 0;
    cond_stack = 0;
    cmdarg_stack = 0;
    command_start = 1;
    class_nest = 0;
    in_single = 0;
    in_def = 0;
    cur_mid = 0;

    vp = ruby_dyna_vars;
    ruby_dyna_vars = vars;
    lex_strterm = 0;
    while (vp && vp != vars) {
	struct RVarmap *tmp = vp;
	vp = vp->next;
	rb_gc_force_recycle((VALUE)tmp);
    }
    if (n == 0) node = ruby_eval_tree;
    else ruby_eval_tree_begin = 0;
    return node;
}

static int lex_gets_ptr;

static VALUE
lex_get_str(s)
    VALUE s;
{
    char *beg, *end, *pend;

    beg = RSTRING(s)->ptr;
    if (lex_gets_ptr) {
	if (RSTRING(s)->len == lex_gets_ptr) return Qnil;
	beg += lex_gets_ptr;
    }
    pend = RSTRING(s)->ptr + RSTRING(s)->len;
    end = beg;
    while (end < pend) {
	if (*end++ == '\n') break;
    }
    lex_gets_ptr = end - RSTRING(s)->ptr;
    return rb_str_new(beg, end - beg);
}

static VALUE
lex_getline()
{
    VALUE line = (*lex_gets)(lex_input);
    if (ruby_debug_lines && !NIL_P(line)) {
	rb_ary_push(ruby_debug_lines, line);
    }
    return line;
}

NODE*
rb_compile_string(f, s, line)
    const char *f;
    VALUE s;
    int line;
{
    lex_gets = lex_get_str;
    lex_gets_ptr = 0;
    lex_input = s;
    lex_pbeg = lex_p = lex_pend = 0;
    ruby_sourceline = line - 1;
    compile_for_eval = ruby_in_eval;

    return yycompile(f, line);
}

NODE*
rb_compile_cstr(f, s, len, line)
    const char *f, *s;
    int len, line;
{
    return rb_compile_string(f, rb_str_new(s, len), line);
}

NODE*
rb_compile_file(f, file, start)
    const char *f;
    VALUE file;
    int start;
{
    lex_gets = rb_io_gets;
    lex_input = file;
    lex_pbeg = lex_p = lex_pend = 0;
    ruby_sourceline = start - 1;

    return yycompile(f, start);
}

static inline int
nextc()
{
    int c;

    if (lex_p == lex_pend) {
	if (lex_input) {
	    VALUE v = lex_getline();

	    if (NIL_P(v)) return -1;
	    if (heredoc_end > 0) {
		ruby_sourceline = heredoc_end;
		heredoc_end = 0;
	    }
	    ruby_sourceline++;
	    lex_pbeg = lex_p = RSTRING(v)->ptr;
	    lex_pend = lex_p + RSTRING(v)->len;
	    lex_lastline = v;
	}
	else {
	    lex_lastline = 0;
	    return -1;
	}
    }
    c = (unsigned char)*lex_p++;
    if (c == '\r' && lex_p < lex_pend && *lex_p == '\n') {
	lex_p++;
	c = '\n';
    }

    return c;
}

static void
pushback(c)
    int c;
{
    if (c == -1) return;
    lex_p--;
}

#define was_bol() (lex_p == lex_pbeg + 1)
#define peek(c) (lex_p != lex_pend && (c) == *lex_p)

#define tokfix() (tokenbuf[tokidx]='\0')
#define tok() tokenbuf
#define toklen() tokidx
#define toklast() (tokidx>0?tokenbuf[tokidx-1]:0)

static char*
newtok()
{
    tokidx = 0;
    if (!tokenbuf) {
	toksiz = 60;
	tokenbuf = ALLOC_N(char, 60);
    }
    if (toksiz > 4096) {
	toksiz = 60;
	REALLOC_N(tokenbuf, char, 60);
    }
    return tokenbuf;
}

static void
tokadd(c)
    char c;
{
    tokenbuf[tokidx++] = c;
    if (tokidx >= toksiz) {
	toksiz *= 2;
	REALLOC_N(tokenbuf, char, toksiz);
    }
}

static int
read_escape()
{
    int c;

    switch (c = nextc()) {
      case '\\':	/* Backslash */
	return c;

      case 'n':	/* newline */
	return '\n';

      case 't':	/* horizontal tab */
	return '\t';

      case 'r':	/* carriage-return */
	return '\r';

      case 'f':	/* form-feed */
	return '\f';

      case 'v':	/* vertical tab */
	return '\13';

      case 'a':	/* alarm(bell) */
	return '\007';

      case 'e':	/* escape */
	return 033;

      case '0': case '1': case '2': case '3': /* octal constant */
      case '4': case '5': case '6': case '7':
	{
	    int numlen;

	    pushback(c);
	    c = scan_oct(lex_p, 3, &numlen);
	    lex_p += numlen;
	}
	return c;

      case 'x':	/* hex constant */
	{
	    int numlen;

	    c = scan_hex(lex_p, 2, &numlen);
	    if (numlen == 0) {
		yyerror("Invalid escape character syntax");
		return 0;
	    }
	    lex_p += numlen;
	}
	return c;

      case 'b':	/* backspace */
	return '\010';

      case 's':	/* space */
	return ' ';

      case 'M':
	if ((c = nextc()) != '-') {
	    yyerror("Invalid escape character syntax");
	    pushback(c);
	    return '\0';
	}
	if ((c = nextc()) == '\\') {
	    return read_escape() | 0x80;
	}
	else if (c == -1) goto eof;
	else {
	    return ((c & 0xff) | 0x80);
	}

      case 'C':
	if ((c = nextc()) != '-') {
	    yyerror("Invalid escape character syntax");
	    pushback(c);
	    return '\0';
	}
      case 'c':
	if ((c = nextc())== '\\') {
	    c = read_escape();
	}
	else if (c == '?')
	    return 0177;
	else if (c == -1) goto eof;
	return c & 0x9f;

      eof:
      case -1:
        yyerror("Invalid escape character syntax");
	return '\0';

      default:
	return c;
    }
}

static int
tokadd_escape(term)
    int term;
{
    int c;

    switch (c = nextc()) {
      case '\n':
	return 0;		/* just ignore */

      case '0': case '1': case '2': case '3': /* octal constant */
      case '4': case '5': case '6': case '7':
	{
	    int i;

	    tokadd('\\');
	    tokadd(c);
	    for (i=0; i<2; i++) {
		c = nextc();
		if (c == -1) goto eof;
		if (c < '0' || '7' < c) {
		    pushback(c);
		    break;
		}
		tokadd(c);
	    }
	}
	return 0;

      case 'x':	/* hex constant */
	{
	    int numlen;

	    tokadd('\\');
	    tokadd(c);
	    scan_hex(lex_p, 2, &numlen);
	    if (numlen == 0) {
		yyerror("Invalid escape character syntax");
		return -1;
	    }
	    while (numlen--)
		tokadd(nextc());
	}
	return 0;

      case 'M':
	if ((c = nextc()) != '-') {
	    yyerror("Invalid escape character syntax");
	    pushback(c);
	    return 0;
	}
	tokadd('\\'); tokadd('M'); tokadd('-');
	goto escaped;

      case 'C':
	if ((c = nextc()) != '-') {
	    yyerror("Invalid escape character syntax");
	    pushback(c);
	    return 0;
	}
	tokadd('\\'); tokadd('C'); tokadd('-');
	goto escaped;

      case 'c':
	tokadd('\\'); tokadd('c');
      escaped:
	if ((c = nextc()) == '\\') {
	    return tokadd_escape(term);
	}
	else if (c == -1) goto eof;
	tokadd(c);
	return 0;

      eof:
      case -1:
        yyerror("Invalid escape character syntax");
	return -1;

      default:
	if (c != '\\' || c != term)
	    tokadd('\\');
	tokadd(c);
    }
    return 0;
}

static int
regx_options()
{
    char kcode = 0;
    int options = 0;
    int c;

    newtok();
    while (c = nextc(), ISALPHA(c)) {
	switch (c) {
	  case 'i':
	    options |= RE_OPTION_IGNORECASE;
	    break;
	  case 'x':
	    options |= RE_OPTION_EXTENDED;
	    break;
	  case 'm':
	    options |= RE_OPTION_MULTILINE;
	    break;
	  case 'o':
	    options |= RE_OPTION_ONCE;
	    break;
	  case 'n':
	    kcode = 16;
	    break;
	  case 'e':
	    kcode = 32;
	    break;
	  case 's':
	    kcode = 48;
	    break;
	  case 'u':
	    kcode = 64;
	    break;
	  default:
	    tokadd(c);
	    break;
	}
    }
    pushback(c);
    if (toklen()) {
	tokfix();
	rb_compile_error("unknown regexp option%s - %s",
			 toklen() > 1 ? "s" : "", tok());
    }
    return options | kcode;
}

#define STR_FUNC_ESCAPE 0x01
#define STR_FUNC_EXPAND 0x02
#define STR_FUNC_REGEXP 0x04
#define STR_FUNC_QWORDS 0x08
#define STR_FUNC_SYMBOL 0x10
#define STR_FUNC_INDENT 0x20

enum string_type {
    str_squote = (0),
    str_dquote = (STR_FUNC_EXPAND),
    str_xquote = (STR_FUNC_EXPAND),
    str_regexp = (STR_FUNC_REGEXP|STR_FUNC_ESCAPE|STR_FUNC_EXPAND),
    str_sword  = (STR_FUNC_QWORDS),
    str_dword  = (STR_FUNC_QWORDS|STR_FUNC_EXPAND),
    str_ssym   = (STR_FUNC_SYMBOL),
    str_dsym   = (STR_FUNC_SYMBOL|STR_FUNC_EXPAND),
};

static void
dispose_string(str)
    VALUE str;
{
    xfree(RSTRING(str)->ptr);
    rb_gc_force_recycle(str);
}

static int
tokadd_string(func, term, paren, nest)
    int func, term, paren, *nest;
{
    int c;

    while ((c = nextc()) != -1) {
	if (paren && c == paren) {
	    ++*nest;
	}
	else if (c == term) {
	    if (!nest || !*nest) {
		pushback(c);
		break;
	    }
	    --*nest;
	}
	else if ((func & STR_FUNC_EXPAND) && c == '#' && lex_p < lex_pend) {
	    int c2 = *lex_p;
	    if (c2 == '$' || c2 == '@' || c2 == '{') {
		pushback(c);
		break;
	    }
	}
	else if (c == '\\') {
	    c = nextc();
	    switch (c) {
	      case '\n':
		if (func & STR_FUNC_QWORDS) break;
		if (func & STR_FUNC_EXPAND) continue;
		tokadd('\\');
		break;

	      case '\\':
		if (func & STR_FUNC_ESCAPE) tokadd(c);
		break;

	      default:
		if (func & STR_FUNC_REGEXP) {
		    pushback(c);
		    if (tokadd_escape(term) < 0)
			return -1;
		    continue;
		}
		else if (func & STR_FUNC_EXPAND) {
		    pushback(c);
		    if (func & STR_FUNC_ESCAPE) tokadd('\\');
		    c = read_escape();
		}
		else if ((func & STR_FUNC_QWORDS) && ISSPACE(c)) {
		    /* ignore backslashed spaces in %w */
		}
		else if (c != term && !(paren && c == paren)) {
		    tokadd('\\');
		}
	    }
	}
	else if (ismbchar(c)) {
	    int i, len = mbclen(c)-1;

	    for (i = 0; i < len; i++) {
		tokadd(c);
		c = nextc();
	    }
	}
	else if ((func & STR_FUNC_QWORDS) && ISSPACE(c)) {
	    pushback(c);
	    break;
	}
	if (!c && (func & STR_FUNC_SYMBOL)) {
	    func &= ~STR_FUNC_SYMBOL;
	    rb_compile_error("symbol cannot contain '\\0'");
	    continue;
	}
	tokadd(c);
    }
    return c;
}

#define NEW_STRTERM(func, term, paren) \
	rb_node_newnode(NODE_STRTERM, (func), (term) | ((paren) << (CHAR_BIT * 2)), 0)

static int
parse_string(quote)
    NODE *quote;
{
    int func = quote->nd_func;
    int term = nd_term(quote);
    int paren = nd_paren(quote);
    int c, space = 0;

    if (func == -1) return tSTRING_END;
    c = nextc();
    if ((func & STR_FUNC_QWORDS) && ISSPACE(c)) {
	do {c = nextc();} while (ISSPACE(c));
	space = 1;
    }
    if (c == term && !quote->nd_nest) {
	if (func & STR_FUNC_QWORDS) {
	    quote->nd_func = -1;
	    return ' ';
	}
	if (!(func & STR_FUNC_REGEXP)) return tSTRING_END;
	yylval.num = regx_options();
	return tREGEXP_END;
    }
    if (space) {
	pushback(c);
	return ' ';
    }
    newtok();
    if ((func & STR_FUNC_EXPAND) && c == '#') {
	switch (c = nextc()) {
	  case '$':
	  case '@':
	    pushback(c);
	    return tSTRING_DVAR;
	  case '{':
	    return tSTRING_DBEG;
	}
	tokadd('#');
    }
    pushback(c);
    if (tokadd_string(func, term, paren, &quote->nd_nest) == -1) {
	ruby_sourceline = nd_line(quote);
	rb_compile_error("unterminated string meets end of file");
	return tSTRING_END;
    }

    tokfix();
    yylval.node = NEW_STR(rb_str_new(tok(), toklen()));
    return tSTRING_CONTENT;
}

static int
heredoc_identifier()
{
    int c = nextc(), term, func = 0, len;

    if (c == '-') {
	c = nextc();
	func = STR_FUNC_INDENT;
    }
    switch (c) {
      case '\'':
	func |= str_squote; goto quoted;
      case '"':
	func |= str_dquote; goto quoted;
      case '`':
	func |= str_xquote;
      quoted:
	newtok();
	tokadd(func);
	term = c;
	while ((c = nextc()) != -1 && c != term) {
	    len = mbclen(c);
	    do {tokadd(c);} while (--len > 0 && (c = nextc()) != -1);
	}
	if (c == -1) {
	    rb_compile_error("unterminated here document identifier");
	    return 0;
	}
	break;

      default:
	if (!is_identchar(c)) {
	    pushback(c);
	    if (func & STR_FUNC_INDENT) {
		pushback('-');
	    }
	    return 0;
	}
	newtok();
	term = '"';
	tokadd(func |= str_dquote);
	do {
	    len = mbclen(c);
	    do {tokadd(c);} while (--len > 0 && (c = nextc()) != -1);
	} while ((c = nextc()) != -1 && is_identchar(c));
	pushback(c);
	break;
    }

    tokfix();
    len = lex_p - lex_pbeg;
    lex_p = lex_pend;
    lex_strterm = rb_node_newnode(NODE_HEREDOC,
				  rb_str_new(tok(), toklen()),	/* nd_lit */
				  len,				/* nd_nth */
				  lex_lastline);		/* nd_orig */
    return term == '`' ? tXSTRING_BEG : tSTRING_BEG;
}

static void
heredoc_restore(here)
    NODE *here;
{
    VALUE line = here->nd_orig;
    lex_lastline = line;
    lex_pbeg = RSTRING(line)->ptr;
    lex_pend = lex_pbeg + RSTRING(line)->len;
    lex_p = lex_pbeg + here->nd_nth;
    heredoc_end = ruby_sourceline;
    ruby_sourceline = nd_line(here);
    dispose_string(here->nd_lit);
    rb_gc_force_recycle((VALUE)here);
}

static int
whole_match_p(eos, len, indent)
    char *eos;
    int len, indent;
{
    char *p = lex_pbeg;
    int n;

    if (indent) {
	while (*p && ISSPACE(*p)) p++;
    }
    n= lex_pend - (p + len);
    if (n < 0 || (n > 0 && p[len] != '\n' && p[len] != '\r')) return Qfalse;
    if (strncmp(eos, p, len) == 0) return Qtrue;
    return Qfalse;
}

static int
here_document(here)
    NODE *here;
{
    int c, func, indent = 0;
    char *eos, *p, *pend;
    long len;
    VALUE str = 0;

    eos = RSTRING(here->nd_lit)->ptr;
    len = RSTRING(here->nd_lit)->len - 1;
    indent = (func = *eos++) & STR_FUNC_INDENT;

    if ((c = nextc()) == -1) {
      error:
	rb_compile_error("can't find string \"%s\" anywhere before EOF", eos);
	heredoc_restore(lex_strterm);
	lex_strterm = 0;
	return 0;
    }
    if (was_bol() && whole_match_p(eos, len, indent)) {
	heredoc_restore(lex_strterm);
	return tSTRING_END;
    }

    if (!(func & STR_FUNC_EXPAND)) {
	do {
	    p = RSTRING(lex_lastline)->ptr;
	    pend = lex_pend;
	    if (pend > p) {
		switch (pend[-1]) {
		  case '\n':
		    if (--pend == p || pend[-1] != '\r') {
			pend++;
			break;
		    }
		  case '\r':
		    --pend;
		}
	    }
	    if (str)
		rb_str_cat(str, p, pend - p);
	    else
		str = rb_str_new(p, pend - p);
	    if (pend < lex_pend) rb_str_cat(str, "\n", 1);
	    lex_p = lex_pend;
	    if (nextc() == -1) {
		if (str) dispose_string(str);
		goto error;
	    }
	} while (!whole_match_p(eos, len, indent));
    }
    else {
	newtok();
	if (c == '#') {
	    switch (c = nextc()) {
	      case '$':
	      case '@':
		pushback(c);
		return tSTRING_DVAR;
	      case '{':
		return tSTRING_DBEG;
	    }
	    tokadd('#');
	}
	do {
	    pushback(c);
	    if ((c = tokadd_string(func, '\n', 0, NULL)) == -1) goto error;
	    if (c != '\n') {
		yylval.node = NEW_STR(rb_str_new(tok(), toklen()));
		return tSTRING_CONTENT;
	    }
	    tokadd(nextc());
	    if ((c = nextc()) == -1) goto error;
	} while (!whole_match_p(eos, len, indent));
	str = rb_str_new(tok(), toklen());
    }
    heredoc_restore(lex_strterm);
    lex_strterm = NEW_STRTERM(-1, 0, 0);
    yylval.node = NEW_STR(str);
    return tSTRING_CONTENT;
}

#include "lex.c"

static void
arg_ambiguous()
{
    rb_warning("ambiguous first argument; put parentheses or even spaces");
}

#define IS_ARG() (lex_state == EXPR_ARG || lex_state == EXPR_CMDARG)

static int
yylex()
{
    register int c;
    int space_seen = 0;
    int cmd_state;
    enum lex_state last_state;

    if (lex_strterm) {
	int token;
	if (nd_type(lex_strterm) == NODE_HEREDOC) {
	    token = here_document(lex_strterm);
	    if (token == tSTRING_END) {
		lex_strterm = 0;
		lex_state = EXPR_END;
	    }
	}
	else {
	    token = parse_string(lex_strterm);
	    if (token == tSTRING_END || token == tREGEXP_END) {
		rb_gc_force_recycle((VALUE)lex_strterm);
		lex_strterm = 0;
		lex_state = EXPR_END;
	    }
	}
	return token;
    }
    cmd_state = command_start;
    command_start = Qfalse;
  retry:
    switch (c = nextc()) {
      case '\0':		/* NUL */
      case '\004':		/* ^D */
      case '\032':		/* ^Z */
      case -1:			/* end of script. */
	return 0;

	/* white spaces */
      case ' ': case '\t': case '\f': case '\r':
      case '\13': /* '\v' */
	space_seen++;
	goto retry;

      case '#':		/* it's a comment */
	while ((c = nextc()) != '\n') {
	    if (c == -1)
		return 0;
	}
	/* fall through */
      case '\n':
	switch (lex_state) {
	  case EXPR_BEG:
	  case EXPR_FNAME:
	  case EXPR_DOT:
	  case EXPR_CLASS:
	    goto retry;
	  default:
	    break;
	}
	command_start = Qtrue;
	lex_state = EXPR_BEG;
	return '\n';

      case '*':
	if ((c = nextc()) == '*') {
	    if ((c = nextc()) == '=') {
		yylval.id = tPOW;
		lex_state = EXPR_BEG;
		return tOP_ASGN;
	    }
	    pushback(c);
	    c = tPOW;
	}
	else {
	    if (c == '=') {
		yylval.id = '*';
		lex_state = EXPR_BEG;
		return tOP_ASGN;
	    }
	    pushback(c);
	    if (IS_ARG() && space_seen && !ISSPACE(c)){
		rb_warning("`*' interpreted as argument prefix");
		c = tSTAR;
	    }
	    else if (lex_state == EXPR_BEG || lex_state == EXPR_MID) {
		c = tSTAR;
	    }
	    else {
		c = '*';
	    }
	}
	switch (lex_state) {
	  case EXPR_FNAME: case EXPR_DOT:
	    lex_state = EXPR_ARG; break;
	  default:
	    lex_state = EXPR_BEG; break;
	}
	return c;

      case '!':
	lex_state = EXPR_BEG;
	if ((c = nextc()) == '=') {
	    return tNEQ;
	}
	if (c == '~') {
	    return tNMATCH;
	}
	pushback(c);
	return '!';

      case '=':
	if (was_bol()) {
	    /* skip embedded rd document */
	    if (strncmp(lex_p, "begin", 5) == 0 && ISSPACE(lex_p[5])) {
		for (;;) {
		    lex_p = lex_pend;
		    c = nextc();
		    if (c == -1) {
			rb_compile_error("embedded document meets end of file");
			return 0;
		    }
		    if (c != '=') continue;
		    if (strncmp(lex_p, "end", 3) == 0 &&
			(lex_p + 3 == lex_pend || ISSPACE(lex_p[3]))) {
			break;
		    }
		}
		lex_p = lex_pend;
		goto retry;
	    }
	}

	switch (lex_state) {
	  case EXPR_FNAME: case EXPR_DOT:
	    lex_state = EXPR_ARG; break;
	  default:
	    lex_state = EXPR_BEG; break;
	}
	if ((c = nextc()) == '=') {
	    if ((c = nextc()) == '=') {
		return tEQQ;
	    }
	    pushback(c);
	    return tEQ;
	}
	if (c == '~') {
	    return tMATCH;
	}
	else if (c == '>') {
	    return tASSOC;
	}
	pushback(c);
	return '=';

      case '<':
	c = nextc();
	if (c == '<' &&
	    lex_state != EXPR_END &&
	    lex_state != EXPR_DOT &&
	    lex_state != EXPR_ENDARG &&
	    lex_state != EXPR_CLASS &&
	    (!IS_ARG() || space_seen)) {
	    int token = heredoc_identifier();
	    if (token) return token;
	}
	switch (lex_state) {
	  case EXPR_FNAME: case EXPR_DOT:
	    lex_state = EXPR_ARG; break;
	  default:
	    lex_state = EXPR_BEG; break;
	}
	if (c == '=') {
	    if ((c = nextc()) == '>') {
		return tCMP;
	    }
	    pushback(c);
	    return tLEQ;
	}
	if (c == '<') {
	    if ((c = nextc()) == '=') {
		yylval.id = tLSHFT;
		lex_state = EXPR_BEG;
		return tOP_ASGN;
	    }
	    pushback(c);
	    return tLSHFT;
	}
	pushback(c);
	return '<';

      case '>':
	switch (lex_state) {
	  case EXPR_FNAME: case EXPR_DOT:
	    lex_state = EXPR_ARG; break;
	  default:
	    lex_state = EXPR_BEG; break;
	}
	if ((c = nextc()) == '=') {
	    return tGEQ;
	}
	if (c == '>') {
	    if ((c = nextc()) == '=') {
		yylval.id = tRSHFT;
		lex_state = EXPR_BEG;
		return tOP_ASGN;
	    }
	    pushback(c);
	    return tRSHFT;
	}
	pushback(c);
	return '>';

      case '"':
	lex_strterm = NEW_STRTERM(str_dquote, '"', 0);
	return tSTRING_BEG;

      case '`':
	if (lex_state == EXPR_FNAME) {
	    lex_state = EXPR_END;
	    return c;
	}
	if (lex_state == EXPR_DOT) {
	    if (cmd_state)
		lex_state = EXPR_CMDARG;
	    else
		lex_state = EXPR_ARG;
	    return c;
	}
	lex_strterm = NEW_STRTERM(str_xquote, '`', 0);
	return tXSTRING_BEG;

      case '\'':
	lex_strterm = NEW_STRTERM(str_squote, '\'', 0);
	return tSTRING_BEG;

      case '?':
	if (lex_state == EXPR_END || lex_state == EXPR_ENDARG) {
	    lex_state = EXPR_BEG;
	    return '?';
	}
	c = nextc();
	if (c == -1) {
	    rb_compile_error("incomplete character syntax");
	    return 0;
	}
	if (ISSPACE(c)){
	    if (!IS_ARG()){
		int c2 = 0;
		switch (c) {
		  case ' ':
		    c2 = 's';
		    break;
		  case '\n':
		    c2 = 'n';
		    break;
		  case '\t':
		    c2 = 't';
		    break;
		  case '\v':
		    c2 = 'v';
		    break;
		  case '\r':
		    c2 = 'r';
		    break;
		  case '\f':
		    c2 = 'f';
		    break;
		}
		if (c2) {
		    rb_warn("invalid character syntax; use ?\\%c", c2);
		}
	    }
	  ternary:
	    pushback(c);
	    lex_state = EXPR_BEG;
	    return '?';
	}
	else if (ismbchar(c)) {
	    rb_warn("multibyte character literal not supported yet; use ?\\%.3o", c);
	    goto ternary;
	}
	else if ((ISALNUM(c) || c == '_') && lex_p < lex_pend && is_identchar(*lex_p)) {
	    goto ternary;
	}
	else if (c == '\\') {
	    c = read_escape();
	}
	c &= 0xff;
	lex_state = EXPR_END;
	yylval.node = NEW_LIT(INT2FIX(c));
	return tINTEGER;

      case '&':
	if ((c = nextc()) == '&') {
	    lex_state = EXPR_BEG;
	    if ((c = nextc()) == '=') {
		yylval.id = tANDOP;
		lex_state = EXPR_BEG;
		return tOP_ASGN;
	    }
	    pushback(c);
	    return tANDOP;
	}
	else if (c == '=') {
	    yylval.id = '&';
	    lex_state = EXPR_BEG;
	    return tOP_ASGN;
	}
	pushback(c);
	if (IS_ARG() && space_seen && !ISSPACE(c)){
	    rb_warning("`&' interpreted as argument prefix");
	    c = tAMPER;
	}
	else if (lex_state == EXPR_BEG || lex_state == EXPR_MID) {
	    c = tAMPER;
	}
	else {
	    c = '&';
	}
	switch (lex_state) {
	  case EXPR_FNAME: case EXPR_DOT:
	    lex_state = EXPR_ARG; break;
	  default:
	    lex_state = EXPR_BEG;
	}
	return c;

      case '|':
	if ((c = nextc()) == '|') {
	    lex_state = EXPR_BEG;
	    if ((c = nextc()) == '=') {
		yylval.id = tOROP;
		lex_state = EXPR_BEG;
		return tOP_ASGN;
	    }
	    pushback(c);
	    return tOROP;
	}
	if (c == '=') {
	    yylval.id = '|';
	    lex_state = EXPR_BEG;
	    return tOP_ASGN;
	}
	if (lex_state == EXPR_FNAME || lex_state == EXPR_DOT) {
	    lex_state = EXPR_ARG;
	}
	else {
	    lex_state = EXPR_BEG;
	}
	pushback(c);
	return '|';

      case '+':
	c = nextc();
	if (lex_state == EXPR_FNAME || lex_state == EXPR_DOT) {
	    lex_state = EXPR_ARG;
	    if (c == '@') {
		return tUPLUS;
	    }
	    pushback(c);
	    return '+';
	}
	if (c == '=') {
	    yylval.id = '+';
	    lex_state = EXPR_BEG;
	    return tOP_ASGN;
	}
	if (lex_state == EXPR_BEG || lex_state == EXPR_MID ||
	    (IS_ARG() && space_seen && !ISSPACE(c))) {
	    if (IS_ARG()) arg_ambiguous();
	    lex_state = EXPR_BEG;
	    pushback(c);
	    if (ISDIGIT(c)) {
		c = '+';
		goto start_num;
	    }
	    return tUPLUS;
	}
	lex_state = EXPR_BEG;
	pushback(c);
	return '+';

      case '-':
	c = nextc();
	if (lex_state == EXPR_FNAME || lex_state == EXPR_DOT) {
	    lex_state = EXPR_ARG;
	    if (c == '@') {
		return tUMINUS;
	    }
	    pushback(c);
	    return '-';
	}
	if (c == '=') {
	    yylval.id = '-';
	    lex_state = EXPR_BEG;
	    return tOP_ASGN;
	}
	if (lex_state == EXPR_BEG || lex_state == EXPR_MID ||
	    (IS_ARG() && space_seen && !ISSPACE(c))) {
	    if (IS_ARG()) arg_ambiguous();
	    lex_state = EXPR_BEG;
	    pushback(c);
	    if (ISDIGIT(c)) {
		return tUMINUS_NUM;
	    }
	    return tUMINUS;
	}
	lex_state = EXPR_BEG;
	pushback(c);
	return '-';

      case '.':
	lex_state = EXPR_BEG;
	if ((c = nextc()) == '.') {
	    if ((c = nextc()) == '.') {
		return tDOT3;
	    }
	    pushback(c);
	    return tDOT2;
	}
	pushback(c);
	if (ISDIGIT(c)) {
	    yyerror("no .<digit> floating literal anymore; put 0 before dot");
	}
	lex_state = EXPR_DOT;
	return '.';

      start_num:
      case '0': case '1': case '2': case '3': case '4':
      case '5': case '6': case '7': case '8': case '9':
	{
	    int is_float, seen_point, seen_e, nondigit;

	    is_float = seen_point = seen_e = nondigit = 0;
	    lex_state = EXPR_END;
	    newtok();
	    if (c == '-' || c == '+') {
		tokadd(c);
		c = nextc();
	    }
	    if (c == '0') {
		int start = toklen();
		c = nextc();
		if (c == 'x' || c == 'X') {
		    /* hexadecimal */
		    c = nextc();
		    if (ISXDIGIT(c)) {
			do {
			    if (c == '_') {
				if (nondigit) break;
				nondigit = c;
				continue;
			    }
			    if (!ISXDIGIT(c)) break;
			    nondigit = 0;
			    tokadd(c);
			} while ((c = nextc()) != -1);
		    }
		    pushback(c);
		    tokfix();
		    if (toklen() == start) {
			yyerror("numeric literal without digits");
		    }
		    else if (nondigit) goto trailing_uc;
		    yylval.node = NEW_LIT(rb_cstr_to_inum(tok(), 16, Qfalse));
		    return tINTEGER;
		}
		if (c == 'b' || c == 'B') {
		    /* binary */
		    c = nextc();
		    if (c == '0' || c == '1') {
			do {
			    if (c == '_') {
				if (nondigit) break;
				nondigit = c;
				continue;
			    }
			    if (c != '0' && c != '1') break;
			    nondigit = 0;
			    tokadd(c);
			} while ((c = nextc()) != -1);
		    }
		    pushback(c);
		    tokfix();
		    if (toklen() == start) {
			yyerror("numeric literal without digits");
		    }
		    else if (nondigit) goto trailing_uc;
		    yylval.node = NEW_LIT(rb_cstr_to_inum(tok(), 2, Qfalse));
		    return tINTEGER;
		}
		if (c == 'd' || c == 'D') {
		    /* decimal */
		    c = nextc();
		    if (ISDIGIT(c)) {
			do {
			    if (c == '_') {
				if (nondigit) break;
				nondigit = c;
				continue;
			    }
			    if (!ISDIGIT(c)) break;
			    nondigit = 0;
			    tokadd(c);
			} while ((c = nextc()) != -1);
		    }
		    pushback(c);
		    tokfix();
		    if (toklen() == start) {
			yyerror("numeric literal without digits");
		    }
		    else if (nondigit) goto trailing_uc;
		    yylval.node = NEW_LIT(rb_cstr_to_inum(tok(), 10, Qfalse));
		    return tINTEGER;
		}
		if (c == '_') {
		    /* 0_0 */
		    goto octal_number;
		}
		if (c == 'o' || c == 'O') {
		    /* prefixed octal */
		    c = nextc();
		    if (c == '_') {
			yyerror("numeric literal without digits");
		    }
		}
		if (c >= '0' && c <= '7') {
		    /* octal */
		  octal_number:
	            do {
			if (c == '_') {
			    if (nondigit) break;
			    nondigit = c;
			    continue;
			}
			if (c < '0' || c > '7') break;
			nondigit = 0;
			tokadd(c);
		    } while ((c = nextc()) != -1);
		    if (toklen() > start) {
			pushback(c);
			tokfix();
			if (nondigit) goto trailing_uc;
			yylval.node = NEW_LIT(rb_cstr_to_inum(tok(), 8, Qfalse));
			return tINTEGER;
		    }
		    if (nondigit) {
			pushback(c);
			goto trailing_uc;
		    }
		}
		if (c > '7' && c <= '9') {
		    yyerror("Illegal octal digit");
		}
		else if (c == '.' || c == 'e' || c == 'E') {
		    tokadd('0');
		}
		else {
		    pushback(c);
		    yylval.node = NEW_LIT(INT2FIX(0));
		    return tINTEGER;
		}
	    }

	    for (;;) {
		switch (c) {
		  case '0': case '1': case '2': case '3': case '4':
		  case '5': case '6': case '7': case '8': case '9':
		    nondigit = 0;
		    tokadd(c);
		    break;

		  case '.':
		    if (nondigit) goto trailing_uc;
		    if (seen_point || seen_e) {
			goto decode_num;
		    }
		    else {
			int c0 = nextc();
			if (!ISDIGIT(c0)) {
			    pushback(c0);
			    goto decode_num;
			}
			c = c0;
		    }
		    tokadd('.');
		    tokadd(c);
		    is_float++;
		    seen_point++;
		    nondigit = 0;
		    break;

		  case 'e':
		  case 'E':
		    if (nondigit) {
			pushback(c);
			c = nondigit;
			goto decode_num;
		    }
		    if (seen_e) {
			goto decode_num;
		    }
		    tokadd(c);
		    seen_e++;
		    is_float++;
		    nondigit = c;
		    c = nextc();
		    if (c != '-' && c != '+') continue;
		    tokadd(c);
		    nondigit = c;
		    break;

		  case '_':	/* `_' in number just ignored */
		    if (nondigit) goto decode_num;
		    nondigit = c;
		    break;

		  default:
		    goto decode_num;
		}
		c = nextc();
	    }

	  decode_num:
	    pushback(c);
	    tokfix();
	    if (nondigit) {
		char tmp[30];
	      trailing_uc:
		sprintf(tmp, "trailing `%c' in number", nondigit);
		yyerror(tmp);
	    }
	    if (is_float) {
		double d = strtod(tok(), 0);
		if (errno == ERANGE) {
		    rb_warn("Float %s out of range", tok());
		    errno = 0;
		}
		yylval.node = NEW_LIT(rb_float_new(d));
		return tFLOAT;
	    }
	    yylval.node = NEW_LIT(rb_cstr_to_inum(tok(), 10, Qfalse));
	    return tINTEGER;
	}

      case ']':
      case '}':
      case ')':
	COND_LEXPOP();
	CMDARG_LEXPOP();
	lex_state = EXPR_END;
	return c;

      case ':':
	c = nextc();
	if (c == ':') {
	    if (lex_state == EXPR_BEG ||  lex_state == EXPR_MID ||
		lex_state == EXPR_CLASS || (IS_ARG() && space_seen)) {
		lex_state = EXPR_BEG;
		return tCOLON3;
	    }
	    lex_state = EXPR_DOT;
	    return tCOLON2;
	}
	if (lex_state == EXPR_END || lex_state == EXPR_ENDARG || ISSPACE(c)) {
	    pushback(c);
	    lex_state = EXPR_BEG;
	    return ':';
	}
	switch (c) {
	  case '\'':
	    lex_strterm = NEW_STRTERM(str_ssym, c, 0);
	    break;
	  case '"':
	    lex_strterm = NEW_STRTERM(str_dsym, c, 0);
	    break;
	  default:
	    pushback(c);
	    break;
	}
	lex_state = EXPR_FNAME;
	return tSYMBEG;

      case '/':
	if (lex_state == EXPR_BEG || lex_state == EXPR_MID) {
	    lex_strterm = NEW_STRTERM(str_regexp, '/', 0);
	    return tREGEXP_BEG;
	}
	if ((c = nextc()) == '=') {
	    yylval.id = '/';
	    lex_state = EXPR_BEG;
	    return tOP_ASGN;
	}
	pushback(c);
	if (IS_ARG() && space_seen) {
	    if (!ISSPACE(c)) {
		arg_ambiguous();
		lex_strterm = NEW_STRTERM(str_regexp, '/', 0);
		return tREGEXP_BEG;
	    }
	}
	switch (lex_state) {
	  case EXPR_FNAME: case EXPR_DOT:
	    lex_state = EXPR_ARG; break;
	  default:
	    lex_state = EXPR_BEG; break;
	}
	return '/';

      case '^':
	if ((c = nextc()) == '=') {
	    yylval.id = '^';
	    lex_state = EXPR_BEG;
	    return tOP_ASGN;
	}
	switch (lex_state) {
	  case EXPR_FNAME: case EXPR_DOT:
	    lex_state = EXPR_ARG; break;
	  default:
	    lex_state = EXPR_BEG; break;
	}
	pushback(c);
	return '^';

      case ';':
	command_start = Qtrue;
      case ',':
	lex_state = EXPR_BEG;
	return c;

      case '~':
	if (lex_state == EXPR_FNAME || lex_state == EXPR_DOT) {
	    if ((c = nextc()) != '@') {
		pushback(c);
	    }
	}
	switch (lex_state) {
	  case EXPR_FNAME: case EXPR_DOT:
	    lex_state = EXPR_ARG; break;
	  default:
	    lex_state = EXPR_BEG; break;
	}
	return '~';

      case '(':
	command_start = Qtrue;
	if (lex_state == EXPR_BEG || lex_state == EXPR_MID) {
	    c = tLPAREN;
	}
	else if (space_seen) {
	    if (lex_state == EXPR_CMDARG) {
		c = tLPAREN_ARG;
	    }
	    else if (lex_state == EXPR_ARG) {
		rb_warn("don't put space before argument parentheses");
		c = '(';
	    }
	}
	COND_PUSH(0);
	CMDARG_PUSH(0);
	lex_state = EXPR_BEG;
	return c;

      case '[':
	if (lex_state == EXPR_FNAME || lex_state == EXPR_DOT) {
	    lex_state = EXPR_ARG;
	    if ((c = nextc()) == ']') {
		if ((c = nextc()) == '=') {
		    return tASET;
		}
		pushback(c);
		return tAREF;
	    }
	    pushback(c);
	    return '[';
	}
	else if (lex_state == EXPR_BEG || lex_state == EXPR_MID) {
	    c = tLBRACK;
	}
	else if (IS_ARG() && space_seen) {
	    c = tLBRACK;
	}
	lex_state = EXPR_BEG;
	COND_PUSH(0);
	CMDARG_PUSH(0);
	return c;

      case '{':
	if (IS_ARG() || lex_state == EXPR_END)
	    c = '{';          /* block (primary) */
	else if (lex_state == EXPR_ENDARG)
	    c = tLBRACE_ARG;  /* block (expr) */
	else
	    c = tLBRACE;      /* hash */
	COND_PUSH(0);
	CMDARG_PUSH(0);
	lex_state = EXPR_BEG;
	return c;

      case '\\':
	c = nextc();
	if (c == '\n') {
	    space_seen = 1;
	    goto retry; /* skip \\n */
	}
	pushback(c);
	return '\\';

      case '%':
	if (lex_state == EXPR_BEG || lex_state == EXPR_MID) {
	    int term;
	    int paren;

	    c = nextc();
	  quotation:
	    if (!ISALNUM(c)) {
		term = c;
		c = 'Q';
	    }
	    else {
		term = nextc();
		if (ISALNUM(term) || ismbchar(term)) {
		    yyerror("unknown type of %string");
		    return 0;
		}
	    }
	    if (c == -1 || term == -1) {
		rb_compile_error("unterminated quoted string meets end of file");
		return 0;
	    }
	    paren = term;
	    if (term == '(') term = ')';
	    else if (term == '[') term = ']';
	    else if (term == '{') term = '}';
	    else if (term == '<') term = '>';
	    else paren = 0;

	    switch (c) {
	      case 'Q':
		lex_strterm = NEW_STRTERM(str_dquote, term, paren);
		return tSTRING_BEG;

	      case 'q':
		lex_strterm = NEW_STRTERM(str_squote, term, paren);
		return tSTRING_BEG;

	      case 'W':
		lex_strterm = NEW_STRTERM(str_dquote | STR_FUNC_QWORDS, term, paren);
		do {c = nextc();} while (ISSPACE(c));
		pushback(c);
		return tWORDS_BEG;

	      case 'w':
		lex_strterm = NEW_STRTERM(str_squote | STR_FUNC_QWORDS, term, paren);
		do {c = nextc();} while (ISSPACE(c));
		pushback(c);
		return tQWORDS_BEG;

	      case 'x':
		lex_strterm = NEW_STRTERM(str_xquote, term, paren);
		return tXSTRING_BEG;

	      case 'r':
		lex_strterm = NEW_STRTERM(str_regexp, term, paren);
		return tREGEXP_BEG;

	      case 's':
		lex_strterm = NEW_STRTERM(str_ssym, term, paren);
		lex_state = EXPR_FNAME;
		return tSYMBEG;

	      default:
		yyerror("unknown type of %string");
		return 0;
	    }
	}
	if ((c = nextc()) == '=') {
	    yylval.id = '%';
	    lex_state = EXPR_BEG;
	    return tOP_ASGN;
	}
	if (IS_ARG() && space_seen && !ISSPACE(c)) {
	    goto quotation;
	}
	switch (lex_state) {
	  case EXPR_FNAME: case EXPR_DOT:
	    lex_state = EXPR_ARG; break;
	  default:
	    lex_state = EXPR_BEG; break;
	}
	pushback(c);
	return '%';

      case '$':
	last_state = lex_state;
	lex_state = EXPR_END;
	newtok();
	c = nextc();
	switch (c) {
	  case '_':		/* $_: last read line string */
	    c = nextc();
	    if (is_identchar(c)) {
		tokadd('$');
		tokadd('_');
		break;
	    }
	    pushback(c);
	    c = '_';
	    /* fall through */
	  case '~':		/* $~: match-data */
	    local_cnt(c);
	    /* fall through */
	  case '*':		/* $*: argv */
	  case '$':		/* $$: pid */
	  case '?':		/* $?: last status */
	  case '!':		/* $!: error string */
	  case '@':		/* $@: error position */
	  case '/':		/* $/: input record separator */
	  case '\\':		/* $\: output record separator */
	  case ';':		/* $;: field separator */
	  case ',':		/* $,: output field separator */
	  case '.':		/* $.: last read line number */
	  case '=':		/* $=: ignorecase */
	  case ':':		/* $:: load path */
	  case '<':		/* $<: reading filename */
	  case '>':		/* $>: default output handle */
	  case '\"':		/* $": already loaded files */
	    tokadd('$');
	    tokadd(c);
	    tokfix();
	    yylval.id = rb_intern(tok());
	    return tGVAR;

	  case '-':
	    tokadd('$');
	    tokadd(c);
	    c = nextc();
	    if (is_identchar(c)) {
		tokadd(c);
	    }
	    else {
		pushback(c);
	    }
	  gvar:
	    tokfix();
	    yylval.id = rb_intern(tok());
	    /* xxx shouldn't check if valid option variable */
	    return tGVAR;

	  case '&':		/* $&: last match */
	  case '`':		/* $`: string before last match */
	  case '\'':		/* $': string after last match */
	  case '+':		/* $+: string matches last paren. */
	    if (last_state == EXPR_FNAME) {
		tokadd('$');
		tokadd(c);
		goto gvar;
	    }
	    yylval.node = NEW_BACK_REF(c);
	    return tBACK_REF;

	  case '1': case '2': case '3':
	  case '4': case '5': case '6':
	  case '7': case '8': case '9':
	    tokadd('$');
	    do {
		tokadd(c);
		c = nextc();
	    } while (ISDIGIT(c));
	    pushback(c);
	    if (last_state == EXPR_FNAME) goto gvar;
	    tokfix();
	    yylval.node = NEW_NTH_REF(atoi(tok()+1));
	    return tNTH_REF;

	  default:
	    if (!is_identchar(c)) {
		pushback(c);
		return '$';
	    }
	  case '0':
	    tokadd('$');
	}
	break;

      case '@':
	c = nextc();
	newtok();
	tokadd('@');
	if (c == '@') {
	    tokadd('@');
	    c = nextc();
	}
	if (ISDIGIT(c)) {
	    if (tokidx == 1) {
		rb_compile_error("`@%c' is not allowed as an instance variable name", c);
	    }
	    else {
		rb_compile_error("`@@%c' is not allowed as a class variable name", c);
	    }
	}
	if (!is_identchar(c)) {
	    pushback(c);
	    return '@';
	}
	break;

      case '_':
	if (was_bol() && whole_match_p("__END__", 7, 0)) {
	    ruby__end__seen = 1;
	    lex_lastline = 0;
	    return -1;
	}
	newtok();
	break;

      default:
	if (!is_identchar(c)) {
	    rb_compile_error("Invalid char `\\%03o' in expression", c);
	    goto retry;
	}

	newtok();
	break;
    }

    do {
	tokadd(c);
	if (ismbchar(c)) {
	    int i, len = mbclen(c)-1;

	    for (i = 0; i < len; i++) {
		c = nextc();
		tokadd(c);
	    }
	}
	c = nextc();
    } while (is_identchar(c));
    if ((c == '!' || c == '?') && is_identchar(tok()[0]) && !peek('=')) {
	tokadd(c);
    }
    else {
	pushback(c);
    }
    tokfix();

    {
	int result = 0;

	last_state = lex_state;
	switch (tok()[0]) {
	  case '$':
	    lex_state = EXPR_END;
	    result = tGVAR;
	    break;
	  case '@':
	    lex_state = EXPR_END;
	    if (tok()[1] == '@')
		result = tCVAR;
	    else
		result = tIVAR;
	    break;

	  default:
	    if (toklast() == '!' || toklast() == '?') {
		result = tFID;
	    }
	    else {
		if (lex_state == EXPR_FNAME) {
		    if ((c = nextc()) == '=' && !peek('~') && !peek('>') &&
			(!peek('=') || (lex_p + 1 < lex_pend && lex_p[1] == '>'))) {
			result = tIDENTIFIER;
			tokadd(c);
			tokfix();
		    }
		    else {
			pushback(c);
		    }
		}
		if (result == 0 && ISUPPER(tok()[0])) {
		    result = tCONSTANT;
		}
		else {
		    result = tIDENTIFIER;
		}
	    }

	    if (lex_state != EXPR_DOT) {
		struct kwtable *kw;

		/* See if it is a reserved word.  */
		kw = rb_reserved_word(tok(), toklen());
		if (kw) {
		    enum lex_state state = lex_state;
		    lex_state = kw->state;
		    if (state == EXPR_FNAME) {
			yylval.id = rb_intern(kw->name);
			return kw->id[0];
		    }
		    if (kw->id[0] == kDO) {
			if (COND_P()) return kDO_COND;
			if (CMDARG_P() && state != EXPR_CMDARG)
			    return kDO_BLOCK;
			if (state == EXPR_ENDARG)
			    return kDO_BLOCK;
			return kDO;
		    }
		    if (state == EXPR_BEG)
			return kw->id[0];
		    else {
			if (kw->id[0] != kw->id[1])
			    lex_state = EXPR_BEG;
			return kw->id[1];
		    }
		}
	    }

	    if (lex_state == EXPR_BEG ||
		lex_state == EXPR_MID ||
		lex_state == EXPR_DOT ||
		lex_state == EXPR_ARG ||
		lex_state == EXPR_CMDARG) {
		if (cmd_state) {
		    lex_state = EXPR_CMDARG;
		}
		else {
		    lex_state = EXPR_ARG;
		}
	    }
	    else {
		lex_state = EXPR_END;
	    }
	}
	yylval.id = rb_intern(tok());
	if (is_local_id(yylval.id) &&
	    last_state != EXPR_DOT &&
	    ((dyna_in_block() && rb_dvar_defined(yylval.id)) || local_id(yylval.id))) {
	    lex_state = EXPR_END;
	}
	return result;
    }
}

NODE*
rb_node_newnode(type, a0, a1, a2)
    enum node_type type;
    VALUE a0, a1, a2;
{
    NODE *n = (NODE*)rb_newobj();

    n->flags |= T_NODE;
    nd_set_type(n, type);
    nd_set_line(n, ruby_sourceline);
    n->nd_file = ruby_sourcefile;

    n->u1.value = a0;
    n->u2.value = a1;
    n->u3.value = a2;

    return n;
}

#if 0
static enum node_type
nodetype(node)			/* for debug */
    NODE *node;
{
    return (enum node_type)nd_type(node);
}
#endif

#if 0
static int
nodeline(node)
    NODE *node;
{
    return nd_line(node);
}
#endif

static NODE*
newline_node(node)
    NODE *node;
{
    NODE *nl = 0;
    if (node) {
	if (nd_type(node) == NODE_NEWLINE) return node;
        nl = NEW_NEWLINE(node);
        fixpos(nl, node);
        nl->nd_nth = nd_line(node);
    }
    return nl;
}

static void
fixpos(node, orig)
    NODE *node, *orig;
{
    if (!node) return;
    if (!orig) return;
    if (orig == (NODE*)1) return;
    node->nd_file = orig->nd_file;
    nd_set_line(node, nd_line(orig));
}

static void
parser_warning(node, mesg)
    NODE *node;
    const char *mesg;
{
    int line = ruby_sourceline;
    ruby_sourceline = nd_line(node);
    rb_warning(mesg);
    ruby_sourceline = line;
}

static void
parser_warn(node, mesg)
    NODE *node;
    const char *mesg;
{
    int line = ruby_sourceline;
    ruby_sourceline = nd_line(node);
    rb_warn(mesg);
    ruby_sourceline = line;
}

static NODE*
block_append(head, tail)
    NODE *head, *tail;
{
    NODE *end, *h = head;

    if (tail == 0) return head;

  again:
    if (h == 0) return tail;
    switch (nd_type(h)) {
      case NODE_NEWLINE:
	h = h->nd_next;
	goto again;
      case NODE_LIT:
      case NODE_STR:
	parser_warning(h, "unused literal ignored");
	return tail;
      default:
	h = end = NEW_BLOCK(head);
	end->nd_end = end;
	fixpos(end, head);
	head = end;
	break;
      case NODE_BLOCK:
	end = h->nd_end;
	break;
    }

    if (RTEST(ruby_verbose)) {
	NODE *nd = end->nd_head;
      newline:
	switch (nd_type(nd)) {
	  case NODE_RETURN:
	  case NODE_BREAK:
	  case NODE_NEXT:
	  case NODE_REDO:
	  case NODE_RETRY:
	    parser_warning(nd, "statement not reached");
	    break;

	case NODE_NEWLINE:
	    nd = nd->nd_next;
	    goto newline;

	  default:
	    break;
	}
    }

    if (nd_type(tail) != NODE_BLOCK) {
	tail = NEW_BLOCK(tail);
	tail->nd_end = tail;
    }
    end->nd_next = tail;
    h->nd_end = tail->nd_end;
    return head;
}

/* append item to the list */
static NODE*
list_append(list, item)
    NODE *list, *item;
{
    NODE *last;

    if (list == 0) return NEW_LIST(item);
    if (list->nd_next) {
	last = list->nd_next->nd_end;
    }
    else {
	last = list;
    }

    list->nd_alen += 1;
    last->nd_next = NEW_LIST(item);
    list->nd_next->nd_end = last->nd_next;
    return list;
}

/* concat two lists */
static NODE*
list_concat(head, tail)
    NODE *head, *tail;
{
    NODE *last;

    if (head->nd_next) {
	last = head->nd_next->nd_end;
    }
    else {
	last = head;
    }

    head->nd_alen += tail->nd_alen;
    last->nd_next = tail;
    if (tail->nd_next) {
	head->nd_next->nd_end = tail->nd_next->nd_end;
    }
    else {
	head->nd_next->nd_end = tail;
    }

    return head;
}

/* concat two string literals */
static NODE *
literal_concat(head, tail)
    NODE *head, *tail;
{
    enum node_type htype;

    if (!head) return tail;
    if (!tail) return head;

    htype = nd_type(head);
    if (htype == NODE_EVSTR) {
	NODE *node = NEW_DSTR(rb_str_new(0, 0));
	head = list_append(node, head);
    }
    switch (nd_type(tail)) {
      case NODE_STR:
	if (htype == NODE_STR) {
	    rb_str_concat(head->nd_lit, tail->nd_lit);
	    rb_gc_force_recycle((VALUE)tail);
	}
	else {
	    list_append(head, tail);
	}
	break;

      case NODE_DSTR:
	if (htype == NODE_STR) {
	    rb_str_concat(head->nd_lit, tail->nd_lit);
	    tail->nd_lit = head->nd_lit;
	    rb_gc_force_recycle((VALUE)head);
	    head = tail;
	}
	else {
	    nd_set_type(tail, NODE_ARRAY);
	    tail->nd_head = NEW_STR(tail->nd_lit);
	    list_concat(head, tail);
	}
	break;

      case NODE_EVSTR:
	if (htype == NODE_STR) {
	    nd_set_type(head, NODE_DSTR);
	    head->nd_alen = 1;
	}
	list_append(head, tail);
	break;
    }
    return head;
}

static NODE *
evstr2dstr(node)
    NODE *node;
{
    if (nd_type(node) == NODE_EVSTR) {
	node = list_append(NEW_DSTR(rb_str_new(0, 0)), node);
    }
    return node;
}

static NODE *
new_evstr(node)
    NODE *node;
{
    NODE *head = node;

  again:
    if (node) {
	switch (nd_type(node)) {
	  case NODE_STR: case NODE_DSTR: case NODE_EVSTR:
	    return node;
	  case NODE_NEWLINE:
	    node = node->nd_next;
	    goto again;
	}
    }
    return NEW_EVSTR(head);
}

static NODE *
call_op(recv, id, narg, arg1)
    NODE *recv;
    ID id;
    int narg;
    NODE *arg1;
{
    value_expr(recv);
    if (narg == 1) {
	value_expr(arg1);
	arg1 = NEW_LIST(arg1);
    }
    else {
	arg1 = 0;
    }
    return NEW_CALL(recv, id, arg1);
}

static NODE*
match_gen(node1, node2)
    NODE *node1;
    NODE *node2;
{
    local_cnt('~');

    value_expr(node1);
    value_expr(node2);
    if (node1) {
	switch (nd_type(node1)) {
	  case NODE_DREGX:
	  case NODE_DREGX_ONCE:
	    return NEW_MATCH2(node1, node2);

	  case NODE_LIT:
	    if (TYPE(node1->nd_lit) == T_REGEXP) {
		return NEW_MATCH2(node1, node2);
	    }
	}
    }

    if (node2) {
	switch (nd_type(node2)) {
	  case NODE_DREGX:
	  case NODE_DREGX_ONCE:
	    return NEW_MATCH3(node2, node1);

	  case NODE_LIT:
	    if (TYPE(node2->nd_lit) == T_REGEXP) {
		return NEW_MATCH3(node2, node1);
	    }
	}
    }

    return NEW_CALL(node1, tMATCH, NEW_LIST(node2));
}

static NODE*
gettable(id)
    ID id;
{
    if (id == kSELF) {
	return NEW_SELF();
    }
    else if (id == kNIL) {
	return NEW_NIL();
    }
    else if (id == kTRUE) {
	return NEW_TRUE();
    }
    else if (id == kFALSE) {
	return NEW_FALSE();
    }
    else if (id == k__FILE__) {
	return NEW_STR(rb_str_new2(ruby_sourcefile));
    }
    else if (id == k__LINE__) {
	return NEW_LIT(INT2FIX(ruby_sourceline));
    }
    else if (is_local_id(id)) {
	if (dyna_in_block() && rb_dvar_defined(id)) return NEW_DVAR(id);
	if (local_id(id)) return NEW_LVAR(id);
	/* method call without arguments */
#if 0
	/* Rite will warn this */
	rb_warn("ambiguous identifier; %s() or self.%s is better for method call",
		rb_id2name(id), rb_id2name(id));
#endif
	return NEW_VCALL(id);
    }
    else if (is_global_id(id)) {
	return NEW_GVAR(id);
    }
    else if (is_instance_id(id)) {
	return NEW_IVAR(id);
    }
    else if (is_const_id(id)) {
	return NEW_CONST(id);
    }
    else if (is_class_id(id)) {
	return NEW_CVAR(id);
    }
    rb_compile_error("identifier %s is not valid", rb_id2name(id));
    return 0;
}

static NODE*
assignable(id, val)
    ID id;
    NODE *val;
{
    value_expr(val);
    if (id == kSELF) {
	yyerror("Can't change the value of self");
    }
    else if (id == kNIL) {
	yyerror("Can't assign to nil");
    }
    else if (id == kTRUE) {
	yyerror("Can't assign to true");
    }
    else if (id == kFALSE) {
	yyerror("Can't assign to false");
    }
    else if (id == k__FILE__) {
	yyerror("Can't assign to __FILE__");
    }
    else if (id == k__LINE__) {
	yyerror("Can't assign to __LINE__");
    }
    else if (is_local_id(id)) {
	if (rb_dvar_curr(id)) {
	    return NEW_DASGN_CURR(id, val);
	}
	else if (rb_dvar_defined(id)) {
	    return NEW_DASGN(id, val);
	}
	else if (local_id(id) || !dyna_in_block()) {
	    return NEW_LASGN(id, val);
	}
	else{
	    rb_dvar_push(id, Qnil);
	    return NEW_DASGN_CURR(id, val);
	}
    }
    else if (is_global_id(id)) {
	return NEW_GASGN(id, val);
    }
    else if (is_instance_id(id)) {
	return NEW_IASGN(id, val);
    }
    else if (is_const_id(id)) {
	if (in_def || in_single)
	    yyerror("dynamic constant assignment");
	return NEW_CDECL(id, val, 0);
    }
    else if (is_class_id(id)) {
	if (in_def || in_single) return NEW_CVASGN(id, val);
	return NEW_CVDECL(id, val);
    }
    else {
	rb_compile_error("identifier %s is not valid", rb_id2name(id));
    }
    return 0;
}

static NODE *
aryset(recv, idx)
    NODE *recv, *idx;
{
    if (recv && nd_type(recv) == NODE_SELF)
	recv = (NODE *)1;
    else
	value_expr(recv);
    return NEW_ATTRASGN(recv, tASET, idx);
}

ID
rb_id_attrset(id)
    ID id;
{
    id &= ~ID_SCOPE_MASK;
    id |= ID_ATTRSET;
    return id;
}

static NODE *
attrset(recv, id)
    NODE *recv;
    ID id;
{
    if (recv && nd_type(recv) == NODE_SELF)
	recv = (NODE *)1;
    else
	value_expr(recv);
    return NEW_ATTRASGN(recv, rb_id_attrset(id), 0);
}

static void
rb_backref_error(node)
    NODE *node;
{
    switch (nd_type(node)) {
      case NODE_NTH_REF:
	rb_compile_error("Can't set variable $%d", node->nd_nth);
	break;
      case NODE_BACK_REF:
	rb_compile_error("Can't set variable $%c", (int)node->nd_nth);
	break;
    }
}

static NODE *
arg_concat(node1, node2)
    NODE *node1;
    NODE *node2;
{
    if (!node2) return node1;
    return NEW_ARGSCAT(node1, node2);
}

static NODE *
arg_add(node1, node2)
    NODE *node1;
    NODE *node2;
{
    if (!node1) return NEW_LIST(node2);
    if (nd_type(node1) == NODE_ARRAY) {
	return list_append(node1, node2);
    }
    else {
	return NEW_ARGSPUSH(node1, node2);
    }
}

static NODE*
node_assign(lhs, rhs)
    NODE *lhs, *rhs;
{
    if (!lhs) return 0;

    value_expr(rhs);
    switch (nd_type(lhs)) {
      case NODE_GASGN:
      case NODE_IASGN:
      case NODE_LASGN:
      case NODE_DASGN:
      case NODE_DASGN_CURR:
      case NODE_MASGN:
      case NODE_CDECL:
      case NODE_CVDECL:
      case NODE_CVASGN:
	lhs->nd_value = rhs;
	break;

      case NODE_ATTRASGN:
      case NODE_CALL:
	lhs->nd_args = arg_add(lhs->nd_args, rhs);
	break;

      default:
	/* should not happen */
	break;
    }

    return lhs;
}

static int
value_expr0(node)
    NODE *node;
{
    int cond = 0;

    while (node) {
	switch (nd_type(node)) {
	  case NODE_DEFN:
	  case NODE_DEFS:
	    parser_warning(node, "void value expression");
	    return Qfalse;

	  case NODE_RETURN:
	  case NODE_BREAK:
	  case NODE_NEXT:
	  case NODE_REDO:
	  case NODE_RETRY:
	    if (!cond) yyerror("void value expression");
	    /* or "control never reach"? */
	    return Qfalse;

	  case NODE_BLOCK:
	    while (node->nd_next) {
		node = node->nd_next;
	    }
	    node = node->nd_head;
	    break;

	  case NODE_BEGIN:
	    node = node->nd_body;
	    break;

	  case NODE_IF:
	    if (!value_expr(node->nd_body)) return Qfalse;
	    node = node->nd_else;
	    break;

	  case NODE_AND:
	  case NODE_OR:
	    cond = 1;
	    node = node->nd_2nd;
	    break;

	  case NODE_NEWLINE:
	    node = node->nd_next;
	    break;

	  default:
	    return Qtrue;
	}
    }

    return Qtrue;
}

static void
void_expr0(node)
    NODE *node;
{
    char *useless = 0;

    if (!RTEST(ruby_verbose)) return;

  again:
    if (!node) return;
    switch (nd_type(node)) {
      case NODE_NEWLINE:
	node = node->nd_next;
	goto again;

      case NODE_CALL:
	switch (node->nd_mid) {
	  case '+':
	  case '-':
	  case '*':
	  case '/':
	  case '%':
	  case tPOW:
	  case tUPLUS:
	  case tUMINUS:
	  case '|':
	  case '^':
	  case '&':
	  case tCMP:
	  case '>':
	  case tGEQ:
	  case '<':
	  case tLEQ:
	  case tEQ:
	  case tNEQ:
	    useless = rb_id2name(node->nd_mid);
	    break;
	}
	break;

      case NODE_LVAR:
      case NODE_DVAR:
      case NODE_GVAR:
      case NODE_IVAR:
      case NODE_CVAR:
      case NODE_NTH_REF:
      case NODE_BACK_REF:
	useless = "a variable";
	break;
      case NODE_CONST:
      case NODE_CREF:
	useless = "a constant";
	break;
      case NODE_LIT:
      case NODE_STR:
      case NODE_DSTR:
      case NODE_DREGX:
      case NODE_DREGX_ONCE:
	useless = "a literal";
	break;
      case NODE_COLON2:
      case NODE_COLON3:
	useless = "::";
	break;
      case NODE_DOT2:
	useless = "..";
	break;
      case NODE_DOT3:
	useless = "...";
	break;
      case NODE_SELF:
	useless = "self";
	break;
      case NODE_NIL:
	useless = "nil";
	break;
      case NODE_TRUE:
	useless = "true";
	break;
      case NODE_FALSE:
	useless = "false";
	break;
      case NODE_DEFINED:
	useless = "defined?";
	break;
    }

    if (useless) {
	int line = ruby_sourceline;

	ruby_sourceline = nd_line(node);
	rb_warn("useless use of %s in void context", useless);
	ruby_sourceline = line;
    }
}

static void
void_stmts(node)
    NODE *node;
{
    if (!RTEST(ruby_verbose)) return;
    if (!node) return;
    if (nd_type(node) != NODE_BLOCK) return;

    for (;;) {
	if (!node->nd_next) return;
	void_expr(node->nd_head);
	node = node->nd_next;
    }
}

static NODE *
remove_begin(node)
    NODE *node;
{
    NODE **n = &node;
    while (*n) {
	switch (nd_type(*n)) {
	  case NODE_NEWLINE:
	    n = &(*n)->nd_next;
	    continue;
	  case NODE_BEGIN:
	    *n = (*n)->nd_body;
	  default:
	    return node;
	}
    }
    return node;
}

static int
assign_in_cond(node)
    NODE *node;
{
    switch (nd_type(node)) {
      case NODE_MASGN:
	yyerror("multiple assignment in conditional");
	return 1;

      case NODE_LASGN:
      case NODE_DASGN:
      case NODE_GASGN:
      case NODE_IASGN:
	break;

      case NODE_NEWLINE:
      default:
	return 0;
    }

    switch (nd_type(node->nd_value)) {
      case NODE_LIT:
      case NODE_STR:
      case NODE_NIL:
      case NODE_TRUE:
      case NODE_FALSE:
	/* reports always */
	parser_warn(node->nd_value, "found = in conditional, should be ==");
	return 1;

      case NODE_DSTR:
      case NODE_XSTR:
      case NODE_DXSTR:
      case NODE_EVSTR:
      case NODE_DREGX:
      default:
	break;
    }
#if 0
    if (assign_in_cond(node->nd_value) == 0) {
	parser_warning(node->nd_value, "assignment in condition");
    }
#endif
    return 1;
}

static int
e_option_supplied()
{
    if (strcmp(ruby_sourcefile, "-e") == 0)
	return Qtrue;
    return Qfalse;
}

static void
warn_unless_e_option(node, str)
    NODE *node;
    const char *str;
{
    if (!e_option_supplied()) parser_warn(node, str);
}

static void
warning_unless_e_option(node, str)
    NODE *node;
    const char *str;
{
    if (!e_option_supplied()) parser_warning(node, str);
}

static NODE *cond0();

static NODE*
range_op(node)
    NODE *node;
{
    enum node_type type;

    if (!e_option_supplied()) return node;
    if (node == 0) return 0;

    value_expr(node);
    node = cond0(node);
    type = nd_type(node);
    if (type == NODE_NEWLINE) {
	node = node->nd_next;
	type = nd_type(node);
    }
    if (type == NODE_LIT && FIXNUM_P(node->nd_lit)) {
	warn_unless_e_option(node, "integer literal in conditional range");
	return call_op(node,tEQ,1,NEW_GVAR(rb_intern("$.")));
    }
    return node;
}

static int
literal_node(node)
    NODE *node;
{
    if (!node) return 1;	/* same as NODE_NIL */
    switch (nd_type(node)) {
      case NODE_LIT:
      case NODE_STR:
      case NODE_DSTR:
      case NODE_EVSTR:
      case NODE_DREGX:
      case NODE_DREGX_ONCE:
      case NODE_DSYM:
	return 2;
      case NODE_TRUE:
      case NODE_FALSE:
      case NODE_NIL:
	return 1;
    }
    return 0;
}

static NODE*
cond0(node)
    NODE *node;
{
    if (node == 0) return 0;
    assign_in_cond(node);

    switch (nd_type(node)) {
      case NODE_DSTR:
      case NODE_EVSTR:
      case NODE_STR:
	rb_warn("string literal in condition");
	break;

      case NODE_DREGX:
      case NODE_DREGX_ONCE:
	warning_unless_e_option(node, "regex literal in condition");
	local_cnt('_');
	local_cnt('~');
	return NEW_MATCH2(node, NEW_GVAR(rb_intern("$_")));

      case NODE_AND:
      case NODE_OR:
	node->nd_1st = cond0(node->nd_1st);
	node->nd_2nd = cond0(node->nd_2nd);
	break;

      case NODE_DOT2:
      case NODE_DOT3:
	node->nd_beg = range_op(node->nd_beg);
	node->nd_end = range_op(node->nd_end);
	if (nd_type(node) == NODE_DOT2) nd_set_type(node,NODE_FLIP2);
	else if (nd_type(node) == NODE_DOT3) nd_set_type(node, NODE_FLIP3);
	node->nd_cnt = local_append(internal_id());
	if (!e_option_supplied()) {
	    int b = literal_node(node->nd_beg);
	    int e = literal_node(node->nd_end);
	    if ((b == 1 && e == 1) || (b + e >= 2 && RTEST(ruby_verbose))) {
		parser_warn(node, "range literal in condition");
	    }
	}
	break;

      case NODE_DSYM:
	parser_warning(node, "literal in condition");
	break;

      case NODE_LIT:
	if (TYPE(node->nd_lit) == T_REGEXP) {
	    warn_unless_e_option(node, "regex literal in condition");
	    nd_set_type(node, NODE_MATCH);
	    local_cnt('_');
	    local_cnt('~');
	}
	else {
	    parser_warning(node, "literal in condition");
	}
      default:
	break;
    }
    return node;
}

static NODE*
cond(node)
    NODE *node;
{
    if (node == 0) return 0;
    value_expr(node);
    if (nd_type(node) == NODE_NEWLINE){
	node->nd_next = cond0(node->nd_next);
	return node;
    }
    return cond0(node);
}

static NODE*
logop(type, left, right)
    enum node_type type;
    NODE *left, *right;
{
    value_expr(left);
    if (left && nd_type(left) == type) {
	NODE *node = left, *second;
	while ((second = node->nd_2nd) != 0 && nd_type(second) == type) {
	    node = second;
	}
	node->nd_2nd = NEW_NODE(type, second, right, 0);
	return left;
    }
    return NEW_NODE(type, left, right, 0);
}

static int
cond_negative(nodep)
    NODE **nodep;
{
    NODE *c = *nodep;

    if (!c) return 0;
    switch (nd_type(c)) {
      case NODE_NOT:
	*nodep = c->nd_body;
	return 1;
      case NODE_NEWLINE:
	if (c->nd_next && nd_type(c->nd_next) == NODE_NOT) {
	    c->nd_next = c->nd_next->nd_body;
	    return 1;
	}
    }
    return 0;
}

static void
no_blockarg(node)
    NODE *node;
{
    if (node && nd_type(node) == NODE_BLOCK_PASS) {
	rb_compile_error("block argument should not be given");
    }
}

static NODE *
ret_args(node)
    NODE *node;
{
    if (node) {
	no_blockarg(node);
	if (nd_type(node) == NODE_ARRAY && node->nd_next == 0) {
	    node = node->nd_head;
	}
	if (node && nd_type(node) == NODE_SPLAT) {
	    node = NEW_SVALUE(node);
	}
    }
    return node;
}

static NODE *
new_yield(node)
    NODE *node;
{
    long state = Qtrue;

    if (node) {
        no_blockarg(node);
        if (nd_type(node) == NODE_ARRAY && node->nd_next == 0) {
            node = node->nd_head;
            state = Qfalse;
        }
        if (node && nd_type(node) == NODE_SPLAT) {
            state = Qtrue;
        }
    }
    else {
        state = Qfalse;
    }
    return NEW_YIELD(node, state);
}

static NODE*
negate_lit(node)
    NODE *node;
{
    switch (TYPE(node->nd_lit)) {
      case T_FIXNUM:
	node->nd_lit = LONG2FIX(-FIX2LONG(node->nd_lit));
	break;
      case T_BIGNUM:
	node->nd_lit = rb_funcall(node->nd_lit,tUMINUS,0,0);
	break;
      case T_FLOAT:
	RFLOAT(node->nd_lit)->value = -RFLOAT(node->nd_lit)->value;
	break;
      default:
	break;
    }
    return node;
}

static NODE *
arg_blk_pass(node1, node2)
    NODE *node1;
    NODE *node2;
{
    if (node2) {
	node2->nd_head = node1;
	return node2;
    }
    return node1;
}

static NODE*
arg_prepend(node1, node2)
    NODE *node1, *node2;
{
    switch (nd_type(node2)) {
      case NODE_ARRAY:
	return list_concat(NEW_LIST(node1), node2);

      case NODE_SPLAT:
	return arg_concat(node1, node2->nd_head);

      case NODE_BLOCK_PASS:
	node2->nd_body = arg_prepend(node1, node2->nd_body);
	return node2;

      default:
	rb_bug("unknown nodetype(%d) for arg_prepend", nd_type(node2));
    }
    return 0;			/* not reached */
}

static NODE*
new_call(r,m,a)
    NODE *r;
    ID m;
    NODE *a;
{
    if (a && nd_type(a) == NODE_BLOCK_PASS) {
	a->nd_iter = NEW_CALL(r,m,a->nd_head);
	return a;
    }
    return NEW_CALL(r,m,a);
}

static NODE*
new_fcall(m,a)
    ID m;
    NODE *a;
{
    if (a && nd_type(a) == NODE_BLOCK_PASS) {
	a->nd_iter = NEW_FCALL(m,a->nd_head);
	return a;
    }
    return NEW_FCALL(m,a);
}

static NODE*
new_super(a)
    NODE *a;
{
    if (a && nd_type(a) == NODE_BLOCK_PASS) {
	a->nd_iter = NEW_SUPER(a->nd_head);
	return a;
    }
    return NEW_SUPER(a);
}

static struct local_vars {
    ID *tbl;
    int nofree;
    int cnt;
    int dlev;
    struct RVarmap* dyna_vars;
    struct local_vars *prev;
} *lvtbl;

static void
local_push(top)
    int top;
{
    struct local_vars *local;

    local = ALLOC(struct local_vars);
    local->prev = lvtbl;
    local->nofree = 0;
    local->cnt = 0;
    local->tbl = 0;
    local->dlev = 0;
    local->dyna_vars = ruby_dyna_vars;
    lvtbl = local;
    if (!top) {
	/* preserve reference for GC, but link should be cut. */
	rb_dvar_push(0, (VALUE)ruby_dyna_vars);
	ruby_dyna_vars->next = 0;
    }
}

static void
local_pop()
{
    struct local_vars *local = lvtbl->prev;

    if (lvtbl->tbl) {
	if (!lvtbl->nofree) xfree(lvtbl->tbl);
	else lvtbl->tbl[0] = lvtbl->cnt;
    }
    ruby_dyna_vars = lvtbl->dyna_vars;
    xfree(lvtbl);
    lvtbl = local;
}

static ID*
local_tbl()
{
    lvtbl->nofree = 1;
    return lvtbl->tbl;
}

static int
local_append(id)
    ID id;
{
    if (lvtbl->tbl == 0) {
	lvtbl->tbl = ALLOC_N(ID, 4);
	lvtbl->tbl[0] = 0;
	lvtbl->tbl[1] = '_';
	lvtbl->tbl[2] = '~';
	lvtbl->cnt = 2;
	if (id == '_') return 0;
	if (id == '~') return 1;
    }
    else {
	REALLOC_N(lvtbl->tbl, ID, lvtbl->cnt+2);
    }

    lvtbl->tbl[lvtbl->cnt+1] = id;
    return lvtbl->cnt++;
}

static int
local_cnt(id)
    ID id;
{
    int cnt, max;

    if (id == 0) return lvtbl->cnt;

    for (cnt=1, max=lvtbl->cnt+1; cnt<max;cnt++) {
	if (lvtbl->tbl[cnt] == id) return cnt-1;
    }
    return local_append(id);
}

static int
local_id(id)
    ID id;
{
    int i, max;

    if (lvtbl == 0) return Qfalse;
    for (i=3, max=lvtbl->cnt+1; i<max; i++) {
	if (lvtbl->tbl[i] == id) return Qtrue;
    }
    return Qfalse;
}

static void
top_local_init()
{
    local_push(1);
    lvtbl->cnt = ruby_scope->local_tbl?ruby_scope->local_tbl[0]:0;
    if (lvtbl->cnt > 0) {
	lvtbl->tbl = ALLOC_N(ID, lvtbl->cnt+3);
	MEMCPY(lvtbl->tbl, ruby_scope->local_tbl, ID, lvtbl->cnt+1);
    }
    else {
	lvtbl->tbl = 0;
    }
    if (ruby_dyna_vars)
	lvtbl->dlev = 1;
    else
	lvtbl->dlev = 0;
}

static void
top_local_setup()
{
    int len = lvtbl->cnt;
    int i;

    if (len > 0) {
	i = ruby_scope->local_tbl?ruby_scope->local_tbl[0]:0;

	if (i < len) {
	    if (i == 0 || (ruby_scope->flags & SCOPE_MALLOC) == 0) {
		VALUE *vars = ALLOC_N(VALUE, len+1);
		if (ruby_scope->local_vars) {
		    *vars++ = ruby_scope->local_vars[-1];
		    MEMCPY(vars, ruby_scope->local_vars, VALUE, i);
		    rb_mem_clear(vars+i, len-i);
		}
		else {
		    *vars++ = (VALUE)ruby_scope;
		    rb_mem_clear(vars, len);
		}
		ruby_scope->local_vars = vars;
		ruby_scope->flags |= SCOPE_MALLOC;
	    }
	    else {
		VALUE *vars = ruby_scope->local_vars-1;
		REALLOC_N(vars, VALUE, len+1);
		ruby_scope->local_vars = vars+1;
		rb_mem_clear(ruby_scope->local_vars+i, len-i);
	    }
	    if (ruby_scope->local_tbl && ruby_scope->local_vars[-1] == 0) {
		xfree(ruby_scope->local_tbl);
	    }
	    ruby_scope->local_tbl = local_tbl();
	}
    }
    local_pop();
}

static struct RVarmap*
dyna_push()
{
    struct RVarmap* vars = ruby_dyna_vars;

    rb_dvar_push(0, 0);
    lvtbl->dlev++;
    return vars;
}

static void
dyna_pop(vars)
    struct RVarmap* vars;
{
    lvtbl->dlev--;
    ruby_dyna_vars = vars;
}

static int
dyna_in_block()
{
    return (lvtbl->dlev > 0);
}

static NODE *
dyna_init(node, pre)
    NODE *node;
    struct RVarmap *pre;
{
    struct RVarmap *post = ruby_dyna_vars;
    NODE *var;

    if (!node || !post || pre == post) return node;
    for (var = 0; post != pre && post->id; post = post->next) {
	var = NEW_DASGN_CURR(post->id, var);
    }
    return block_append(var, node);
}

int
ruby_parser_stack_on_heap()
{
#if defined(YYMALLOC)
    return Qfalse;
#else
    return Qtrue;
#endif
}

void
rb_gc_mark_parser()
{
#if defined YYMALLOC
    rb_gc_mark((VALUE)parser_heap);
#elif defined yystacksize
    if (yyvsp) rb_gc_mark_locations((VALUE *)yyvs, (VALUE *)yyvsp);
#endif

    if (!ruby_in_compile) return;

    rb_gc_mark_maybe((VALUE)yylval.node);
    rb_gc_mark(ruby_debug_lines);
    rb_gc_mark(lex_lastline);
    rb_gc_mark(lex_input);
    rb_gc_mark((VALUE)lex_strterm);
}

void
rb_parser_append_print()
{
    ruby_eval_tree =
	block_append(ruby_eval_tree,
		     NEW_FCALL(rb_intern("print"),
			       NEW_ARRAY(NEW_GVAR(rb_intern("$_")))));
}

void
rb_parser_while_loop(chop, split)
    int chop, split;
{
    if (split) {
	ruby_eval_tree =
	    block_append(NEW_GASGN(rb_intern("$F"),
				   NEW_CALL(NEW_GVAR(rb_intern("$_")),
					    rb_intern("split"), 0)),
				   ruby_eval_tree);
    }
    if (chop) {
	ruby_eval_tree =
	    block_append(NEW_CALL(NEW_GVAR(rb_intern("$_")),
				  rb_intern("chop!"), 0), ruby_eval_tree);
    }
    ruby_eval_tree = NEW_OPT_N(ruby_eval_tree);
}

static struct {
    ID token;
    char *name;
} op_tbl[] = {
    {tDOT2,	".."},
    {tDOT3,	"..."},
    {'+',	"+"},
    {'-',	"-"},
    {'+',	"+(binary)"},
    {'-',	"-(binary)"},
    {'*',	"*"},
    {'/',	"/"},
    {'%',	"%"},
    {tPOW,	"**"},
    {tUPLUS,	"+@"},
    {tUMINUS,	"-@"},
    {tUPLUS,	"+(unary)"},
    {tUMINUS,	"-(unary)"},
    {'|',	"|"},
    {'^',	"^"},
    {'&',	"&"},
    {tCMP,	"<=>"},
    {'>',	">"},
    {tGEQ,	">="},
    {'<',	"<"},
    {tLEQ,	"<="},
    {tEQ,	"=="},
    {tEQQ,	"==="},
    {tNEQ,	"!="},
    {tMATCH,	"=~"},
    {tNMATCH,	"!~"},
    {'!',	"!"},
    {'~',	"~"},
    {'!',	"!(unary)"},
    {'~',	"~(unary)"},
    {'!',	"!@"},
    {'~',	"~@"},
    {tAREF,	"[]"},
    {tASET,	"[]="},
    {tLSHFT,	"<<"},
    {tRSHFT,	">>"},
    {tCOLON2,	"::"},
    {'`',	"`"},
    {0,	0}
};

static st_table *sym_tbl;
static st_table *sym_rev_tbl;

void
Init_sym()
{
    sym_tbl = st_init_strtable_with_size(200);
    sym_rev_tbl = st_init_numtable_with_size(200);
}

static ID last_id = tLAST_TOKEN;

static ID
internal_id()
{
    return ID_INTERNAL | (++last_id << ID_SCOPE_SHIFT);
}

static int
is_special_global_name(m)
    const char *m;
{
    switch (*m) {
      case '~': case '*': case '$': case '?': case '!': case '@':
      case '/': case '\\': case ';': case ',': case '.': case '=':
      case ':': case '<': case '>': case '\"':
      case '&': case '`': case '\'': case '+':
      case '0':
	++m;
	break;
      case '-':
	++m;
	if (is_identchar(*m)) m += mbclen(*m);
	break;
      default:
	if (!ISDIGIT(*m)) return 0;
	do ++m; while (ISDIGIT(*m));
    }
    return !*m;
}

int
rb_symname_p(name)
    const char *name;
{
    const char *m = name;
    int localid = Qfalse;

    if (!m) return Qfalse;
    switch (*m) {
      case '\0':
	return Qfalse;

      case '$':
	if (is_special_global_name(++m)) return Qtrue;
	goto id;

      case '@':
	if (*++m == '@') ++m;
	goto id;

      case '<':
	switch (*++m) {
	  case '<': ++m; break;
	  case '=': if (*++m == '>') ++m; break;
	  default: break;
	}
	break;

      case '>':
	switch (*++m) {
	  case '>': case '=': ++m; break;
	}
	break;

      case '=':
	switch (*++m) {
	  case '~': ++m; break;
	  case '=': if (*++m == '=') ++m; break;
	  default: return Qfalse;
	}
	break;

      case '*':
	if (*++m == '*') ++m;
	break;

      case '+': case '-':
	if (*++m == '@') ++m;
	break;

      case '|': case '^': case '&': case '/': case '%': case '~': case '`':
	++m;
	break;

      case '[':
	if (*++m != ']') return Qfalse;
	if (*++m == '=') ++m;
	break;

      default:
	localid = !ISUPPER(*m);
      id:
	if (*m != '_' && !ISALPHA(*m) && !ismbchar(*m)) return Qfalse;
	while (is_identchar(*m)) m += mbclen(*m);
	if (localid) {
	    switch (*m) {
	      case '!': case '?': case '=': ++m;
	    }
	}
	break;
    }
    return *m ? Qfalse : Qtrue;
}

ID
rb_intern(name)
    const char *name;
{
    const char *m = name;
    ID id;
    int last;

    if (st_lookup(sym_tbl, (st_data_t)name, (st_data_t *)&id))
	return id;

    last = strlen(name)-1;
    id = 0;
    switch (*name) {
      case '$':
	id |= ID_GLOBAL;
	if (is_special_global_name(++m)) goto new_id;
	break;
      case '@':
	if (name[1] == '@') {
	    m++;
	    id |= ID_CLASS;
	}
	else {
	    id |= ID_INSTANCE;
	}
	m++;
	break;
      default:
	if (name[0] != '_' && ISASCII(name[0]) && !ISALNUM(name[0])) {
	    /* operators */
	    int i;

	    for (i=0; op_tbl[i].token; i++) {
		if (*op_tbl[i].name == *name &&
		    strcmp(op_tbl[i].name, name) == 0) {
		    id = op_tbl[i].token;
		    goto id_regist;
		}
	    }
	}

	if (name[last] == '=') {
	    /* attribute assignment */
	    char *buf = ALLOCA_N(char,last+1);

	    strncpy(buf, name, last);
	    buf[last] = '\0';
	    id = rb_intern(buf);
	    if (id > tLAST_TOKEN && !is_attrset_id(id)) {
		id = rb_id_attrset(id);
		goto id_regist;
	    }
	    id = ID_ATTRSET;
	}
	else if (ISUPPER(name[0])) {
	    id = ID_CONST;
        }
	else {
	    id = ID_LOCAL;
	}
	break;
    }
    if (!ISDIGIT(*m)) {
	while (m <= name + last && is_identchar(*m)) {
	    m += mbclen(*m);
	}
    }
    if (*m) id = ID_JUNK;
  new_id:
    id |= ++last_id << ID_SCOPE_SHIFT;
  id_regist:
    name = strdup(name);
    st_add_direct(sym_tbl, (st_data_t)name, id);
    st_add_direct(sym_rev_tbl, id, (st_data_t)name);
    return id;
}

char *
rb_id2name(id)
    ID id;
{
    char *name;

    if (id < tLAST_TOKEN) {
	int i = 0;

	for (i=0; op_tbl[i].token; i++) {
	    if (op_tbl[i].token == id)
		return op_tbl[i].name;
	}
    }

    if (st_lookup(sym_rev_tbl, id, (st_data_t *)&name))
	return name;

    if (is_attrset_id(id)) {
	ID id2 = (id & ~ID_SCOPE_MASK) | ID_LOCAL;

      again:
	name = rb_id2name(id2);
	if (name) {
	    char *buf = ALLOCA_N(char, strlen(name)+2);

	    strcpy(buf, name);
	    strcat(buf, "=");
	    rb_intern(buf);
	    return rb_id2name(id);
	}
	if (is_local_id(id2)) {
	    id2 = (id & ~ID_SCOPE_MASK) | ID_CONST;
	    goto again;
	}
    }
    return 0;
}

static int
symbols_i(key, value, ary)
    char *key;
    ID value;
    VALUE ary;
{
    rb_ary_push(ary, ID2SYM(value));
    return ST_CONTINUE;
}

/*
 *  call-seq:
 *     Symbol.all_symbols    => array
 *  
 *  Returns an array of all the symbols currently in Ruby's symbol
 *  table.
 *     
 *     Symbol.all_symbols.size    #=> 903
 *     Symbol.all_symbols[1,20]   #=> [:floor, :ARGV, :Binding, :symlink,
 *                                     :chown, :EOFError, :$;, :String, 
 *                                     :LOCK_SH, :"setuid?", :$<, 
 *                                     :default_proc, :compact, :extend, 
 *                                     :Tms, :getwd, :$=, :ThreadGroup,
 *                                     :wait2, :$>]
 */

VALUE
rb_sym_all_symbols()
{
    VALUE ary = rb_ary_new2(sym_tbl->num_entries);

    st_foreach(sym_tbl, symbols_i, ary);
    return ary;
}

int
rb_is_const_id(id)
    ID id;
{
    if (is_const_id(id)) return Qtrue;
    return Qfalse;
}

int
rb_is_class_id(id)
    ID id;
{
    if (is_class_id(id)) return Qtrue;
    return Qfalse;
}

int
rb_is_instance_id(id)
    ID id;
{
    if (is_instance_id(id)) return Qtrue;
    return Qfalse;
}

int
rb_is_local_id(id)
    ID id;
{
    if (is_local_id(id)) return Qtrue;
    return Qfalse;
}

int
rb_is_junk_id(id)
    ID id;
{
    if (is_junk_id(id)) return Qtrue;
    return Qfalse;
}

static void
special_local_set(c, val)
    char c;
    VALUE val;
{
    int cnt;

    top_local_init();
    cnt = local_cnt(c);
    top_local_setup();
    ruby_scope->local_vars[cnt] = val;
}

VALUE
rb_backref_get()
{
    VALUE *var = rb_svar(1);
    if (var) {
	return *var;
    }
    return Qnil;
}

void
rb_backref_set(val)
    VALUE val;
{
    VALUE *var = rb_svar(1);
    if (var) {
	*var = val;
    }
    else {
	special_local_set('~', val);
    }
}

VALUE
rb_lastline_get()
{
    VALUE *var = rb_svar(0);
    if (var) {
	return *var;
    }
    return Qnil;
}

void
rb_lastline_set(val)
    VALUE val;
{
    VALUE *var = rb_svar(0);
    if (var) {
	*var = val;
    }
    else {
	special_local_set('_', val);
    }
}

#ifdef YYMALLOC
#define HEAPCNT(n, size) ((n) * (size) / sizeof(YYSTYPE))
#define NEWHEAP() rb_node_newnode(NODE_ALLOCA, 0, (VALUE)parser_heap, 0)
#define ADD2HEAP(n, c, p) ((parser_heap = (n))->u1.node = (p), \
			   (n)->u3.cnt = (c), (p))

static void *
rb_parser_malloc(size)
    size_t size;
{
    size_t cnt = HEAPCNT(1, size);
    NODE *n = NEWHEAP();
    void *ptr = xmalloc(size);

    return ADD2HEAP(n, cnt, ptr);
}

static void *
rb_parser_calloc(nelem, size)
    size_t nelem, size;
{
    size_t cnt = HEAPCNT(nelem, size);
    NODE *n = NEWHEAP();
    void *ptr = xcalloc(nelem, size);

    return ADD2HEAP(n, cnt, ptr);
}

static void *
rb_parser_realloc(ptr, size)
    void *ptr;
    size_t size;
{
    NODE *n;
    size_t cnt = HEAPCNT(1, size);

    if (ptr && (n = parser_heap) != NULL) {
	do {
	    if (n->u1.node == ptr) {
		n->u1.node = ptr = xrealloc(ptr, size);
		if (n->u3.cnt) n->u3.cnt = cnt;
		return ptr;
	    }
	} while ((n = n->u2.node) != NULL);
    }
    n = NEWHEAP();
    ptr = xrealloc(ptr, size);
    return ADD2HEAP(n, cnt, ptr);
}

static void
rb_parser_free(ptr)
    void *ptr;
{
    NODE **prev = &parser_heap, *n;

    while (n = *prev) {
	if (n->u1.node == ptr) {
	    *prev = n->u2.node;
	    rb_gc_force_recycle((VALUE)n);
	    break;
	}
	prev = &n->u2.node;
    }
    xfree(ptr);
}
#endif
#line 9005 "parse.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 346 "parse.y"
{
			lex_state = EXPR_BEG;
                        top_local_init();
			if (ruby_class == rb_cObject) class_nest = 0;
			else class_nest = 1;
		    }
break;
case 2:
#line 353 "parse.y"
{
			if (yyvsp[0].node && !compile_for_eval) {
                            /* last expression should not be void */
			    if (nd_type(yyvsp[0].node) != NODE_BLOCK) void_expr(yyvsp[0].node);
			    else {
				NODE *node = yyvsp[0].node;
				while (node->nd_next) {
				    node = node->nd_next;
				}
				void_expr(node->nd_head);
			    }
			}
			ruby_eval_tree = block_append(ruby_eval_tree, yyvsp[0].node);
                        top_local_setup();
			class_nest = 0;
		    }
break;
case 3:
#line 375 "parse.y"
{
		        yyval.node = yyvsp[-3].node;
			if (yyvsp[-2].node) {
			    yyval.node = NEW_RESCUE(yyvsp[-3].node, yyvsp[-2].node, yyvsp[-1].node);
			}
			else if (yyvsp[-1].node) {
			    rb_warn("else without rescue is useless");
			    yyval.node = block_append(yyval.node, yyvsp[-1].node);
			}
			if (yyvsp[0].node) {
			    yyval.node = NEW_ENSURE(yyval.node, yyvsp[0].node);
			}
			fixpos(yyval.node, yyvsp[-3].node);
		    }
break;
case 4:
#line 392 "parse.y"
{
			void_stmts(yyvsp[-1].node);
		        yyval.node = yyvsp[-1].node;
		    }
break;
case 6:
#line 400 "parse.y"
{
			yyval.node = newline_node(yyvsp[0].node);
		    }
break;
case 7:
#line 404 "parse.y"
{
			yyval.node = block_append(yyvsp[-2].node, newline_node(yyvsp[0].node));
		    }
break;
case 8:
#line 408 "parse.y"
{
			yyval.node = yyvsp[0].node;
		    }
break;
case 9:
#line 413 "parse.y"
{lex_state = EXPR_FNAME;}
break;
case 10:
#line 414 "parse.y"
{
		        yyval.node = NEW_ALIAS(yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 11:
#line 418 "parse.y"
{
		        yyval.node = NEW_VALIAS(yyvsp[-1].id, yyvsp[0].id);
		    }
break;
case 12:
#line 422 "parse.y"
{
			char buf[3];

			sprintf(buf, "$%c", (char)yyvsp[0].node->nd_nth);
		        yyval.node = NEW_VALIAS(yyvsp[-1].id, rb_intern(buf));
		    }
break;
case 13:
#line 429 "parse.y"
{
		        yyerror("can't make alias for the number variables");
		        yyval.node = 0;
		    }
break;
case 14:
#line 434 "parse.y"
{
			yyval.node = yyvsp[0].node;
		    }
break;
case 15:
#line 438 "parse.y"
{
			yyval.node = NEW_IF(cond(yyvsp[0].node), yyvsp[-2].node, 0);
		        fixpos(yyval.node, yyvsp[0].node);
			if (cond_negative(&yyval.node->nd_cond)) {
		            yyval.node->nd_else = yyval.node->nd_body;
		            yyval.node->nd_body = 0;
			}
		    }
break;
case 16:
#line 447 "parse.y"
{
			yyval.node = NEW_UNLESS(cond(yyvsp[0].node), yyvsp[-2].node, 0);
		        fixpos(yyval.node, yyvsp[0].node);
			if (cond_negative(&yyval.node->nd_cond)) {
		            yyval.node->nd_body = yyval.node->nd_else;
		            yyval.node->nd_else = 0;
			}
		    }
break;
case 17:
#line 456 "parse.y"
{
			if (yyvsp[-2].node && nd_type(yyvsp[-2].node) == NODE_BEGIN) {
			    yyval.node = NEW_WHILE(cond(yyvsp[0].node), yyvsp[-2].node->nd_body, 0);
			}
			else {
			    yyval.node = NEW_WHILE(cond(yyvsp[0].node), yyvsp[-2].node, 1);
			}
			if (cond_negative(&yyval.node->nd_cond)) {
			    nd_set_type(yyval.node, NODE_UNTIL);
			}
		    }
break;
case 18:
#line 468 "parse.y"
{
			if (yyvsp[-2].node && nd_type(yyvsp[-2].node) == NODE_BEGIN) {
			    yyval.node = NEW_UNTIL(cond(yyvsp[0].node), yyvsp[-2].node->nd_body, 0);
			}
			else {
			    yyval.node = NEW_UNTIL(cond(yyvsp[0].node), yyvsp[-2].node, 1);
			}
			if (cond_negative(&yyval.node->nd_cond)) {
			    nd_set_type(yyval.node, NODE_WHILE);
			}
		    }
break;
case 19:
#line 480 "parse.y"
{
			yyval.node = NEW_RESCUE(yyvsp[-2].node, NEW_RESBODY(0,yyvsp[0].node,0), 0);
		    }
break;
case 20:
#line 484 "parse.y"
{
			if (in_def || in_single) {
			    yyerror("BEGIN in method");
			}
			local_push(0);
		    }
break;
case 21:
#line 491 "parse.y"
{
			ruby_eval_tree_begin = block_append(ruby_eval_tree_begin,
						            NEW_PREEXE(yyvsp[-1].node));
		        local_pop();
		        yyval.node = 0;
		    }
break;
case 22:
#line 498 "parse.y"
{
			if (in_def || in_single) {
			    rb_warn("END in method; use at_exit");
			}

			yyval.node = NEW_ITER(0, NEW_POSTEXE(), yyvsp[-1].node);
		    }
break;
case 23:
#line 506 "parse.y"
{
			yyval.node = node_assign(yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 24:
#line 510 "parse.y"
{
			value_expr(yyvsp[0].node);
			yyvsp[-2].node->nd_value = (yyvsp[-2].node->nd_head) ? NEW_TO_ARY(yyvsp[0].node) : NEW_ARRAY(yyvsp[0].node);
			yyval.node = yyvsp[-2].node;
		    }
break;
case 25:
#line 516 "parse.y"
{
			value_expr(yyvsp[0].node);
			if (yyvsp[-2].node) {
			    ID vid = yyvsp[-2].node->nd_vid;
			    if (yyvsp[-1].id == tOROP) {
				yyvsp[-2].node->nd_value = yyvsp[0].node;
				yyval.node = NEW_OP_ASGN_OR(gettable(vid), yyvsp[-2].node);
				if (is_asgn_or_id(vid)) {
				    yyval.node->nd_aid = vid;
				}
			    }
			    else if (yyvsp[-1].id == tANDOP) {
				yyvsp[-2].node->nd_value = yyvsp[0].node;
				yyval.node = NEW_OP_ASGN_AND(gettable(vid), yyvsp[-2].node);
			    }
			    else {
				yyval.node = yyvsp[-2].node;
				yyval.node->nd_value = call_op(gettable(vid),yyvsp[-1].id,1,yyvsp[0].node);
			    }
			}
			else {
			    yyval.node = 0;
			}
		    }
break;
case 26:
#line 541 "parse.y"
{
                        NODE *args;

			value_expr(yyvsp[0].node);
			args = arg_concat(yyvsp[0].node, yyvsp[-3].node);
			if (yyvsp[-1].id == tOROP) {
			    yyvsp[-1].id = 0;
			}
			else if (yyvsp[-1].id == tANDOP) {
			    yyvsp[-1].id = 1;
			}
			yyval.node = NEW_OP_ASGN1(yyvsp[-5].node, yyvsp[-1].id, args);
		        fixpos(yyval.node, yyvsp[-5].node);
		    }
break;
case 27:
#line 556 "parse.y"
{
			value_expr(yyvsp[0].node);
			if (yyvsp[-1].id == tOROP) {
			    yyvsp[-1].id = 0;
			}
			else if (yyvsp[-1].id == tANDOP) {
			    yyvsp[-1].id = 1;
			}
			yyval.node = NEW_OP_ASGN2(yyvsp[-4].node, yyvsp[-2].id, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-4].node);
		    }
break;
case 28:
#line 568 "parse.y"
{
			value_expr(yyvsp[0].node);
			if (yyvsp[-1].id == tOROP) {
			    yyvsp[-1].id = 0;
			}
			else if (yyvsp[-1].id == tANDOP) {
			    yyvsp[-1].id = 1;
			}
			yyval.node = NEW_OP_ASGN2(yyvsp[-4].node, yyvsp[-2].id, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-4].node);
		    }
break;
case 29:
#line 580 "parse.y"
{
			value_expr(yyvsp[0].node);
			if (yyvsp[-1].id == tOROP) {
			    yyvsp[-1].id = 0;
			}
			else if (yyvsp[-1].id == tANDOP) {
			    yyvsp[-1].id = 1;
			}
			yyval.node = NEW_OP_ASGN2(yyvsp[-4].node, yyvsp[-2].id, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-4].node);
		    }
break;
case 30:
#line 592 "parse.y"
{
		        rb_backref_error(yyvsp[-2].node);
			yyval.node = 0;
		    }
break;
case 31:
#line 597 "parse.y"
{
			yyval.node = node_assign(yyvsp[-2].node, NEW_SVALUE(yyvsp[0].node));
		    }
break;
case 32:
#line 601 "parse.y"
{
			yyvsp[-2].node->nd_value = (yyvsp[-2].node->nd_head) ? NEW_TO_ARY(yyvsp[0].node) : NEW_ARRAY(yyvsp[0].node);
			yyval.node = yyvsp[-2].node;
		    }
break;
case 33:
#line 606 "parse.y"
{
			yyvsp[-2].node->nd_value = yyvsp[0].node;
			yyval.node = yyvsp[-2].node;
		    }
break;
case 36:
#line 615 "parse.y"
{
			yyval.node = logop(NODE_AND, yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 37:
#line 619 "parse.y"
{
			yyval.node = logop(NODE_OR, yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 38:
#line 623 "parse.y"
{
			yyval.node = NEW_NOT(cond(yyvsp[0].node));
		    }
break;
case 39:
#line 627 "parse.y"
{
			yyval.node = NEW_NOT(cond(yyvsp[0].node));
		    }
break;
case 41:
#line 634 "parse.y"
{
			value_expr(yyval.node);
			yyval.node = yyvsp[0].node;
		    }
break;
case 44:
#line 643 "parse.y"
{
			yyval.node = NEW_RETURN(ret_args(yyvsp[0].node));
		    }
break;
case 45:
#line 647 "parse.y"
{
			yyval.node = NEW_BREAK(ret_args(yyvsp[0].node));
		    }
break;
case 46:
#line 651 "parse.y"
{
			yyval.node = NEW_NEXT(ret_args(yyvsp[0].node));
		    }
break;
case 48:
#line 658 "parse.y"
{
			yyval.node = new_call(yyvsp[-3].node, yyvsp[-1].id, yyvsp[0].node);
		    }
break;
case 49:
#line 662 "parse.y"
{
			yyval.node = new_call(yyvsp[-3].node, yyvsp[-1].id, yyvsp[0].node);
		    }
break;
case 50:
#line 668 "parse.y"
{
			yyval.vars = dyna_push();
			yyvsp[0].num = ruby_sourceline;
		    }
break;
case 51:
#line 672 "parse.y"
{yyval.vars = ruby_dyna_vars;}
break;
case 52:
#line 675 "parse.y"
{
			yyval.node = NEW_ITER(yyvsp[-3].node, 0, dyna_init(yyvsp[-1].node, yyvsp[-2].vars));
			nd_set_line(yyval.node, yyvsp[-5].num);
			dyna_pop(yyvsp[-4].vars);
		    }
break;
case 53:
#line 683 "parse.y"
{
			yyval.node = new_fcall(yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[0].node);
		   }
break;
case 54:
#line 688 "parse.y"
{
			yyval.node = new_fcall(yyvsp[-2].id, yyvsp[-1].node);
			if (yyvsp[0].node) {
			    if (nd_type(yyval.node) == NODE_BLOCK_PASS) {
				rb_compile_error("both block arg and actual block given");
			    }
			    yyvsp[0].node->nd_iter = yyval.node;
			    yyval.node = yyvsp[0].node;
			}
		        fixpos(yyval.node, yyvsp[-1].node);
		   }
break;
case 55:
#line 700 "parse.y"
{
			yyval.node = new_call(yyvsp[-3].node, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-3].node);
		    }
break;
case 56:
#line 705 "parse.y"
{
			yyval.node = new_call(yyvsp[-4].node, yyvsp[-2].id, yyvsp[-1].node);
			if (yyvsp[0].node) {
			    if (nd_type(yyval.node) == NODE_BLOCK_PASS) {
				rb_compile_error("both block arg and actual block given");
			    }
			    yyvsp[0].node->nd_iter = yyval.node;
			    yyval.node = yyvsp[0].node;
			}
		        fixpos(yyval.node, yyvsp[-4].node);
		   }
break;
case 57:
#line 717 "parse.y"
{
			yyval.node = new_call(yyvsp[-3].node, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-3].node);
		    }
break;
case 58:
#line 722 "parse.y"
{
			yyval.node = new_call(yyvsp[-4].node, yyvsp[-2].id, yyvsp[-1].node);
			if (yyvsp[0].node) {
			    if (nd_type(yyval.node) == NODE_BLOCK_PASS) {
				rb_compile_error("both block arg and actual block given");
			    }
			    yyvsp[0].node->nd_iter = yyval.node;
			    yyval.node = yyvsp[0].node;
			}
		        fixpos(yyval.node, yyvsp[-4].node);
		   }
break;
case 59:
#line 734 "parse.y"
{
			yyval.node = new_super(yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[0].node);
		    }
break;
case 60:
#line 739 "parse.y"
{
			yyval.node = new_yield(yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[0].node);
		    }
break;
case 62:
#line 747 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 64:
#line 754 "parse.y"
{
			yyval.node = NEW_MASGN(NEW_LIST(yyvsp[-1].node), 0);
		    }
break;
case 65:
#line 760 "parse.y"
{
			yyval.node = NEW_MASGN(yyvsp[0].node, 0);
		    }
break;
case 66:
#line 764 "parse.y"
{
			yyval.node = NEW_MASGN(list_append(yyvsp[-1].node,yyvsp[0].node), 0);
		    }
break;
case 67:
#line 768 "parse.y"
{
			yyval.node = NEW_MASGN(yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 68:
#line 772 "parse.y"
{
			yyval.node = NEW_MASGN(yyvsp[-1].node, -1);
		    }
break;
case 69:
#line 776 "parse.y"
{
			yyval.node = NEW_MASGN(0, yyvsp[0].node);
		    }
break;
case 70:
#line 780 "parse.y"
{
			yyval.node = NEW_MASGN(0, -1);
		    }
break;
case 72:
#line 787 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 73:
#line 793 "parse.y"
{
			yyval.node = NEW_LIST(yyvsp[-1].node);
		    }
break;
case 74:
#line 797 "parse.y"
{
			yyval.node = list_append(yyvsp[-2].node, yyvsp[-1].node);
		    }
break;
case 75:
#line 803 "parse.y"
{
			yyval.node = assignable(yyvsp[0].id, 0);
		    }
break;
case 76:
#line 807 "parse.y"
{
			yyval.node = aryset(yyvsp[-3].node, yyvsp[-1].node);
		    }
break;
case 77:
#line 811 "parse.y"
{
			yyval.node = attrset(yyvsp[-2].node, yyvsp[0].id);
		    }
break;
case 78:
#line 815 "parse.y"
{
			yyval.node = attrset(yyvsp[-2].node, yyvsp[0].id);
		    }
break;
case 79:
#line 819 "parse.y"
{
			yyval.node = attrset(yyvsp[-2].node, yyvsp[0].id);
		    }
break;
case 80:
#line 823 "parse.y"
{
			if (in_def || in_single)
			    yyerror("dynamic constant assignment");
			yyval.node = NEW_CDECL(0, 0, NEW_COLON2(yyvsp[-2].node, yyvsp[0].id));
		    }
break;
case 81:
#line 829 "parse.y"
{
			if (in_def || in_single)
			    yyerror("dynamic constant assignment");
			yyval.node = NEW_CDECL(0, 0, NEW_COLON3(yyvsp[0].id));
		    }
break;
case 82:
#line 835 "parse.y"
{
		        rb_backref_error(yyvsp[0].node);
			yyval.node = 0;
		    }
break;
case 83:
#line 842 "parse.y"
{
			yyval.node = assignable(yyvsp[0].id, 0);
		    }
break;
case 84:
#line 846 "parse.y"
{
			yyval.node = aryset(yyvsp[-3].node, yyvsp[-1].node);
		    }
break;
case 85:
#line 850 "parse.y"
{
			yyval.node = attrset(yyvsp[-2].node, yyvsp[0].id);
		    }
break;
case 86:
#line 854 "parse.y"
{
			yyval.node = attrset(yyvsp[-2].node, yyvsp[0].id);
		    }
break;
case 87:
#line 858 "parse.y"
{
			yyval.node = attrset(yyvsp[-2].node, yyvsp[0].id);
		    }
break;
case 88:
#line 862 "parse.y"
{
			if (in_def || in_single)
			    yyerror("dynamic constant assignment");
			yyval.node = NEW_CDECL(0, 0, NEW_COLON2(yyvsp[-2].node, yyvsp[0].id));
		    }
break;
case 89:
#line 868 "parse.y"
{
			if (in_def || in_single)
			    yyerror("dynamic constant assignment");
			yyval.node = NEW_CDECL(0, 0, NEW_COLON3(yyvsp[0].id));
		    }
break;
case 90:
#line 874 "parse.y"
{
		        rb_backref_error(yyvsp[0].node);
			yyval.node = 0;
		    }
break;
case 91:
#line 881 "parse.y"
{
			yyerror("class/module name must be CONSTANT");
		    }
break;
case 93:
#line 888 "parse.y"
{
			yyval.node = NEW_COLON3(yyvsp[0].id);
		    }
break;
case 94:
#line 892 "parse.y"
{
			yyval.node = NEW_COLON2(0, yyval.node);
		    }
break;
case 95:
#line 896 "parse.y"
{
			yyval.node = NEW_COLON2(yyvsp[-2].node, yyvsp[0].id);
		    }
break;
case 99:
#line 905 "parse.y"
{
			lex_state = EXPR_END;
			yyval.id = yyvsp[0].id;
		    }
break;
case 100:
#line 910 "parse.y"
{
			lex_state = EXPR_END;
			yyval.id = yyvsp[0].id;
		    }
break;
case 103:
#line 921 "parse.y"
{
			yyval.node = NEW_LIT(ID2SYM(yyvsp[0].id));
		    }
break;
case 105:
#line 928 "parse.y"
{
			yyval.node = NEW_UNDEF(yyvsp[0].node);
		    }
break;
case 106:
#line 931 "parse.y"
{lex_state = EXPR_FNAME;}
break;
case 107:
#line 932 "parse.y"
{
			yyval.node = block_append(yyvsp[-3].node, NEW_UNDEF(yyvsp[0].node));
		    }
break;
case 108:
#line 937 "parse.y"
{ yyval.id = '|'; }
break;
case 109:
#line 938 "parse.y"
{ yyval.id = '^'; }
break;
case 110:
#line 939 "parse.y"
{ yyval.id = '&'; }
break;
case 111:
#line 940 "parse.y"
{ yyval.id = tCMP; }
break;
case 112:
#line 941 "parse.y"
{ yyval.id = tEQ; }
break;
case 113:
#line 942 "parse.y"
{ yyval.id = tEQQ; }
break;
case 114:
#line 943 "parse.y"
{ yyval.id = tMATCH; }
break;
case 115:
#line 944 "parse.y"
{ yyval.id = '>'; }
break;
case 116:
#line 945 "parse.y"
{ yyval.id = tGEQ; }
break;
case 117:
#line 946 "parse.y"
{ yyval.id = '<'; }
break;
case 118:
#line 947 "parse.y"
{ yyval.id = tLEQ; }
break;
case 119:
#line 948 "parse.y"
{ yyval.id = tLSHFT; }
break;
case 120:
#line 949 "parse.y"
{ yyval.id = tRSHFT; }
break;
case 121:
#line 950 "parse.y"
{ yyval.id = '+'; }
break;
case 122:
#line 951 "parse.y"
{ yyval.id = '-'; }
break;
case 123:
#line 952 "parse.y"
{ yyval.id = '*'; }
break;
case 124:
#line 953 "parse.y"
{ yyval.id = '*'; }
break;
case 125:
#line 954 "parse.y"
{ yyval.id = '/'; }
break;
case 126:
#line 955 "parse.y"
{ yyval.id = '%'; }
break;
case 127:
#line 956 "parse.y"
{ yyval.id = tPOW; }
break;
case 128:
#line 957 "parse.y"
{ yyval.id = '~'; }
break;
case 129:
#line 958 "parse.y"
{ yyval.id = tUPLUS; }
break;
case 130:
#line 959 "parse.y"
{ yyval.id = tUMINUS; }
break;
case 131:
#line 960 "parse.y"
{ yyval.id = tAREF; }
break;
case 132:
#line 961 "parse.y"
{ yyval.id = tASET; }
break;
case 133:
#line 962 "parse.y"
{ yyval.id = '`'; }
break;
case 174:
#line 975 "parse.y"
{
			yyval.node = node_assign(yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 175:
#line 979 "parse.y"
{
			yyval.node = node_assign(yyvsp[-4].node, NEW_RESCUE(yyvsp[-2].node, NEW_RESBODY(0,yyvsp[0].node,0), 0));
		    }
break;
case 176:
#line 983 "parse.y"
{
			value_expr(yyvsp[0].node);
			if (yyvsp[-2].node) {
			    ID vid = yyvsp[-2].node->nd_vid;
			    if (yyvsp[-1].id == tOROP) {
				yyvsp[-2].node->nd_value = yyvsp[0].node;
				yyval.node = NEW_OP_ASGN_OR(gettable(vid), yyvsp[-2].node);
				if (is_asgn_or_id(vid)) {
				    yyval.node->nd_aid = vid;
				}
			    }
			    else if (yyvsp[-1].id == tANDOP) {
				yyvsp[-2].node->nd_value = yyvsp[0].node;
				yyval.node = NEW_OP_ASGN_AND(gettable(vid), yyvsp[-2].node);
			    }
			    else {
				yyval.node = yyvsp[-2].node;
				yyval.node->nd_value = call_op(gettable(vid),yyvsp[-1].id,1,yyvsp[0].node);
			    }
			}
			else {
			    yyval.node = 0;
			}
		    }
break;
case 177:
#line 1008 "parse.y"
{
                        NODE *args;

			value_expr(yyvsp[0].node);
			args = arg_concat(yyvsp[0].node, yyvsp[-3].node);
			if (yyvsp[-1].id == tOROP) {
			    yyvsp[-1].id = 0;
			}
			else if (yyvsp[-1].id == tANDOP) {
			    yyvsp[-1].id = 1;
			}
			yyval.node = NEW_OP_ASGN1(yyvsp[-5].node, yyvsp[-1].id, args);
		        fixpos(yyval.node, yyvsp[-5].node);
		    }
break;
case 178:
#line 1023 "parse.y"
{
			value_expr(yyvsp[0].node);
			if (yyvsp[-1].id == tOROP) {
			    yyvsp[-1].id = 0;
			}
			else if (yyvsp[-1].id == tANDOP) {
			    yyvsp[-1].id = 1;
			}
			yyval.node = NEW_OP_ASGN2(yyvsp[-4].node, yyvsp[-2].id, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-4].node);
		    }
break;
case 179:
#line 1035 "parse.y"
{
			value_expr(yyvsp[0].node);
			if (yyvsp[-1].id == tOROP) {
			    yyvsp[-1].id = 0;
			}
			else if (yyvsp[-1].id == tANDOP) {
			    yyvsp[-1].id = 1;
			}
			yyval.node = NEW_OP_ASGN2(yyvsp[-4].node, yyvsp[-2].id, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-4].node);
		    }
break;
case 180:
#line 1047 "parse.y"
{
			value_expr(yyvsp[0].node);
			if (yyvsp[-1].id == tOROP) {
			    yyvsp[-1].id = 0;
			}
			else if (yyvsp[-1].id == tANDOP) {
			    yyvsp[-1].id = 1;
			}
			yyval.node = NEW_OP_ASGN2(yyvsp[-4].node, yyvsp[-2].id, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-4].node);
		    }
break;
case 181:
#line 1059 "parse.y"
{
			yyerror("constant re-assignment");
			yyval.node = 0;
		    }
break;
case 182:
#line 1064 "parse.y"
{
			yyerror("constant re-assignment");
			yyval.node = 0;
		    }
break;
case 183:
#line 1069 "parse.y"
{
		        rb_backref_error(yyvsp[-2].node);
			yyval.node = 0;
		    }
break;
case 184:
#line 1074 "parse.y"
{
			value_expr(yyvsp[-2].node);
			value_expr(yyvsp[0].node);
			if (nd_type(yyvsp[-2].node) == NODE_LIT && FIXNUM_P(yyvsp[-2].node->nd_lit) &&
			    nd_type(yyvsp[0].node) == NODE_LIT && FIXNUM_P(yyvsp[0].node->nd_lit)) {
			    yyvsp[-2].node->nd_lit = rb_range_new(yyvsp[-2].node->nd_lit, yyvsp[0].node->nd_lit, Qfalse);
			    yyval.node = yyvsp[-2].node;
			}
			else {
			    yyval.node = NEW_DOT2(yyvsp[-2].node, yyvsp[0].node);
			}
		    }
break;
case 185:
#line 1087 "parse.y"
{
			value_expr(yyvsp[-2].node);
			value_expr(yyvsp[0].node);
			if (nd_type(yyvsp[-2].node) == NODE_LIT && FIXNUM_P(yyvsp[-2].node->nd_lit) &&
			    nd_type(yyvsp[0].node) == NODE_LIT && FIXNUM_P(yyvsp[0].node->nd_lit)) {
			    yyvsp[-2].node->nd_lit = rb_range_new(yyvsp[-2].node->nd_lit, yyvsp[0].node->nd_lit, Qtrue);
			    yyval.node = yyvsp[-2].node;
			}
			else {
			    yyval.node = NEW_DOT3(yyvsp[-2].node, yyvsp[0].node);
			}
		    }
break;
case 186:
#line 1100 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, '+', 1, yyvsp[0].node);
		    }
break;
case 187:
#line 1104 "parse.y"
{
		        yyval.node = call_op(yyvsp[-2].node, '-', 1, yyvsp[0].node);
		    }
break;
case 188:
#line 1108 "parse.y"
{
		        yyval.node = call_op(yyvsp[-2].node, '*', 1, yyvsp[0].node);
		    }
break;
case 189:
#line 1112 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, '/', 1, yyvsp[0].node);
		    }
break;
case 190:
#line 1116 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, '%', 1, yyvsp[0].node);
		    }
break;
case 191:
#line 1120 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, tPOW, 1, yyvsp[0].node);
		    }
break;
case 192:
#line 1124 "parse.y"
{
			yyval.node = call_op(call_op(yyvsp[-2].node, tPOW, 1, yyvsp[0].node), tUMINUS, 0, 0);
		    }
break;
case 193:
#line 1128 "parse.y"
{
			yyval.node = call_op(call_op(yyvsp[-2].node, tPOW, 1, yyvsp[0].node), tUMINUS, 0, 0);
		    }
break;
case 194:
#line 1132 "parse.y"
{
			if (yyvsp[0].node && nd_type(yyvsp[0].node) == NODE_LIT) {
			    yyval.node = yyvsp[0].node;
			}
			else {
			    yyval.node = call_op(yyvsp[0].node, tUPLUS, 0, 0);
			}
		    }
break;
case 195:
#line 1141 "parse.y"
{
			yyval.node = call_op(yyvsp[0].node, tUMINUS, 0, 0);
		    }
break;
case 196:
#line 1145 "parse.y"
{
		        yyval.node = call_op(yyvsp[-2].node, '|', 1, yyvsp[0].node);
		    }
break;
case 197:
#line 1149 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, '^', 1, yyvsp[0].node);
		    }
break;
case 198:
#line 1153 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, '&', 1, yyvsp[0].node);
		    }
break;
case 199:
#line 1157 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, tCMP, 1, yyvsp[0].node);
		    }
break;
case 200:
#line 1161 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, '>', 1, yyvsp[0].node);
		    }
break;
case 201:
#line 1165 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, tGEQ, 1, yyvsp[0].node);
		    }
break;
case 202:
#line 1169 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, '<', 1, yyvsp[0].node);
		    }
break;
case 203:
#line 1173 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, tLEQ, 1, yyvsp[0].node);
		    }
break;
case 204:
#line 1177 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, tEQ, 1, yyvsp[0].node);
		    }
break;
case 205:
#line 1181 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, tEQQ, 1, yyvsp[0].node);
		    }
break;
case 206:
#line 1185 "parse.y"
{
			yyval.node = NEW_NOT(call_op(yyvsp[-2].node, tEQ, 1, yyvsp[0].node));
		    }
break;
case 207:
#line 1189 "parse.y"
{
			yyval.node = match_gen(yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 208:
#line 1193 "parse.y"
{
			yyval.node = NEW_NOT(match_gen(yyvsp[-2].node, yyvsp[0].node));
		    }
break;
case 209:
#line 1197 "parse.y"
{
			yyval.node = NEW_NOT(cond(yyvsp[0].node));
		    }
break;
case 210:
#line 1201 "parse.y"
{
			yyval.node = call_op(yyvsp[0].node, '~', 0, 0);
		    }
break;
case 211:
#line 1205 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, tLSHFT, 1, yyvsp[0].node);
		    }
break;
case 212:
#line 1209 "parse.y"
{
			yyval.node = call_op(yyvsp[-2].node, tRSHFT, 1, yyvsp[0].node);
		    }
break;
case 213:
#line 1213 "parse.y"
{
			yyval.node = logop(NODE_AND, yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 214:
#line 1217 "parse.y"
{
			yyval.node = logop(NODE_OR, yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 215:
#line 1220 "parse.y"
{in_defined = 1;}
break;
case 216:
#line 1221 "parse.y"
{
		        in_defined = 0;
			yyval.node = NEW_DEFINED(yyvsp[0].node);
		    }
break;
case 217:
#line 1226 "parse.y"
{
			yyval.node = NEW_IF(cond(yyvsp[-4].node), yyvsp[-2].node, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-4].node);
		    }
break;
case 218:
#line 1231 "parse.y"
{
			yyval.node = yyvsp[0].node;
		    }
break;
case 219:
#line 1237 "parse.y"
{
			value_expr(yyvsp[0].node);
			yyval.node = yyvsp[0].node;
		    }
break;
case 221:
#line 1245 "parse.y"
{
		        rb_warn("parenthesize argument(s) for future version");
			yyval.node = NEW_LIST(yyvsp[-1].node);
		    }
break;
case 222:
#line 1250 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 223:
#line 1254 "parse.y"
{
			value_expr(yyvsp[-1].node);
			yyval.node = arg_concat(yyvsp[-4].node, yyvsp[-1].node);
		    }
break;
case 224:
#line 1259 "parse.y"
{
			yyval.node = NEW_LIST(NEW_HASH(yyvsp[-1].node));
		    }
break;
case 225:
#line 1263 "parse.y"
{
			value_expr(yyvsp[-1].node);
			yyval.node = NEW_NEWLINE(NEW_SPLAT(yyvsp[-1].node));
		    }
break;
case 226:
#line 1270 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 227:
#line 1274 "parse.y"
{
			yyval.node = yyvsp[-2].node;
		    }
break;
case 228:
#line 1278 "parse.y"
{
		        rb_warn("parenthesize argument for future version");
			yyval.node = NEW_LIST(yyvsp[-2].node);
		    }
break;
case 229:
#line 1283 "parse.y"
{
		        rb_warn("parenthesize argument for future version");
			yyval.node = list_append(yyvsp[-4].node, yyvsp[-2].node);
		    }
break;
case 232:
#line 1294 "parse.y"
{
		        rb_warn("parenthesize argument(s) for future version");
			yyval.node = NEW_LIST(yyvsp[0].node);
		    }
break;
case 233:
#line 1299 "parse.y"
{
			yyval.node = arg_blk_pass(yyvsp[-1].node, yyvsp[0].node);
		    }
break;
case 234:
#line 1303 "parse.y"
{
			yyval.node = arg_concat(yyvsp[-4].node, yyvsp[-1].node);
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 235:
#line 1308 "parse.y"
{
			yyval.node = NEW_LIST(NEW_HASH(yyvsp[-1].node));
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 236:
#line 1313 "parse.y"
{
			yyval.node = arg_concat(NEW_LIST(NEW_HASH(yyvsp[-4].node)), yyvsp[-1].node);
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 237:
#line 1318 "parse.y"
{
			yyval.node = list_append(yyvsp[-3].node, NEW_HASH(yyvsp[-1].node));
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 238:
#line 1323 "parse.y"
{
			value_expr(yyvsp[-1].node);
			yyval.node = arg_concat(list_append(yyvsp[-6].node, NEW_HASH(yyvsp[-4].node)), yyvsp[-1].node);
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 239:
#line 1329 "parse.y"
{
			yyval.node = arg_blk_pass(NEW_SPLAT(yyvsp[-1].node), yyvsp[0].node);
		    }
break;
case 241:
#line 1336 "parse.y"
{
			yyval.node = arg_blk_pass(list_concat(NEW_LIST(yyvsp[-3].node),yyvsp[-1].node), yyvsp[0].node);
		    }
break;
case 242:
#line 1340 "parse.y"
{
                        yyval.node = arg_blk_pass(yyvsp[-2].node, yyvsp[0].node);
                    }
break;
case 243:
#line 1344 "parse.y"
{
			yyval.node = arg_concat(NEW_LIST(yyvsp[-4].node), yyvsp[-1].node);
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 244:
#line 1349 "parse.y"
{
                       yyval.node = arg_concat(list_concat(NEW_LIST(yyvsp[-6].node),yyvsp[-4].node), yyvsp[-1].node);
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 245:
#line 1354 "parse.y"
{
			yyval.node = NEW_LIST(NEW_HASH(yyvsp[-1].node));
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 246:
#line 1359 "parse.y"
{
			yyval.node = arg_concat(NEW_LIST(NEW_HASH(yyvsp[-4].node)), yyvsp[-1].node);
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 247:
#line 1364 "parse.y"
{
			yyval.node = list_append(NEW_LIST(yyvsp[-3].node), NEW_HASH(yyvsp[-1].node));
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 248:
#line 1369 "parse.y"
{
			yyval.node = list_append(list_concat(NEW_LIST(yyvsp[-5].node),yyvsp[-3].node), NEW_HASH(yyvsp[-1].node));
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 249:
#line 1374 "parse.y"
{
			yyval.node = arg_concat(list_append(NEW_LIST(yyvsp[-6].node), NEW_HASH(yyvsp[-4].node)), yyvsp[-1].node);
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 250:
#line 1379 "parse.y"
{
			yyval.node = arg_concat(list_append(list_concat(NEW_LIST(yyvsp[-8].node), yyvsp[-6].node), NEW_HASH(yyvsp[-4].node)), yyvsp[-1].node);
			yyval.node = arg_blk_pass(yyval.node, yyvsp[0].node);
		    }
break;
case 251:
#line 1384 "parse.y"
{
			yyval.node = arg_blk_pass(NEW_SPLAT(yyvsp[-1].node), yyvsp[0].node);
		    }
break;
case 253:
#line 1390 "parse.y"
{
			yyval.num = cmdarg_stack;
			CMDARG_PUSH(1);
		    }
break;
case 254:
#line 1395 "parse.y"
{
			/* CMDARG_POP() */
		        cmdarg_stack = yyvsp[-1].num;
			yyval.node = yyvsp[0].node;
		    }
break;
case 256:
#line 1403 "parse.y"
{lex_state = EXPR_ENDARG;}
break;
case 257:
#line 1404 "parse.y"
{
		        rb_warn("don't put space before argument parentheses");
			yyval.node = 0;
		    }
break;
case 258:
#line 1408 "parse.y"
{lex_state = EXPR_ENDARG;}
break;
case 259:
#line 1409 "parse.y"
{
		        rb_warn("don't put space before argument parentheses");
			yyval.node = yyvsp[-2].node;
		    }
break;
case 260:
#line 1416 "parse.y"
{
			yyval.node = NEW_BLOCK_PASS(yyvsp[0].node);
		    }
break;
case 261:
#line 1422 "parse.y"
{
			yyval.node = yyvsp[0].node;
		    }
break;
case 263:
#line 1429 "parse.y"
{
			yyval.node = NEW_LIST(yyvsp[0].node);
		    }
break;
case 264:
#line 1433 "parse.y"
{
			yyval.node = list_append(yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 265:
#line 1439 "parse.y"
{
			yyval.node = list_append(yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 266:
#line 1443 "parse.y"
{
			yyval.node = arg_concat(yyvsp[-3].node, yyvsp[0].node);
		    }
break;
case 267:
#line 1447 "parse.y"
{
			yyval.node = NEW_SPLAT(yyvsp[0].node);
		    }
break;
case 276:
#line 1461 "parse.y"
{
			yyval.node = NEW_FCALL(yyvsp[0].id, 0);
		    }
break;
case 277:
#line 1465 "parse.y"
{
			yyvsp[0].num = ruby_sourceline;
		    }
break;
case 278:
#line 1470 "parse.y"
{
			if (yyvsp[-1].node == NULL)
			    yyval.node = NEW_NIL();
			else
			    yyval.node = NEW_BEGIN(yyvsp[-1].node);
			nd_set_line(yyval.node, yyvsp[-3].num);
		    }
break;
case 279:
#line 1477 "parse.y"
{lex_state = EXPR_ENDARG;}
break;
case 280:
#line 1478 "parse.y"
{
		        rb_warning("(...) interpreted as grouped expression");
			yyval.node = yyvsp[-3].node;
		    }
break;
case 281:
#line 1483 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 282:
#line 1487 "parse.y"
{
			yyval.node = NEW_COLON2(yyvsp[-2].node, yyvsp[0].id);
		    }
break;
case 283:
#line 1491 "parse.y"
{
			yyval.node = NEW_COLON3(yyvsp[0].id);
		    }
break;
case 284:
#line 1495 "parse.y"
{
			if (yyvsp[-3].node && nd_type(yyvsp[-3].node) == NODE_SELF)
			    yyval.node = NEW_FCALL(tAREF, yyvsp[-1].node);
			else
			    yyval.node = NEW_CALL(yyvsp[-3].node, tAREF, yyvsp[-1].node);
			fixpos(yyval.node, yyvsp[-3].node);
		    }
break;
case 285:
#line 1503 "parse.y"
{
		        if (yyvsp[-1].node == 0) {
			    yyval.node = NEW_ZARRAY(); /* zero length array*/
			}
			else {
			    yyval.node = yyvsp[-1].node;
			}
		    }
break;
case 286:
#line 1512 "parse.y"
{
			yyval.node = NEW_HASH(yyvsp[-1].node);
		    }
break;
case 287:
#line 1516 "parse.y"
{
			yyval.node = NEW_RETURN(0);
		    }
break;
case 288:
#line 1520 "parse.y"
{
			yyval.node = new_yield(yyvsp[-1].node);
		    }
break;
case 289:
#line 1524 "parse.y"
{
			yyval.node = NEW_YIELD(0, Qfalse);
		    }
break;
case 290:
#line 1528 "parse.y"
{
			yyval.node = NEW_YIELD(0, Qfalse);
		    }
break;
case 291:
#line 1531 "parse.y"
{in_defined = 1;}
break;
case 292:
#line 1532 "parse.y"
{
		        in_defined = 0;
			yyval.node = NEW_DEFINED(yyvsp[-1].node);
		    }
break;
case 293:
#line 1537 "parse.y"
{
			yyvsp[0].node->nd_iter = NEW_FCALL(yyvsp[-1].id, 0);
			yyval.node = yyvsp[0].node;
			fixpos(yyvsp[0].node->nd_iter, yyvsp[0].node);
		    }
break;
case 295:
#line 1544 "parse.y"
{
			if (yyvsp[-1].node && nd_type(yyvsp[-1].node) == NODE_BLOCK_PASS) {
			    rb_compile_error("both block arg and actual block given");
			}
			yyvsp[0].node->nd_iter = yyvsp[-1].node;
			yyval.node = yyvsp[0].node;
		        fixpos(yyval.node, yyvsp[-1].node);
		    }
break;
case 296:
#line 1556 "parse.y"
{
			yyval.node = NEW_IF(cond(yyvsp[-4].node), yyvsp[-2].node, yyvsp[-1].node);
		        fixpos(yyval.node, yyvsp[-4].node);
			if (cond_negative(&yyval.node->nd_cond)) {
		            NODE *tmp = yyval.node->nd_body;
		            yyval.node->nd_body = yyval.node->nd_else;
		            yyval.node->nd_else = tmp;
			}
		    }
break;
case 297:
#line 1569 "parse.y"
{
			yyval.node = NEW_UNLESS(cond(yyvsp[-4].node), yyvsp[-2].node, yyvsp[-1].node);
		        fixpos(yyval.node, yyvsp[-4].node);
			if (cond_negative(&yyval.node->nd_cond)) {
		            NODE *tmp = yyval.node->nd_body;
		            yyval.node->nd_body = yyval.node->nd_else;
		            yyval.node->nd_else = tmp;
			}
		    }
break;
case 298:
#line 1578 "parse.y"
{COND_PUSH(1);}
break;
case 299:
#line 1578 "parse.y"
{COND_POP();}
break;
case 300:
#line 1581 "parse.y"
{
			yyval.node = NEW_WHILE(cond(yyvsp[-4].node), yyvsp[-1].node, 1);
		        fixpos(yyval.node, yyvsp[-4].node);
			if (cond_negative(&yyval.node->nd_cond)) {
			    nd_set_type(yyval.node, NODE_UNTIL);
			}
		    }
break;
case 301:
#line 1588 "parse.y"
{COND_PUSH(1);}
break;
case 302:
#line 1588 "parse.y"
{COND_POP();}
break;
case 303:
#line 1591 "parse.y"
{
			yyval.node = NEW_UNTIL(cond(yyvsp[-4].node), yyvsp[-1].node, 1);
		        fixpos(yyval.node, yyvsp[-4].node);
			if (cond_negative(&yyval.node->nd_cond)) {
			    nd_set_type(yyval.node, NODE_WHILE);
			}
		    }
break;
case 304:
#line 1601 "parse.y"
{
			yyval.node = NEW_CASE(yyvsp[-3].node, yyvsp[-1].node);
		        fixpos(yyval.node, yyvsp[-3].node);
		    }
break;
case 305:
#line 1606 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 306:
#line 1610 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 307:
#line 1613 "parse.y"
{COND_PUSH(1);}
break;
case 308:
#line 1613 "parse.y"
{COND_POP();}
break;
case 309:
#line 1616 "parse.y"
{
			yyval.node = NEW_FOR(yyvsp[-7].node, yyvsp[-4].node, yyvsp[-1].node);
		        fixpos(yyval.node, yyvsp[-7].node);
		    }
break;
case 310:
#line 1621 "parse.y"
{
			if (in_def || in_single)
			    yyerror("class definition in method body");
			class_nest++;
			local_push(0);
		        yyval.num = ruby_sourceline;
		    }
break;
case 311:
#line 1630 "parse.y"
{
		        yyval.node = NEW_CLASS(yyvsp[-4].node, yyvsp[-1].node, yyvsp[-3].node);
		        nd_set_line(yyval.node, yyvsp[-2].num);
		        local_pop();
			class_nest--;
		    }
break;
case 312:
#line 1637 "parse.y"
{
			yyval.num = in_def;
		        in_def = 0;
		    }
break;
case 313:
#line 1642 "parse.y"
{
		        yyval.num = in_single;
		        in_single = 0;
			class_nest++;
			local_push(0);
		    }
break;
case 314:
#line 1650 "parse.y"
{
		        yyval.node = NEW_SCLASS(yyvsp[-5].node, yyvsp[-1].node);
		        fixpos(yyval.node, yyvsp[-5].node);
		        local_pop();
			class_nest--;
		        in_def = yyvsp[-4].num;
		        in_single = yyvsp[-2].num;
		    }
break;
case 315:
#line 1659 "parse.y"
{
			if (in_def || in_single)
			    yyerror("module definition in method body");
			class_nest++;
			local_push(0);
		        yyval.num = ruby_sourceline;
		    }
break;
case 316:
#line 1668 "parse.y"
{
		        yyval.node = NEW_MODULE(yyvsp[-3].node, yyvsp[-1].node);
		        nd_set_line(yyval.node, yyvsp[-2].num);
		        local_pop();
			class_nest--;
		    }
break;
case 317:
#line 1675 "parse.y"
{
			yyval.id = cur_mid;
			cur_mid = yyvsp[0].id;
			in_def++;
			local_push(0);
		    }
break;
case 318:
#line 1684 "parse.y"
{
			if (!yyvsp[-1].node) yyvsp[-1].node = NEW_NIL();
			yyval.node = NEW_DEFN(yyvsp[-4].id, yyvsp[-2].node, yyvsp[-1].node, NOEX_PRIVATE);
		        fixpos(yyval.node, yyvsp[-2].node);
		        local_pop();
			in_def--;
			cur_mid = yyvsp[-3].id;
		    }
break;
case 319:
#line 1692 "parse.y"
{lex_state = EXPR_FNAME;}
break;
case 320:
#line 1693 "parse.y"
{
			in_single++;
			local_push(0);
		        lex_state = EXPR_END; /* force for args */
		    }
break;
case 321:
#line 1701 "parse.y"
{
			yyval.node = NEW_DEFS(yyvsp[-7].node, yyvsp[-4].id, yyvsp[-2].node, yyvsp[-1].node);
		        fixpos(yyval.node, yyvsp[-7].node);
		        local_pop();
			in_single--;
		    }
break;
case 322:
#line 1708 "parse.y"
{
			yyval.node = NEW_BREAK(0);
		    }
break;
case 323:
#line 1712 "parse.y"
{
			yyval.node = NEW_NEXT(0);
		    }
break;
case 324:
#line 1716 "parse.y"
{
			yyval.node = NEW_REDO();
		    }
break;
case 325:
#line 1720 "parse.y"
{
			yyval.node = NEW_RETRY();
		    }
break;
case 326:
#line 1726 "parse.y"
{
			value_expr(yyvsp[0].node);
			yyval.node = yyvsp[0].node;
		    }
break;
case 335:
#line 1747 "parse.y"
{
			yyval.node = NEW_IF(cond(yyvsp[-3].node), yyvsp[-1].node, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-3].node);
		    }
break;
case 337:
#line 1755 "parse.y"
{
			yyval.node = yyvsp[0].node;
		    }
break;
case 341:
#line 1766 "parse.y"
{
			yyval.node = (NODE*)1;
		    }
break;
case 342:
#line 1770 "parse.y"
{
			yyval.node = (NODE*)1;
		    }
break;
case 343:
#line 1774 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 344:
#line 1780 "parse.y"
{
		        yyval.vars = dyna_push();
			yyvsp[0].num = ruby_sourceline;
		    }
break;
case 345:
#line 1784 "parse.y"
{yyval.vars = ruby_dyna_vars;}
break;
case 346:
#line 1787 "parse.y"
{
			yyval.node = NEW_ITER(yyvsp[-3].node, 0, dyna_init(yyvsp[-1].node, yyvsp[-2].vars));
			nd_set_line(yyval.node, yyvsp[-5].num);
			dyna_pop(yyvsp[-4].vars);
		    }
break;
case 347:
#line 1795 "parse.y"
{
			if (yyvsp[-1].node && nd_type(yyvsp[-1].node) == NODE_BLOCK_PASS) {
			    rb_compile_error("both block arg and actual block given");
			}
			yyvsp[0].node->nd_iter = yyvsp[-1].node;
			yyval.node = yyvsp[0].node;
		        fixpos(yyval.node, yyvsp[-1].node);
		    }
break;
case 348:
#line 1804 "parse.y"
{
			yyval.node = new_call(yyvsp[-3].node, yyvsp[-1].id, yyvsp[0].node);
		    }
break;
case 349:
#line 1808 "parse.y"
{
			yyval.node = new_call(yyvsp[-3].node, yyvsp[-1].id, yyvsp[0].node);
		    }
break;
case 350:
#line 1814 "parse.y"
{
			yyval.node = new_fcall(yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[0].node);
		    }
break;
case 351:
#line 1819 "parse.y"
{
			yyval.node = new_call(yyvsp[-3].node, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-3].node);
		    }
break;
case 352:
#line 1824 "parse.y"
{
			yyval.node = new_call(yyvsp[-3].node, yyvsp[-1].id, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-3].node);
		    }
break;
case 353:
#line 1829 "parse.y"
{
			yyval.node = new_call(yyvsp[-2].node, yyvsp[0].id, 0);
		    }
break;
case 354:
#line 1833 "parse.y"
{
			yyval.node = new_super(yyvsp[0].node);
		    }
break;
case 355:
#line 1837 "parse.y"
{
			yyval.node = NEW_ZSUPER();
		    }
break;
case 356:
#line 1843 "parse.y"
{
		        yyval.vars = dyna_push();
			yyvsp[0].num = ruby_sourceline;
		    }
break;
case 357:
#line 1847 "parse.y"
{yyval.vars = ruby_dyna_vars;}
break;
case 358:
#line 1849 "parse.y"
{
			yyval.node = NEW_ITER(yyvsp[-3].node, 0, dyna_init(yyvsp[-1].node, yyvsp[-2].vars));
			nd_set_line(yyval.node, yyvsp[-5].num);
			dyna_pop(yyvsp[-4].vars);
		    }
break;
case 359:
#line 1855 "parse.y"
{
		        yyval.vars = dyna_push();
			yyvsp[0].num = ruby_sourceline;
		    }
break;
case 360:
#line 1859 "parse.y"
{yyval.vars = ruby_dyna_vars;}
break;
case 361:
#line 1861 "parse.y"
{
			yyval.node = NEW_ITER(yyvsp[-3].node, 0, dyna_init(yyvsp[-1].node, yyvsp[-2].vars));
			nd_set_line(yyval.node, yyvsp[-5].num);
			dyna_pop(yyvsp[-4].vars);
		    }
break;
case 362:
#line 1871 "parse.y"
{
			yyval.node = NEW_WHEN(yyvsp[-3].node, yyvsp[-1].node, yyvsp[0].node);
		    }
break;
case 364:
#line 1877 "parse.y"
{
			yyval.node = list_append(yyvsp[-3].node, NEW_WHEN(yyvsp[0].node, 0, 0));
		    }
break;
case 365:
#line 1881 "parse.y"
{
			yyval.node = NEW_LIST(NEW_WHEN(yyvsp[0].node, 0, 0));
		    }
break;
case 368:
#line 1893 "parse.y"
{
		        if (yyvsp[-3].node) {
		            yyvsp[-3].node = node_assign(yyvsp[-3].node, NEW_GVAR(rb_intern("$!")));
			    yyvsp[-1].node = block_append(yyvsp[-3].node, yyvsp[-1].node);
			}
			yyval.node = NEW_RESBODY(yyvsp[-4].node, yyvsp[-1].node, yyvsp[0].node);
		        fixpos(yyval.node, yyvsp[-4].node?yyvsp[-4].node:yyvsp[-1].node);
		    }
break;
case 370:
#line 1905 "parse.y"
{
			yyval.node = NEW_LIST(yyvsp[0].node);
		    }
break;
case 373:
#line 1913 "parse.y"
{
			yyval.node = yyvsp[0].node;
		    }
break;
case 375:
#line 1920 "parse.y"
{
			if (yyvsp[0].node)
			    yyval.node = yyvsp[0].node;
			else
			    /* place holder */
			    yyval.node = NEW_NIL();
		    }
break;
case 378:
#line 1932 "parse.y"
{
			yyval.node = NEW_LIT(ID2SYM(yyvsp[0].id));
		    }
break;
case 380:
#line 1939 "parse.y"
{
			NODE *node = yyvsp[0].node;
			if (!node) {
			    node = NEW_STR(rb_str_new(0, 0));
			}
			else {
			    node = evstr2dstr(node);
			}
			yyval.node = node;
		    }
break;
case 382:
#line 1953 "parse.y"
{
			yyval.node = literal_concat(yyvsp[-1].node, yyvsp[0].node);
		    }
break;
case 383:
#line 1959 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 384:
#line 1965 "parse.y"
{
			NODE *node = yyvsp[-1].node;
			if (!node) {
			    node = NEW_XSTR(rb_str_new(0, 0));
			}
			else {
			    switch (nd_type(node)) {
			      case NODE_STR:
				nd_set_type(node, NODE_XSTR);
				break;
			      case NODE_DSTR:
				nd_set_type(node, NODE_DXSTR);
				break;
			      default:
				node = NEW_NODE(NODE_DXSTR, rb_str_new(0, 0), 1, NEW_LIST(node));
				break;
			    }
			}
			yyval.node = node;
		    }
break;
case 385:
#line 1988 "parse.y"
{
			int options = yyvsp[0].num;
			NODE *node = yyvsp[-1].node;
			if (!node) {
			    node = NEW_LIT(rb_reg_new("", 0, options & ~RE_OPTION_ONCE));
			}
			else switch (nd_type(node)) {
			  case NODE_STR:
			    {
				VALUE src = node->nd_lit;
				nd_set_type(node, NODE_LIT);
				node->nd_lit = rb_reg_new(RSTRING(src)->ptr,
							  RSTRING(src)->len,
							  options & ~RE_OPTION_ONCE);
			    }
			    break;
			  default:
			    node = NEW_NODE(NODE_DSTR, rb_str_new(0, 0), 1, NEW_LIST(node));
			  case NODE_DSTR:
			    if (options & RE_OPTION_ONCE) {
				nd_set_type(node, NODE_DREGX_ONCE);
			    }
			    else {
				nd_set_type(node, NODE_DREGX);
			    }
			    node->nd_cflag = options & ~RE_OPTION_ONCE;
			    break;
			}
			yyval.node = node;
		    }
break;
case 386:
#line 2021 "parse.y"
{
			yyval.node = NEW_ZARRAY();
		    }
break;
case 387:
#line 2025 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 388:
#line 2031 "parse.y"
{
			yyval.node = 0;
		    }
break;
case 389:
#line 2035 "parse.y"
{
			yyval.node = list_append(yyvsp[-2].node, evstr2dstr(yyvsp[-1].node));
		    }
break;
case 391:
#line 2042 "parse.y"
{
			yyval.node = literal_concat(yyvsp[-1].node, yyvsp[0].node);
		    }
break;
case 392:
#line 2048 "parse.y"
{
			yyval.node = NEW_ZARRAY();
		    }
break;
case 393:
#line 2052 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 394:
#line 2058 "parse.y"
{
			yyval.node = 0;
		    }
break;
case 395:
#line 2062 "parse.y"
{
			yyval.node = list_append(yyvsp[-2].node, yyvsp[-1].node);
		    }
break;
case 396:
#line 2068 "parse.y"
{
			yyval.node = 0;
		    }
break;
case 397:
#line 2072 "parse.y"
{
			yyval.node = literal_concat(yyvsp[-1].node, yyvsp[0].node);
		    }
break;
case 398:
#line 2078 "parse.y"
{
			yyval.node = 0;
		    }
break;
case 399:
#line 2082 "parse.y"
{
			yyval.node = literal_concat(yyvsp[-1].node, yyvsp[0].node);
		    }
break;
case 401:
#line 2089 "parse.y"
{
			yyval.node = lex_strterm;
			lex_strterm = 0;
			lex_state = EXPR_BEG;
		    }
break;
case 402:
#line 2095 "parse.y"
{
			lex_strterm = yyvsp[-1].node;
		        yyval.node = NEW_EVSTR(yyvsp[0].node);
		    }
break;
case 403:
#line 2100 "parse.y"
{
			yyval.node = lex_strterm;
			lex_strterm = 0;
			lex_state = EXPR_BEG;
			COND_PUSH(0);
			CMDARG_PUSH(0);
		    }
break;
case 404:
#line 2108 "parse.y"
{
			lex_strterm = yyvsp[-2].node;
			COND_LEXPOP();
			CMDARG_LEXPOP();
			if ((yyval.node = yyvsp[-1].node) && nd_type(yyval.node) == NODE_NEWLINE) {
			    yyval.node = yyval.node->nd_next;
			    rb_gc_force_recycle((VALUE)yyvsp[-1].node);
			}
			yyval.node = new_evstr(yyval.node);
		    }
break;
case 405:
#line 2120 "parse.y"
{yyval.node = NEW_GVAR(yyvsp[0].id);}
break;
case 406:
#line 2121 "parse.y"
{yyval.node = NEW_IVAR(yyvsp[0].id);}
break;
case 407:
#line 2122 "parse.y"
{yyval.node = NEW_CVAR(yyvsp[0].id);}
break;
case 409:
#line 2127 "parse.y"
{
		        lex_state = EXPR_END;
			yyval.id = yyvsp[0].id;
		    }
break;
case 414:
#line 2140 "parse.y"
{
		        lex_state = EXPR_END;
			if (!(yyval.node = yyvsp[-1].node)) {
			    yyerror("empty symbol literal");
			}
			else {
			    VALUE lit;

			    switch (nd_type(yyval.node)) {
			      case NODE_DSTR:
				nd_set_type(yyval.node, NODE_DSYM);
				break;
			      case NODE_STR:
				lit = yyval.node->nd_lit;
				if (RSTRING(lit)->len == 0) {
				    yyerror("empty symbol literal");
				    break;
				}
				if (strlen(RSTRING(lit)->ptr) == RSTRING(lit)->len) {
				    yyval.node->nd_lit = ID2SYM(rb_intern(RSTRING(yyval.node->nd_lit)->ptr));
				    nd_set_type(yyval.node, NODE_LIT);
				    break;
				}
				/* fall through */
			      default:
				yyval.node = NEW_NODE(NODE_DSYM, rb_str_new(0, 0), 1, NEW_LIST(yyval.node));
				break;
			    }
			}
		    }
break;
case 417:
#line 2175 "parse.y"
{
			yyval.node = negate_lit(yyvsp[0].node);
		    }
break;
case 418:
#line 2179 "parse.y"
{
			yyval.node = negate_lit(yyvsp[0].node);
		    }
break;
case 424:
#line 2189 "parse.y"
{yyval.id = kNIL;}
break;
case 425:
#line 2190 "parse.y"
{yyval.id = kSELF;}
break;
case 426:
#line 2191 "parse.y"
{yyval.id = kTRUE;}
break;
case 427:
#line 2192 "parse.y"
{yyval.id = kFALSE;}
break;
case 428:
#line 2193 "parse.y"
{yyval.id = k__FILE__;}
break;
case 429:
#line 2194 "parse.y"
{yyval.id = k__LINE__;}
break;
case 430:
#line 2198 "parse.y"
{
			yyval.node = gettable(yyvsp[0].id);
		    }
break;
case 431:
#line 2204 "parse.y"
{
			yyval.node = assignable(yyvsp[0].id, 0);
		    }
break;
case 434:
#line 2214 "parse.y"
{
			yyval.node = 0;
		    }
break;
case 435:
#line 2218 "parse.y"
{
			lex_state = EXPR_BEG;
		    }
break;
case 436:
#line 2222 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 437:
#line 2225 "parse.y"
{yyerrok; yyval.node = 0;}
break;
case 438:
#line 2229 "parse.y"
{
			yyval.node = yyvsp[-2].node;
			lex_state = EXPR_BEG;
		        command_start = Qtrue;
		    }
break;
case 439:
#line 2235 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 440:
#line 2241 "parse.y"
{
			yyval.node = block_append(NEW_ARGS(yyvsp[-5].num, yyvsp[-3].node, yyvsp[-1].node), yyvsp[0].node);
		    }
break;
case 441:
#line 2245 "parse.y"
{
			yyval.node = block_append(NEW_ARGS(yyvsp[-3].num, yyvsp[-1].node, 0), yyvsp[0].node);
		    }
break;
case 442:
#line 2249 "parse.y"
{
			yyval.node = block_append(NEW_ARGS(yyvsp[-3].num, 0, yyvsp[-1].node), yyvsp[0].node);
		    }
break;
case 443:
#line 2253 "parse.y"
{
			yyval.node = block_append(NEW_ARGS(yyvsp[-1].num, 0, 0), yyvsp[0].node);
		    }
break;
case 444:
#line 2257 "parse.y"
{
			yyval.node = block_append(NEW_ARGS(0, yyvsp[-3].node, yyvsp[-1].node), yyvsp[0].node);
		    }
break;
case 445:
#line 2261 "parse.y"
{
			yyval.node = block_append(NEW_ARGS(0, yyvsp[-1].node, 0), yyvsp[0].node);
		    }
break;
case 446:
#line 2265 "parse.y"
{
			yyval.node = block_append(NEW_ARGS(0, 0, yyvsp[-1].node), yyvsp[0].node);
		    }
break;
case 447:
#line 2269 "parse.y"
{
			yyval.node = block_append(NEW_ARGS(0, 0, 0), yyvsp[0].node);
		    }
break;
case 448:
#line 2273 "parse.y"
{
			yyval.node = NEW_ARGS(0, 0, 0);
		    }
break;
case 449:
#line 2279 "parse.y"
{
			yyerror("formal argument cannot be a constant");
		    }
break;
case 450:
#line 2283 "parse.y"
{
                        yyerror("formal argument cannot be an instance variable");
		    }
break;
case 451:
#line 2287 "parse.y"
{
                        yyerror("formal argument cannot be a global variable");
		    }
break;
case 452:
#line 2291 "parse.y"
{
                        yyerror("formal argument cannot be a class variable");
		    }
break;
case 453:
#line 2295 "parse.y"
{
			if (!is_local_id(yyvsp[0].id))
			    yyerror("formal argument must be local variable");
			else if (local_id(yyvsp[0].id))
			    yyerror("duplicate argument name");
			local_cnt(yyvsp[0].id);
			yyval.num = 1;
		    }
break;
case 455:
#line 2307 "parse.y"
{
			yyval.num += 1;
		    }
break;
case 456:
#line 2313 "parse.y"
{
			if (!is_local_id(yyvsp[-2].id))
			    yyerror("formal argument must be local variable");
			else if (local_id(yyvsp[-2].id))
			    yyerror("duplicate optional argument name");
			yyval.node = assignable(yyvsp[-2].id, yyvsp[0].node);
		    }
break;
case 457:
#line 2323 "parse.y"
{
			yyval.node = NEW_BLOCK(yyvsp[0].node);
			yyval.node->nd_end = yyval.node;
		    }
break;
case 458:
#line 2328 "parse.y"
{
			yyval.node = block_append(yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 461:
#line 2338 "parse.y"
{
			if (!is_local_id(yyvsp[0].id))
			    yyerror("rest argument must be local variable");
			if (dyna_in_block()) {
			    rb_dvar_push(yyvsp[0].id, Qnil);
			}
			yyval.node = assignable(yyvsp[0].id, 0);
		    }
break;
case 462:
#line 2347 "parse.y"
{
			if (dyna_in_block()) {
			    yyval.node = NEW_DASGN_CURR(internal_id(), 0);
			}
			else {
			    yyval.node = NEW_NODE(NODE_LASGN,0,0,local_append(0));
			}
		    }
break;
case 465:
#line 2362 "parse.y"
{
			if (!is_local_id(yyvsp[0].id))
			    yyerror("block argument must be local variable");
			else if (local_id(yyvsp[0].id))
			    yyerror("duplicate block argument name");
			yyval.node = NEW_BLOCK_ARG(yyvsp[0].id);
		    }
break;
case 466:
#line 2372 "parse.y"
{
			yyval.node = yyvsp[0].node;
		    }
break;
case 468:
#line 2379 "parse.y"
{
			if (yyvsp[0].node && nd_type(yyvsp[0].node) == NODE_SELF) {
			    yyval.node = NEW_SELF();
			}
			else {
			    yyval.node = yyvsp[0].node;
		            value_expr(yyval.node);
			}
		    }
break;
case 469:
#line 2388 "parse.y"
{lex_state = EXPR_BEG;}
break;
case 470:
#line 2389 "parse.y"
{
			if (yyvsp[-2].node == 0) {
			    yyerror("can't define singleton method for ().");
			}
			else {
			    switch (nd_type(yyvsp[-2].node)) {
			      case NODE_STR:
			      case NODE_DSTR:
			      case NODE_XSTR:
			      case NODE_DXSTR:
			      case NODE_DREGX:
			      case NODE_LIT:
			      case NODE_ARRAY:
			      case NODE_ZARRAY:
				yyerror("can't define singleton method for literals");
			      default:
				value_expr(yyvsp[-2].node);
				break;
			    }
			}
			yyval.node = yyvsp[-2].node;
		    }
break;
case 472:
#line 2415 "parse.y"
{
			yyval.node = yyvsp[-1].node;
		    }
break;
case 473:
#line 2419 "parse.y"
{
			if (yyvsp[-1].node->nd_alen%2 != 0) {
			    yyerror("odd number list for Hash");
			}
			yyval.node = yyvsp[-1].node;
		    }
break;
case 475:
#line 2429 "parse.y"
{
			yyval.node = list_concat(yyvsp[-2].node, yyvsp[0].node);
		    }
break;
case 476:
#line 2435 "parse.y"
{
			yyval.node = list_append(NEW_LIST(yyvsp[-2].node), yyvsp[0].node);
		    }
break;
case 496:
#line 2473 "parse.y"
{yyerrok;}
break;
case 499:
#line 2478 "parse.y"
{yyerrok;}
break;
case 500:
#line 2481 "parse.y"
{yyval.node = 0;}
break;
#line 11777 "parse.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
